com.corticon.eclipse.server.core

## Interface ICcServer

-     public interface ICcServer

  `ICcServer` client programs to initialize the Corticon Server, to manage decision services, and to invoke decision services. The Corticon Server is the entry point to a managed set of decision services called Ruleflows. Each Ruleflow has its own Corticon engine (also known as the Reactor) pool. Each Corticon engine pool is keyed by a logical decision "Service" name used to identify the target service on an incoming request. Each Corticon engine pool is associated with one and only one Ruleflow (decision service). Clients use `ICcServerFactory` to create an instance of type `ICcServer` which is used it to deploy one or more decision services using either a Corticon Deployment Descriptor file (CDD) or individually via method `addDecisionService`. Once the Corticon Server is initialized, clients can invoke `execute` methods to process requests. Various overloads of `execute` are offered to allow input via JDOM XML Documents, XML Strings or Java Business Objects.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `ICcServer.LogLevel` Log level enumeration to used control the logging level for the ICcServer instance.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `CCPROPERTY_BUILD_NUMBER` Explicit property name that is used to get the Build Number of the CcServer
    `static java.lang.String` | `CCPROPERTY_FULL_VERSION_NUMBER` Explicit property name that is used to get the Full Version Number of the CcServer
    `static java.lang.String` | `CCPROPERTY_SERVICE_RELEASE_NUMBER` Explicit property name that is used to get the Service Release Number of the CcServer
    `static java.lang.String` | `CCPROPERTY_VERSION_NUMBER` Explicit property name that is used to get the Version Number of the CcServer
    `static java.lang.String` | `DATABASE_ACCESS_NONE` Indicates that a Decision Service does not access an Enterprise database.
    `static java.lang.String` | `DATABASE_ACCESS_READ_ONLY` Indicates that a Decision Service has read only access to an Enterprise database.
    `static java.lang.String` | `DATABASE_ACCESS_READ_WRITE` Indicates that a Decision Service has read/write access to an Enterprise database.
    `static java.lang.String` | `DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES` Indicates that all entity instances in working memory, including the ones retrieved from the database are returned as part of the response.
    `static java.lang.String` | `DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES` Indicates that only entity instances that arrived as part of the incoming request and those instantiated by rules are returned as part of the response.
    `static java.lang.String` | `DECISION_SERVICE_DETAILS_TYPE_JSON`
    `static java.lang.String` | `DECISION_SERVICE_DETAILS_TYPE_XML` Property name to be used to get the desired output structure when calling getDecisionServiceDetails()
    `static java.lang.String` | `LICENSE_BATCHPROCESSING_ENABLED` Property name that is used to get the value that enables database batch processing inside a Decision Service.
    `static java.lang.String` | `LICENSE_DATE_GRANTED` Property name that is used to get the date the Server License was issued.
    `static java.lang.String` | `LICENSE_DEACTIVATE_DATE` Property name that is used to get the date when the Corticon Server expires.
    `static java.lang.String` | `LICENSE_DEACTIVATE_DATE_OVERRIDE` Property name that is used to get the value that disables license expiration.
    `static java.lang.String` | `LICENSE_EXECUTION_QUEUE_SIZE` Property name that is used to determine how many concurrent executions can occur in the CcServer
    `static java.lang.String` | `LICENSE_INCREMENT_IP` Property name that is used to get the value that sets the increment value used by IP validation.
    `static java.lang.String` | `LICENSE_IP_OVERRIDE` Property name that is used to get the value that enables IP validation.
    `static java.lang.String` | `LICENSE_LOCATION` Property name that is used to get the location of the License file on the Classpath.
    `static java.lang.String` | `LICENSE_MAX_NUMBER_OF_RULES` Property name that is used to get max number of rules that can be deployed on the Corticon Server.
    `static java.lang.String` | `LICENSE_MAX_POOLS` Property name that is used to get max number of Decision Services that can be deployed on the Corticon Server.
    `static java.lang.String` | `LICENSE_MAX_REACTORS` Property name that is used to get max number of Reactor instances that can be in each Decision Service Pool.
    `static java.lang.String` | `LICENSE_NAMED_USERS` Property name that is used to get the value that describes the named users for the license.
    `static java.lang.String` | `LICENSE_OEM_NAME` Property name that is used to get the registered name associated with the Server License.
    `static java.lang.String` | `LICENSE_SERVER_IP` Property name that is used to get the value that sets the approved IP Address of the server where the Corticon Server can run.
    `static java.lang.String` | `LICENSE_SERVER_TRANSACTION_OVERRIDE` Property name that is used to get the value that enables transaction validation.
    `static java.lang.String` | `LICENSE_SERVER_TRANSACTIONS_MAX_EXECUTIONS` Property name that is used to get the value that determines the number of executions allowed for transaction validation.
    `static java.lang.String` | `LICENSE_SERVER_TRANSACTIONS_TIME_PERIOD` Property name that is used to get the value that determines the time period for transaction validation.
    `static java.lang.String` | `LICENSE_SINGLE_EXECUTION_DB_ACCESS_ENABLED` Property name that is used to get the value that enables single database executions.
    `static java.lang.String` | `LICENSE_SINGLE_EXECUTION_ENABLED` Property name that is used to get the value that enables single non-database executions.
    `static java.lang.String` | `LOG_FILTERS_ACCEPT` Property name that is used to get or set log marker filters.
    `static java.lang.String` | `LOG_LEVEL` Property name that is used to get or set the log level.
    `static java.lang.String` | `LOG_PATH` Property name that is used to get or set the log file path.
    `static java.lang.String` | `LOG_PER_DS` Property name that is used to get or set decision service specific logging.
    `static java.lang.String` | `LOG_ROLLOVER` Property name that is used to get or set log file daily rollover behavior.
    `static java.lang.String` | `LOG_ROLLOVERS_TO_KEEP` Property name that is used to get or set the maximum number of rollover log files.
    `static java.lang.String` | `PROPERTY_ACTIVE_POOL` Property name that is used to get the active value for a Decision Service.
    `static java.lang.String` | `PROPERTY_AUTO_RELOAD` Property name that is used to get the auto reload value for a Decision Service.
    `static java.lang.String` | `PROPERTY_CURRENTLY_RUNNING_IN_BATCH_MODE` Property name that is used to get the running in batch mode value for a Decision Service.
    `static java.lang.String` | `PROPERTY_DATABASE_ACCESS_CACHING_ENABLED` Property name that is used to get the value that tells whether this Decision Service has Caching turned on
    `static java.lang.String` | `PROPERTY_DATABASE_ACCESS_MODE` Property name that is used to get the database access mode for a Decision Service.
    `static java.lang.String` | `PROPERTY_DATABASE_ACCESS_PROPERTIES` Property name that is used to get the string representation of the database access properties object for a Decision Service.
    `static java.lang.String` | `PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH` Property name that is used to get the path to the properties file that was loaded for a Decision Service
    `static java.lang.String` | `PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH_RELATIVE` Property name that is used to get the path to the properties file that was loaded for a Decision Service The path that is returned will be relative to the location of the CcServerSandbox\DoNotDelete\DecisionServices
    `static java.lang.String` | `PROPERTY_DATABASE_ACCESS_RETURN_ENTITIES_MODE` Property name that is used to get the return policy for database access executions for a Decision Service.
    `static java.lang.String` | `PROPERTY_DATASOURCE_CONFIG_FILE_CONTENTS` Property name that is used to get the string representation of the datasource configuration properties object for a Decision Service.
    `static java.lang.String` | `PROPERTY_DATASOURCE_CONFIG_FILE_PATH` Property name that is used to get the string representation of the datasource xml file object for a Decision Service.
    `static java.lang.String` | `PROPERTY_DECISION_SERVICE_DETAILS` Property name that is used to get the details of the Decision Service in a String representation of a JSONObject.
    `static java.lang.String` | `PROPERTY_DECISION_SERVICE_HAS_RULEASSETS_CHANGED` Property name that is used to check to see if any of the associated RuleAssets have changed based on their timestamp.
    `static java.lang.String` | `PROPERTY_DECISION_SERVICE_QUERY_SERVICE_LAST_LOAD` Property name that is used to determine when the Query Service was last loaded for a Decision Service.
    `static java.lang.String` | `PROPERTY_DEPENDENT_JARS` Property name that is used to set the Dependent Jars identifier.
    `static java.lang.String` | `PROPERTY_DEPLOYED_AS_TEST_DECISION_SERVICE` Property name that is used to get the boolean that signifies that the Decision Service was deployed in Test Mode.
    `static java.lang.String` | `PROPERTY_DEPLOYED_EDS` Property name that is used to determine if the deployment of the Decision Service used a .eds file instead of a .erf file.
    `static java.lang.String` | `PROPERTY_DEPLOYED_RULEFLOW` Property name that is used to determine if the deployment of the Decision Service used a .erf file instead of a .eds file.
    `static java.lang.String` | `PROPERTY_DEPLOYMENT_TIMESTAMP` Property name that is used to get the time when the Decision Service was deployed.
    `static java.lang.String` | `PROPERTY_EDS_FILE_TIMESTAMP` Property name that is used to get the time of the .eds file's timestamp
    `static java.lang.String` | `PROPERTY_EDS_HAS_WSDL` Property name that is used to get whether or not the EDS file contains a WSDL document
    `static java.lang.String` | `PROPERTY_EDS_URI` Property name that is used to get the path of the Rule Asset (.erf file, if a .eds file was deployed).
    `static java.lang.String` | `PROPERTY_EDS_URI_RELATIVE` Property name that is used to get the relative path of the deployed EDS in relation to the CcServerSandbox Directory.
    `static java.lang.String` | `PROPERTY_EFFECTIVE_END_DATE` Property name that is used to get the effective end date for a Decision Service.
    `static java.lang.String` | `PROPERTY_EFFECTIVE_START_DATE` Property name that is used to get the effective start date for a Decision Service.
    `static java.lang.String` | `PROPERTY_EXECUTION_EXECUTION_RECORDING_SERVICE_NAME` Property name that is used to get the Decision Service's execution recording service name.
    `static java.lang.String` | `PROPERTY_EXECUTION_LOCALE` Property name that is used to get the Decision Service's execution locale.
    `static java.lang.String` | `PROPERTY_EXECUTION_RECORDING_SERVICE_ENABLED` Property name that is used to determine if this Decision Service will use the default Execution Recording Service
    `static java.lang.String` | `PROPERTY_EXECUTION_RECORDING_SERVICE_NAME` Property name that is used to get the Execution Recording Serivce that is associated with the specified Decision Service
    `static java.lang.String` | `PROPERTY_EXECUTION_RESTRICT_RESPONSE_TO_RULEMESSAGES_ONLY` Property name that is used to get the Decision Service's restrict the CorticonResponse to only RuleMessages.
    `static java.lang.String` | `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO` Property name that is used to get the Decision Service's restrict Info RuleMessages.
    `static java.lang.String` | `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION` Property name that is used to get the Decision Service's restrict Violation RuleMessages.
    `static java.lang.String` | `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING` Property name that is used to get the Decision Service's restrict Warning RuleMessages.
    `static java.lang.String` | `PROPERTY_EXECUTION_TIMEZONE`
    `static java.lang.String` | `PROPERTY_INCLUDED_JARS` Property name that is used to set the Included Jars identifier.
    `static java.lang.String` | `PROPERTY_IS_DEPLOYED` Property name that is used to determine if a particular Decision Service is deployed..
    `static java.lang.String` | `PROPERTY_LAST_EXECUTION_TIMESTAMP` Property name that is used to get the timestamp of the last execution against a specific Decision Service.
    `static java.lang.String` | `PROPERTY_LOADED_FROM_CDD` Property name that is used to get the loaded from CDD value for a Decision Service.
    `static java.lang.String` | `PROPERTY_MAJOR_VERSION_NUMBER` Property name that is used to get the version number for a Decision Service.
    `static java.lang.String` | `PROPERTY_MAX_POOL_SIZE` Property name that is used to get the maximum pool size for a Decision Service.
    `static java.lang.String` | `PROPERTY_MESSAGE_STRUCTURE_TYPE` Property name that is used to get the message structure type for a Decision Service.
    `static java.lang.String` | `PROPERTY_MIN_POOL_SIZE` Property name that is used to get the minimum pool size for a Decision Service.
    `static java.lang.String` | `PROPERTY_MINOR_VERSION_NUMBER` Property name that is used to get the version number for a Decision Service.
    `static java.lang.String` | `PROPERTY_NUMBER_OF_RULES_DEPLOYED` Property name that is used to get the number of rules deployed in the Decision Service.
    `static java.lang.String` | `PROPERTY_PATH_TO_CDD` Property name that is used to get the path to CDD value for a Decision Service.
    `static java.lang.String` | `PROPERTY_REACTORS_CURRENT_STATE` Property name that is used to get a description of the current state of all the Reactors for the Decision Service
    `static java.lang.String` | `PROPERTY_REACTORS_CURRENTLY_PROCESSING` Property name that is used to get the number of reactors that are currently processing for a Decision Service.
    `static java.lang.String` | `PROPERTY_REACTORS_CURRENTLY_QUEUED` Property name that is used to get the number of reactors that are waiting in the Execution Queie
    `static java.lang.String` | `PROPERTY_REACTORS_WAITING_IN_POOL` Property name that is used to get the number of available reactors that are waiting Decision Service.
    `static java.lang.String` | `PROPERTY_RULEASSET_URI` Property name that is used to get the path of the Rule Asset (.erf file or .eds file that was deployed).
    `static java.lang.String` | `PROPERTY_RULEASSET_ZIP_FILE_TIMESTAMP` Property name that is used to get the timestamp of the unzipped Rule Asset files.
    `static java.lang.String` | `PROPERTY_RULEASSET_ZIP_FILE_URI` Property name that is used to get the location of the unzipped Rule Asset files.
    `static java.lang.String` | `PROPERTY_RULEFLOW_FILE_TIMESTAMP` Property name that is used to get the time of the .erf file's timestamp
    `static java.lang.String` | `PROPERTY_RULEFLOW_URI` Property name that is used to get the path of the Rule Asset (.erf file, if a .erf file was deployed).
    `static java.lang.String` | `PROPERTY_RULEFLOW_URI_RELATIVE` Property name that is used to get the relative path of the deployed Ruleflow in relation to the CcServerSandbox Directory.
    `static java.lang.String` | `PROPERTY_TOTAL_EXECUTION_COUNT` Property name that is used to get the total execution count for specific Decision Service.
    `static java.lang.String` | `PROPERTY_TOTAL_EXECUTION_TIME` Property name that is used to get the total execution time for specific Decision Service.
    `static java.lang.String` | `PROPERTY_VERSION_NUMBER` Property name that is used to get the version number for a Decision Service.
    `static java.lang.String` | `PROPERTY_VOCABULARY_METADATA` Property name that is used to return the vocabulary metadata for the specified Decision Service.
    `static java.lang.String` | `PROPERTY_WEB_CONSOLE_ASSET_ID` Property name that is used to set the Web Console Asset identifier.
    `static java.lang.String` | `PROPERTY_WSDL` Property name that is used to get the WSDL for the Decision Service.
    `static java.lang.String` | `PROPERTY_XML_REPORT` Property name that is used to get the XML Report for the Decision Service.
    `static java.lang.String` | `REST_HEADER_DECISION_SERVICE_EFFECTIVE_TIMESTAMP`
    `static java.lang.String` | `REST_HEADER_DECISION_SERVICE_MAJOR_VERSION`
    `static java.lang.String` | `REST_HEADER_DECISION_SERVICE_MINOR_VERSION`
    `static java.lang.String` | `REST_HEADER_DECISION_SERVICE_NAME` Constants that can be used to to pass necessary information in REST Header call.
    `static java.lang.String` | `XML_FLAT_STYLE` A style of XML message where all business object associations are captured using href's, resulting in a "flat" XML document.
    `static java.lang.String` | `XML_HIER_STYLE` A style of XML message where all business object associations are captured using embeddings, resulting in a hierarchical XML document.
    `static java.lang.String` | `XML_STYLE_AUTODETECT` The server auto-detects the style of XML message.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDecisionService(java.lang.String astrDecisionServiceName, com.corticon.eclipse.studio.rule.ruleflow.core.IRuleflowModelAPI aIRuleflowModelAPI, java.util.Properties apropDeploymentOptions)`
    `void` | `addDecisionService(java.lang.String astrDecisionServiceName, com.corticon.eclipse.studio.rule.rulesheet.core.IRulesheetModelAPI aIRulesheetModelAPI, java.util.Properties apropDeploymentOptions)`
    `void` | `addDecisionService(java.lang.String astrDecisionServiceName, java.lang.String astrRuleAssetPath, boolean abAutoReload)` Invokes `addDecisionService(astrDecisionServiceName, astrRuleAssetPath, abAutoReload, false)`
    `void` | `addDecisionService(java.lang.String astrDecisionServiceName, java.lang.String astrRuleAssetPath, boolean abAutoReload, int aiMinPoolSize, int aiMaxPoolSize, java.lang.String astrMsgStructStyle)` Invokes `addDecisionService(astrDecisionServiceName, astrRuleAssetPath, abAutoReload, aiMinPoolSize, aiMaxPoolSize, astrMsgStructStyle, false)`
    `void` | `addDecisionService(java.lang.String astrDecisionServiceName, java.lang.String astrRuleAssetPath, boolean abAutoReload, int aiMinPoolSize, int aiMaxPoolSize, java.lang.String astrMsgStructStyle, java.lang.String astrDatabaseAccessMode, java.lang.String astrDatabaseAccessReturnEntities, java.lang.String astrDatabaseAccessPropertiesPath)` Deploys a Ruleflow as a Decision Service named `astrDecisionServiceName`.
    `void` | `addDecisionService(java.lang.String astrDecisionServiceName, java.lang.String astrRuleAssetPath, java.util.Properties apropDeploymentOptions)`
    `void` | `clearAllNonCddDecisionServices()` Clears all Decision Services and all associated Corticon Engine pools from the server.
    `java.lang.String` | `createDownloadableZipFile(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Takes the most current Rule Assets related to the Decision Service and zips them up into a .zip file, and places this file inside the CcServerSandbox.
    `int` | `createTestDecisionService(java.lang.String astrDecisionServiceName, int aiTargetMajorVersionNumber)` Invokes `createTestDecisionService(astrDecisionServiceName, aiTargetMajorVersionNumber, )`.
    `int` | `createTestDecisionService(java.lang.String astrDecisionServiceName, int aiTargetMajorVersionNumber, int aiTargetMinorVersionNumber)` Creates a new Test Decision Service from an existing Decision Service.
    `int` | `createTestDecisionServiceMinorVersion(java.lang.String astrDecisionServiceName, int aiMajorVersionNumber)` Invokes `createTestDecisionServiceMinorVersion(astrDecisionServiceName, aiTargetMajorVersionNumber, )`.
    `int` | `createTestDecisionServiceMinorVersion(java.lang.String astrDecisionServiceName, int aiMajorVersionNumber, int aiMinorVersionNumber)` Creates a new Test Decision Service from an existing Decision Service.
    `java.lang.String` | `createUniqueUploadDirectory()` Create a new temporary upload directory inside the CcServerSandbox.
    `void` | `deregisterTrackingAttribute(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrRegisteredTrackingAttribute)` Deregisters a particular attribute in Corticon Data Monitoring subsystem.
    `void` | `deregisterTrackingAttribute(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrRegisteredTrackingAttribute)` Invokes `deregisterTrackingAttribute(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute)`.
    `void` | `deregisterTrackingAttribute(java.lang.String astrDecisionServiceName, java.lang.String astrRegisteredTrackingAttribute)` Invokes `deregisterTrackingAttribute(astrDecisionServiceName, , astrRegisteredTrackingAttribute)`.
    `java.lang.String` | `downloadRuleAssetFile(java.lang.String astrFullyQualifiedPath)` Allow the user to download Rule Asset files up to the CcServer.
    `org.jdom.Document` | `execute(org.jdom.Document aCorticonRequestDoc)` Equivalent to the method `execute(String)`, except that the `CorticonRequest` & `CorticonResponse` documents are JDOM XML.
    `org.jdom.Document` | `execute(org.jdom.Document aCorticonRequestDoc, java.lang.String astrServerLocation)` Equivalent to the method `execute(String)`, except that the `CorticonRequest` & `CorticonResponse` documents are JDOM XML.
    `org.jdom.Document` | `execute(org.jdom.Document aCorticonRequestDoc, java.lang.String astrServerLocation, com.corticon.services.http.ICcServerHttpInfo aCcServerHttpInfo)` Equivalent to the method `execute(String, ICcServerHttpInfo)`, except that the `CorticonRequest` & `CorticonResponse` documents are JDOM XML.
    `org.json.JSONObject` | `execute(org.json.JSONObject ajsonObjectPayload)` Invoke a specific Decision Service by passing in a `JSONObject`.
    `org.json.JSONObject` | `execute(org.json.JSONObject ajsonObjectPayload, com.corticon.services.http.ICcServerHttpInfo aCcServerHttpInfo)` Equivalent to `execute(JSONObject)`, except for this method accepts `ICcServerHttpInfo`
    `java.lang.String` | `execute(java.lang.String astrCorticonRequest)` Invoke a specific Decision Service by passing in a `CorticonRequest` XML message in String form.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Collection acolWorkObjs)` Invoke a specific Decision Service by passing in a `Collection` of Java business objects representing `WorkDocuments`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Collection acolWorkObjs, java.util.Date adDecisionServiceEffectiveTimestamp)` Similar to `execute(String, Collection)` except that the user can specify what effective timestamp should be using using the parameter `adDecisionServiceEffectiveTimestamp`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Collection acolWorkObjs, java.util.Date adDecisionServiceEffectiveTimestamp, int aiDecisionServiceTargetMajorVersion)` Similar to `execute(String, Collection, Date)` except that the user can specify what major version number should be using for the parameter `aiDecisionServiceTargetMajorVersion`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Collection acolWorkObjs, int aiDecisionServiceTargetMajorVersion)` Similar to `execute(String, Collection)` except that the user can specify which Major Version of the Decision Service should process the request using parameter `aiDecisionServiceTargetVersion`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Collection acolWorkObjs, int aiDecisionServiceTargetMajorVersion, int aiDecisionServiceTargetMinorVersion)` Similar to `execute(String, Collection, int)` except that the user can specify which Minor Version of the Decision Service should process the request using parameter `aiDecisionServiceTargetVersion`.
    `java.lang.String` | `execute(java.lang.String astrCorticonRequest, com.corticon.services.http.ICcServerHttpInfo aCcServerHttpInfo)` Equivalent to the method `execute(String)`, except for this method accepts `ICcServerHttpInfo`
    `org.json.JSONObject` | `execute(java.lang.String astrDecisionServiceName, org.json.JSONObject ajsonObjectPayload)` Deprecated.
    `org.json.JSONObject` | `execute(java.lang.String astrDecisionServiceName, org.json.JSONObject ajsonObjectPayload, java.util.Date adDecisionServiceEffectiveTimestamp)` Deprecated.
    `org.json.JSONObject` | `execute(java.lang.String astrDecisionServiceName, org.json.JSONObject ajsonObjectPayload, java.util.Date adDecisionServiceEffectiveTimestamp, int aiDecisionServiceTargetMajorVersion)` Deprecated.
    `org.json.JSONObject` | `execute(java.lang.String astrDecisionServiceName, org.json.JSONObject ajsonObjectPayload, int aiDecisionServiceTargetMajorVersion)` Deprecated.
    `org.json.JSONObject` | `execute(java.lang.String astrDecisionServiceName, org.json.JSONObject ajsonObjectPayload, int aiDecisionServiceTargetMajorVersion, int aiDecisionServiceTargetMinorVersion)` Deprecated.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Map amapWorkObjs)` Equivalent to the method `execute(String, Collection)`, except that a `Map` is passed in instead of a `Collection`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Map amapWorkObjs, java.util.Date adDecisionServiceEffectiveTimestamp)` Equivalent to the method `execute(String, Collection, Date)`, except that a `Map` is passed in instead of a `Collection`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Map amapWorkObjs, java.util.Date adDecisionServiceEffectiveTimestamp, int aiDecisionServiceTargetMajorVersion)` Equivalent to the method `execute(String, Collection, Date, int)`, except that a `Map` is passed in instead of a `Collection`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Map acolWorkObjs, int aiDecisionServiceTargetMajorVersion)` Equivalent to the method `execute(String, Collection, int)`, except that a `Map` is passed in instead of a `Collection`.
    `ICcRuleMessages` | `execute(java.lang.String astrDecisionServiceName, java.util.Map acolWorkObjs, int aiDecisionServiceTargetMajorVersion, int aiDecisionServiceTargetMinorVersion)` Equivalent to the method `execute(String, Collection, int, int)`, except that a `Map` is passed in instead of a `Collection`.
    `org.json.JSONObject` | `getBatchExecutionDetails(java.lang.String astrBatchExecutionId)` This method will return a JSONObject that contains all the details the Batch Execution for the passed in Id.
    `java.util.List<java.lang.String>` | `getBatchExecutionIds()` This method will start a Batch Execution against a particular Decision Service based on the Batch Processing Properties outlined in the passed in JSONObject.
    `java.util.Set` | `getCcPropertyOverrideSet()` This will return the property names that are in the CcDebug.properties file inside the CcConfig.jar
    `java.lang.String` | `getCcPropertyValue(java.lang.String astrPropertyName)` Returns a `String` value of any Corticon Property that is inside the CcConfig.jar.
    `java.lang.String` | `getCcServerInfo()` Returns a `String` in XML format that describes the current state of the CcServer.
    `java.lang.String` | `getCcServerLicenseValue(java.lang.String astrPropertyName)` Returns a requested Corticon Server License value.
    `java.lang.String` | `getCompilationDirectoryPath()` Return the current directory that the Server uses to compile assets.
    `java.lang.Object` | `getDecisionServiceDetails(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrStructureType)` Returns the String object representation for the specified decision service.
    `java.lang.Object` | `getDecisionServiceDetails(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrStructureType)` Invokes `getDecisionServiceDetails(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrStructureType)`
    `java.lang.Object` | `getDecisionServiceDetails(java.lang.String astrDecisionServiceName, java.lang.String astrStructureType)` Invokes `getDecisionServiceDetails(astrDecisionServiceName, , astrStructureType)`
    `java.util.ArrayList` | `getDecisionServiceDetailsAll(java.lang.String astrStructureType)` Invokes `getDecisionServiceDetailsAll(, astrStructureType)`
    `java.util.ArrayList` | `getDecisionServiceDetailsAll(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrStructureType)` Returns the String object representation for the specified decision service.
    `java.util.ArrayList` | `getDecisionServiceDetailsAll(java.lang.String astrDecisionServiceName, java.lang.String astrStructureType)` Invokes `getDecisionServiceDetailsAll(astrDecisionServiceName, , astrStructureType)`
    `java.lang.String` | `getDecisionServiceDirectoryPath()` Return the current directory that the Server uses to store the compiled Decision Services.
    `java.util.List` | `getDecisionServiceMajorVersionNumbers(java.lang.String astrDecisionServiceName)` Returns a `List` of Decision Service Major Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
    `java.lang.String` | `getDecisionServiceMajorVersionNumbersFormatted(java.lang.String astrDecisionServiceName)` Returns a formatted `String` of Decision Service Major Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
    `java.util.List` | `getDecisionServiceMinorVersionNumbers(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Returns a `List` of Decision Service Minor Version Integers that are currently loaded into the Corticon Server for a particular Decision Service with a Major version number `aiDecisionServiceMajorVersion`.
    `java.lang.String` | `getDecisionServiceMinorVersionNumbersFormatted(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Returns a formatted `String` of Decision Service Minor Version Integers that are currently loaded into the Corticon Server for a particular Decision Service with a Major version number `aiDecisionServiceMajorVersion`.
    `java.util.Collection` | `getDecisionServiceNames()` Returns a `Collection` of Decision Service name Strings that are currently loaded into the Corticon Server.
    `java.lang.String` | `getDecisionServicePropertyValue(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrPropertyName)` Get a particular property value related to a specific Decision Service based on name and major and minor version number.
    `java.lang.String` | `getDecisionServicePropertyValue(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrPropertyName)` Invokes `getDecisionServicePropertyValue(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `java.lang.String` | `getDecisionServicePropertyValue(java.lang.String astrDecisionServiceName, java.lang.String astrPropertyName)` Invokes `getDecisionServicePropertyValue(astrDecisionServiceName, , astrPropertyName)`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(java.lang.String astrDecisionServiceName)` Invokes `getDecisionServiceStepNumberAndRulesheetActivityNames(astrDecisionServiceName, )`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Returns a `HashMap` containing the step number along with the corresponding Rulesheet Activity name for the given Decision Service.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetPaths(java.lang.String astrDecisionServiceName)` Invokes `getDecisionServiceStepNumberAndRulesheetPaths(astrDecisionServiceName, )`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetPaths(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `getDecisionServiceStepNumberAndRulesheetPaths(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetPaths(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Returns a `HashMap` containing the step number along with the corresponding Rulesheet path for the given Decision Service.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetRelativePaths(java.lang.String astrDecisionServiceName)` Invokes `getDecisionServiceStepNumberAndRulesheetRelativePaths(astrDecisionServiceName, )`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetRelativePaths(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `getDecisionServiceStepNumberAndRulesheetRelativePaths(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `java.util.HashMap<java.lang.Integer,java.lang.String>` | `getDecisionServiceStepNumberAndRulesheetRelativePaths(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Returns a `HashMap` containing the step number along with the corresponding relative Rulesheet path to the Ruleflow file for the given Decision Service.
    `java.util.List` | `getDecisionServiceVersionNumbers(java.lang.String astrDecisionServiceName)` Returns a `List` of Decision Service Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
    `java.lang.String` | `getDecisionServiceVersionNumbersFormatted(java.lang.String astrDecisionServiceName)` Deprecated. use getDecisionServiceMajorVersionNumbersFormatted(astrDecisionServiceName)
    `java.lang.String` | `getDeploymentDescriptorDirectoryPath()` Returns the current directory that the Maintenance Service looks for new CDD files to be auto-deployed.
    `java.lang.String` | `getDeploymentUploadDirectoryPath()` Returns the current directory that the Server Console will upload pre-compiled .eds or Database property files to the Server.
    `java.lang.String` | `getExecutionRecordingDirectoryPath()` Return the current directory that the Server uses to store the Execution Recording Service files.
    `java.util.List` | `getFullyQualifiedPathsForRuleAssets(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Get a list of fully qualified paths of the Rule Assets related to the Decision Service.
    `java.lang.String` | `getFullyQualifiedPathsForRuleAssetsFormatted(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Get a list of fully qualified paths of the Rule Assets related to the Decision Service.
    `java.lang.String` | `getJavaHome()` Get the java home for launching java executable when compiling the rules out-of-process.
    `java.lang.Long` | `getLastExecutionTimestamp(java.lang.String astrDecisionServiceName)` Deprecated. use getDecisionServicePropertyValue(String, String)
    `java.lang.Long` | `getLastExecutionTimestamp(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, String)
    `java.lang.Long` | `getLastExecutionTimestamp(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
    `java.lang.String` | `getLicensePath()` Get the location of the CcLicense.jar that the CcServer is using.
    `java.lang.String` | `getRegisteredTrackingAttributeBucketDefinition(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrRegisteredTrackingAttribute)` Returns a `String` of the Bucket definition.
    `java.lang.String` | `getRegisteredTrackingAttributeBucketDefinition(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeBucketDefinition(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute)`.
    `java.lang.String` | `getRegisteredTrackingAttributeBucketDefinition(java.lang.String astrDecisionServiceName, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeBucketDefinition(astrDecisionServiceName, , astrRegisteredTrackingAttribute)`.
    `java.util.List` | `getRegisteredTrackingAttributeCounts(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrRegisteredTrackingAttribute)` Returns a `List` of `String` values.
    `java.util.List` | `getRegisteredTrackingAttributeCounts(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute)`.
    `java.util.List` | `getRegisteredTrackingAttributeCounts(java.lang.String astrDecisionServiceName, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, , astrRegisteredTrackingAttribute)`.
    `java.lang.String` | `getRegisteredTrackingAttributeCountsFormatted(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, aiDecisionServiceMajorVersion, aiDecisionServiceMinorVersion, astrRegisteredTrackingAttribute)` and formats the result into a String..
    `java.lang.String` | `getRegisteredTrackingAttributeCountsFormatted(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, aiDecisionServiceMajorVersion, astrRegisteredTrackingAttribute)` and formats the result into a String..
    `java.lang.String` | `getRegisteredTrackingAttributeCountsFormatted(java.lang.String astrDecisionServiceName, java.lang.String astrRegisteredTrackingAttribute)` Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, astrRegisteredTrackingAttribute)` and formats the result into a String..
    `java.util.List` | `getRegisteredTrackingAttributes(java.lang.String astrDecisionServiceName)` Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, )`.
    `java.util.List` | `getRegisteredTrackingAttributes(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `java.util.List` | `getRegisteredTrackingAttributes(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Returns a `List` of `String` values.
    `java.lang.String` | `getRegisteredTrackingAttributesFormatted(java.lang.String astrDecisionServiceName)` Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName)` and formats the result into a String.
    `java.lang.String` | `getRegisteredTrackingAttributesFormatted(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, aiDecisionServiceMajorVersion)` and formats the result into a String.
    `java.lang.String` | `getRegisteredTrackingAttributesFormatted(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, aiDecisionServiceMajorVersion, aiDecisionServiceMinorVersion)` and formats the result into a String.
    `org.jdom.Document` | `getRulesetHtmlReport(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrXsltPath)` Returns a `Document` of the Html transformed Report.
    `org.jdom.Document` | `getRulesetHtmlReport(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrXsltPath)` Invokes `getRulesetHtmlReport(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrXsltPath)`.
    `org.jdom.Document` | `getRulesetHtmlReport(java.lang.String astrDecisionServiceName, java.lang.String astrXsltPath)` Invokes `getRulesetHtmlReport(astrDecisionServiceName, , astrXsltPath)`.
    `int` | `getRulesetMajorVersionNumber(java.lang.String astrRulesetAssetPath)` Returns the Major Version number that has been associated within the RuleAsset, based on the path to the RuleAsset.
    `int` | `getRulesetMinorVersionNumber(java.lang.String astrRulesetAssetPath)` Returns the Minor Version number that has been associated within the RuleAsset, based on the path to the RuleAsset.
    `int` | `getRulesetVersionNumber(java.lang.String astrRulesetAssetPath)` Returns the Major Version number that has been associated within the RuleAsset, based on the path to the RuleAsset.
    `org.jdom.Document` | `getRulesetWSDL(java.lang.String astrDecisionServiceName)` Deprecated. use getDecisionServicePropertyValue(String, String)
    `org.jdom.Document` | `getRulesetWSDL(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, String)
    `org.jdom.Document` | `getRulesetWSDL(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
    `org.jdom.Document` | `getRulesetXmlReport(java.lang.String astrDecisionServiceName)` Deprecated. use getDecisionServicePropertyValue(String, String)
    `org.jdom.Document` | `getRulesetXmlReport(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, String)
    `org.jdom.Document` | `getRulesetXmlReport(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
    `java.lang.String` | `getSandboxDirectoryPath()` Returns the current directory that the Server Sandbox is located.
    `long` | `getTotalExecutionCount()` Returns the total execution count across all Decision Service Versions.
    `long` | `getTotalExecutionCount(java.lang.String astrDecisionServiceName)` Deprecated. use getDecisionServicePropertyValue(String, String)
    `long` | `getTotalExecutionCount(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, String)
    `long` | `getTotalExecutionCount(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
    `long` | `getTotalExecutionTime()` Returns the total execution time across all Decision Service Versions.
    `long` | `getTotalExecutionTime(java.lang.String astrDecisionServiceName)` Deprecated. use getDecisionServicePropertyValue(String, String)
    `long` | `getTotalExecutionTime(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, String)
    `long` | `getTotalExecutionTime(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
    `void` | `initialize()` Deprecated. Current version of CcServer will automatically initialize itself inside the constructor.
    `boolean` | `isCcServerRunning()` Allows a client application to ask the CcServer it is up and running.
    `boolean` | `isCDDFileDeployed(java.lang.String astrPathToCddFile)` Returns a `boolean` based on whether the CDD has been deployed in the CcServer.
    `boolean` | `isDecisionServiceDeployed(java.lang.String astrDecisionServiceName)` Invokes `isDecisionServiceDeployed(astrDecisionServiceName, )`.
    `boolean` | `isDecisionServiceDeployed(java.lang.String astrDecisionServiceName, java.util.Date adtDecisionServiceEffectiveTimestamp)` Query the CcServer to determine is a Decision Service has already been deployed under a specific name
    `boolean` | `isDecisionServiceDeployed(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `isDecisionServiceDeployed(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `boolean` | `isDecisionServiceDeployed(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Query the CcServer to determine is a Decision Service has already been deployed under a specific name and Major Version number and Minor Version number
    `boolean` | `isDecisionServiceDeployedAsTest(java.lang.String astrDecisionServiceName)` Inform the caller whether a particular Decision Service is deployed as a Test Decision Service.
    `boolean` | `isDecisionServiceDeployedAsTest(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Inform the caller whether a particular Decision Service is deployed as a Test Decision Service.
    `boolean` | `isDecisionServiceDeployedAsTest(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Inform the caller whether a particular Decision Service is deployed as a Test Decision Service.
    `boolean` | `isDecisionServiceEdsDeployed(java.lang.String astrDecisionServiceName)` Invokes `isDecisionServiceEdsDeployed(astrDecisionServiceName, )`.
    `boolean` | `isDecisionServiceEdsDeployed(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `isDecisionServiceEdsDeployed(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `boolean` | `isDecisionServiceEdsDeployed(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Returns a `boolean` based on whether the Decision Service version was originally deployed as an EDS file.
    `boolean` | `isDecisionServiceRuleflowDeployed(java.lang.String astrDecisionServiceName)` Invokes `isDecisionServiceRuleflowDeployed(astrDecisionServiceName, )`.
    `boolean` | `isDecisionServiceRuleflowDeployed(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `isDecisionServiceRuleflowDeployed(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `boolean` | `isDecisionServiceRuleflowDeployed(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Returns a `boolean` based on whether the Decision Service version was originally deployed as an ERF file.
    `boolean` | `isDynamicUpdateMonitoringServiceRunning()` See `startDynamicUpdateMonitorService`.
    `boolean` | `isServerDiagnosticServiceRunning()` See `startServerDiagnosticService`.
    `boolean` | `isServerExecutionTimesIntervalServiceRunning()` See `startServerExecutionTimesIntervalService`.
    `boolean` | `isServerResultsDistributionMonitoringServiceRunning()` See `startServerResultsDistributionMonitoringService`.
    `void` | `loadFromCdd(java.lang.String astrCddPath)` Deploys the specified Corticon Deployment Descriptor (CDD).
    `void` | `loadFromCddDir(java.lang.String astrCddDirPath)` Deploys all decision services in all Corticon Deployment Descriptor (CDD) files in a specified directory.
    `void` | `modifyDecisionServiceAutoReload(java.lang.String astrDecisionServiceName, boolean abNewAutoReload)` Deprecated. use setDecisionServicePropertyValue(String, String, String)
    `void` | `modifyDecisionServiceAutoReload(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, boolean abNewAutoReload)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServiceAutoReload(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, boolean abNewAutoReload)` Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
    `void` | `modifyDecisionServiceDatabaseAccessProperties(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrNewDatabaseAccessMode, java.lang.String astrNewDatabaseAccessReturnEntities, java.lang.String astrNewDatabaseAccessPropertiesPath)` Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
    `void` | `modifyDecisionServiceDatabaseAccessProperties(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrNewDatabaseAccessMode, java.lang.String astrNewDatabaseAccessReturnEntities, java.lang.String astrNewDatabaseAccessPropertiesPath)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServiceDatabaseAccessProperties(java.lang.String astrDecisionServiceName, java.lang.String astrNewDatabaseAccessMode, java.lang.String astrNewDatabaseAccessReturnEntities, java.lang.String astrNewDatabaseAccessPropertiesPath)` Deprecated. use setDecisionServicePropertyValue(String, String, String)
    `void` | `modifyDecisionServiceExecutionProperty(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
    `void` | `modifyDecisionServiceExecutionProperty(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServiceExecutionProperty(java.lang.String astrDecisionServiceName, java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Deprecated. use setDecisionServicePropertyValue(String, String, String)
    `void` | `modifyDecisionServiceMessageStructType(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrNewMsgStructStyle)` Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
    `void` | `modifyDecisionServiceMessageStructType(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrNewMsgStructStyle)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServiceMessageStructType(java.lang.String astrDecisionServiceName, java.lang.String astrNewMsgStructStyle)` Deprecated. use setDecisionServicePropertyValue(String, String, String)
    `void` | `modifyDecisionServicePoolSizes(java.lang.String astrDecisionServiceName, int aiNewMinPoolSize, int aiNewMaxPoolSize)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServicePoolSizes(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiNewMinPoolSize, int aiNewMaxPoolSize)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServicePoolSizes(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, int aiNewMinPoolSize, int aiNewMaxPoolSize)` Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
    `void` | `modifyDecisionServiceRuleAssetPath(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrNewRuleAssetPath)` Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
    `void` | `modifyDecisionServiceRuleAssetPath(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrNewRuleAssetPath)` Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
    `void` | `modifyDecisionServiceRuleAssetPath(java.lang.String astrDecisionServiceName, java.lang.String astrNewRuleAssetPath)` Deprecated. use setDecisionServicePropertyValue(String, String, String)
    `void` | `modifyDecisionServiceRuleflowPath(java.lang.String astrDecisionServiceName, int aiDecisionServiceVersion, java.lang.String astrRuleAssetPath)` Deprecated. Please use `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, aiDecisionServiceVersion>, astrRuleAssetPath)` instead.
    `void` | `modifyDecisionServiceRuleflowPath(java.lang.String astrDecisionServiceName, java.lang.String astrNewRuleAssetPath)` Deprecated. Please use `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, astrNewRuleAssetPath)` instead.
    `java.lang.String` | `precompileDecisionService(java.lang.String astrRuleflowPath, java.lang.String astrDecisionServiceName, java.lang.String astrOutputPath, boolean abOverwriteFile)` Pre-compiles the give Ruleflow into a deployment unit (EDS) which is written to the output directory.
    `java.lang.String` | `precompileDecisionService(java.lang.String astrRuleflowPath, java.lang.String astrDecisionServiceName, java.lang.String astrOutputPath, java.lang.String astrDatabaseAccessMode, boolean abOverwriteFile)` Pre-compiles the give Ruleflow into a deployment unit (EDS) which is written to the output directory.
    `java.lang.String` | `precompileDecisionService(java.lang.String astrRuleflowPath, java.lang.String astrDecisionServiceName, java.lang.String astrOutputPath, java.lang.String astrDatabaseAccessMode, boolean abOverwriteFile, java.util.Set<java.lang.String> asetDependentJars, java.util.Set<java.lang.String> asetIncludedJars)` Pre-compiles the give Ruleflow into a deployment unit (EDS) which is written to the output directory.
    `void` | `promoteTestDecisionService(java.lang.String astrDecisionServiceName)` Invokes `promoteTestDecisionService(astrDecisionServiceName, )`.
    `void` | `promoteTestDecisionService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `promoteTestDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `void` | `promoteTestDecisionService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Promotes a Test Decision Service to be a live.
    `void` | `redeployDecisionServiceUsingExistingModel(java.lang.String astrDecisionServiceName)` This will redeploy the Decision Service using the existing model assigned to the Decision Service Name.
    `void` | `registerTrackingAttribute(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion, java.lang.String astrRegisteredTrackingAttribute, java.lang.String astrBucketString)` Registers a particular attribute in Corticon Data Monitoring subsystem.
    `void` | `registerTrackingAttribute(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, java.lang.String astrRegisteredTrackingAttribute, java.lang.String astrBucketString)` Invokes `registerTrackingAttribute(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute, astrBucketString)`.
    `void` | `registerTrackingAttribute(java.lang.String astrDecisionServiceName, java.lang.String astrRegisteredTrackingAttribute, java.lang.String astrBucketString)` Invokes `registerTrackingAttribute(astrDecisionServiceName, , astrRegisteredTrackingAttribute, String astrRegisteredAttributeType, String astrBucketString)`.
    `void` | `reloadAllDecisionServicesQueryService()` This method will go to each Decision Service and reload the Query Service data from the Database.
    `void` | `reloadDecisionService(java.lang.String astrDecisionServiceName)` Invokes `reloadDecisionService(astrDecisionServiceName, )`.
    `void` | `reloadDecisionService(java.lang.String astrDecisionServiceName, int aiDecisionServiceVersion)` Invokes `reloadDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `void` | `reloadDecisionService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Reload a specific deployed Major Version and Minor Version of a Decision Service.
    `void` | `reloadDecisionServiceQueryService(java.lang.String astrDecisionServiceName)` Invokes `reloadDecisionServiceQueryService(astrDecisionServiceName, )`
    `void` | `reloadDecisionServiceQueryService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `reloadDecisionServiceQueryService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`
    `void` | `reloadDecisionServiceQueryService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` This method will reload the Query Service data from the Database for the desired Decision Service.
    `void` | `removeDecisionService(java.lang.String astrDecisionServiceName)` Invokes `removeDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `void` | `removeDecisionService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `removeDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `void` | `removeDecisionService(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` Removes version `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` of Decision Service `astrDecisionServiceName` and all associated Corticon Engines in its pool (if any).
    `void` | `setCcPropertyValue(java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Sets the property values of limited number of properties that can be changed at runtime.
    `void` | `setDecisionServicePropertyValue(java.lang.String astrDecisionServiceName, int aiMajorVersionNumber, int aiMinorVersionNumber, java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Set a new property value related to a specific Decision Service based on name and major and minor version number.
    `void` | `setDecisionServicePropertyValue(java.lang.String astrDecisionServiceName, int aiMajorVersionNumber, java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Invokes `setDecisionServicePropertyValue(astrDecisionServiceName, aiMajorVersionNumber, , astrPropertyName, astrProperyValue)`.
    `void` | `setDecisionServicePropertyValue(java.lang.String astrDecisionServiceName, java.lang.String astrPropertyName, java.lang.String astrPropertyValue)` Invokes `setDecisionServicePropertyValue(astrDecisionServiceName, , astrPropertyName, astrProperyValue)`.
    `void` | `setDeploymentDescriptorDirectoryPath(java.lang.String astrDeploymentDirectoryPath)` Sets the current directory that the Maintenance Service looks for new CDD files to be auto-deployed.
    `void` | `setDiagnosticsEnabled(boolean abValue)` Enable/Disable server diagnostic data collection.
    `void` | `setIntervalProcessingEnabled(boolean abValue)` Enable/Disable the Interval Time processing
    `void` | `setJavaHome(java.lang.String astrJavaHome)` Set the java home that will be used to locate java executable for compiling the rules out-of-process.
    `void` | `setLicensePath(java.lang.String astrLicensePath)` Set the location of the CcLicense.jar that the CcServer should use.
    `void` | `setLogLevel(java.lang.String astrLogPath)` Sets the Log level for the server.
    `void` | `setLogPath(java.lang.String astrLogPath)` Sets the path for the Corticon Server log files.
    `void` | `setServerDiagnosticsWaitTime(long alWaitTime)` Change the wait time for the Diagnostic service.
    `void` | `setServerExecutionTimesIntervalTime(long alInterval)` Change the interval time that the Server Execution Times Interval Service uses to determine when to record interval values.
    `java.lang.String` | `startBatchExecution(org.json.JSONObject ajsonObjectBatchProcessingProperties)` This method will start a Batch Execution against a particular Decision Service based on the Batch Processing Properties outlined in the passed in JSONObject.
    `void` | `startDynamicUpdateMonitoringService()` Each Decision Service and each CDD loaded into the Server is monitored by a Maintenance thread at intervals of X where X is the number of milliseconds in the `CcConfig.jar|CcServer.properties| com.corticon.ccserver.dynamicUpdateMonitoringService.serviceIntervals`.
    `void` | `startServerDiagnosticService()` This will start the Diagnostic Service.
    `void` | `startServerExecutionTimesIntervalService()` Each Decision Service loaded into the Server is monitored by an Server Execution Times Interval Service thread at intervals of X that will keep track of total execution times, total execution count, and the average execution times for all executions that occurred during each interval.
    `void` | `startServerResultsDistributionMonitoringService()` This will inform the Corticon Server to perform three separate tasks on the Decision Service Version for each execution.
    `void` | `stopBatchExecution(java.lang.String astrBatchExecutionId)` This method will stop a Batch Execution based on the passed in Id.
    `void` | `stopDynamicUpdateMonitoringService()` See `startDynamicUpdateMonitorService`.
    `void` | `stopServerDiagnosticService()` Start Diagnostic Logging Service
    `void` | `stopServerExecutionTimesIntervalService()` See `stopServerExecutionTimesIntervalService`.
    `void` | `stopServerResultsDistributionMonitoringService()` See `startServerResultsDistributionMonitoringService`.
    `java.lang.String` | `unzipDecisionServiceRuleAssets(java.lang.String astrDecisionServiceName)` Invokes `unzipDecisionServiceRuleAssets(astrDecisionServiceName, )`.
    `java.lang.String` | `unzipDecisionServiceRuleAssets(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion)` Invokes `unzipDecisionServiceRuleAssets(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
    `java.lang.String` | `unzipDecisionServiceRuleAssets(java.lang.String astrDecisionServiceName, int aiDecisionServiceMajorVersion, int aiDecisionServiceMinorVersion)` If the Decision Services was deployed as an EDS file, this method will unzip the Rule Assets inside the EDS file and put them under a unique directory under the ServerSandbox directory.
    `void` | `uploadRuleAssetFile(java.lang.String astrFullyQualifiedPath, java.lang.String astrFileContents)` Allow the user to upload Rule Asset files up to the CcServer.

- - ### Field Detail

    - #### XML_HIER_STYLE

          static final java.lang.String XML_HIER_STYLE

      A style of XML message where all business object associations are captured using embeddings, resulting in a hierarchical XML document.
      See Also:
        Constant Field Values

    - #### XML_FLAT_STYLE

          static final java.lang.String XML_FLAT_STYLE

      A style of XML message where all business object associations are captured using href's, resulting in a "flat" XML document.
      See Also:
        Constant Field Values

    - #### XML_STYLE_AUTODETECT

          static final java.lang.String XML_STYLE_AUTODETECT

      The server auto-detects the style of XML message. This provides more flexibility, however, there's a slight performance hit. If the style of messaging is know, it should be explicitly stated.

    - #### DATABASE_ACCESS_NONE

          static final java.lang.String DATABASE_ACCESS_NONE

      Indicates that a Decision Service does not access an Enterprise database.

    - #### DATABASE_ACCESS_READ_ONLY

          static final java.lang.String DATABASE_ACCESS_READ_ONLY

      Indicates that a Decision Service has read only access to an Enterprise database.
      See Also:
        Constant Field Values

    - #### DATABASE_ACCESS_READ_WRITE

          static final java.lang.String DATABASE_ACCESS_READ_WRITE

      Indicates that a Decision Service has read/write access to an Enterprise database. This mode is required for batch processing.
      See Also:
        Constant Field Values

    - #### DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES

          static final java.lang.String DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES

      Indicates that all entity instances in working memory, including the ones retrieved from the database are returned as part of the response.
      See Also:
        Constant Field Values

    - #### DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES

          static final java.lang.String DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES

      Indicates that only entity instances that arrived as part of the incoming request and those instantiated by rules are returned as part of the response. Those entity instances retrieved from the database are excluded.
      See Also:
        Constant Field Values

    - #### CCPROPERTY_VERSION_NUMBER

          static final java.lang.String CCPROPERTY_VERSION_NUMBER

      Explicit property name that is used to get the Version Number of the CcServer
      See Also:
        `getCcPropertyValue(String)`, Constant Field Values

    - #### CCPROPERTY_SERVICE_RELEASE_NUMBER

          static final java.lang.String CCPROPERTY_SERVICE_RELEASE_NUMBER

      Explicit property name that is used to get the Service Release Number of the CcServer
      See Also:
        `getCcPropertyValue(String)`, Constant Field Values

    - #### CCPROPERTY_BUILD_NUMBER

          static final java.lang.String CCPROPERTY_BUILD_NUMBER

      Explicit property name that is used to get the Build Number of the CcServer
      See Also:
        `getCcPropertyValue(String)`, Constant Field Values

    - #### CCPROPERTY_FULL_VERSION_NUMBER

          static final java.lang.String CCPROPERTY_FULL_VERSION_NUMBER

      Explicit property name that is used to get the Full Version Number of the CcServer
      See Also:
        `getCcPropertyValue(String)`, Constant Field Values

    - #### LICENSE_LOCATION

          static final java.lang.String LICENSE_LOCATION

      Property name that is used to get the location of the License file on the Classpath.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_OEM_NAME

          static final java.lang.String LICENSE_OEM_NAME

      Property name that is used to get the registered name associated with the Server License.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_DATE_GRANTED

          static final java.lang.String LICENSE_DATE_GRANTED

      Property name that is used to get the date the Server License was issued.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_MAX_POOLS

          static final java.lang.String LICENSE_MAX_POOLS

      Property name that is used to get max number of Decision Services that can be deployed on the Corticon Server.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_MAX_REACTORS

          static final java.lang.String LICENSE_MAX_REACTORS

      Property name that is used to get max number of Reactor instances that can be in each Decision Service Pool.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_MAX_NUMBER_OF_RULES

          static final java.lang.String LICENSE_MAX_NUMBER_OF_RULES

      Property name that is used to get max number of rules that can be deployed on the Corticon Server.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_DEACTIVATE_DATE

          static final java.lang.String LICENSE_DEACTIVATE_DATE

      Property name that is used to get the date when the Corticon Server expires.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_DEACTIVATE_DATE_OVERRIDE

          static final java.lang.String LICENSE_DEACTIVATE_DATE_OVERRIDE

      Property name that is used to get the value that disables license expiration.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_SINGLE_EXECUTION_ENABLED

          static final java.lang.String LICENSE_SINGLE_EXECUTION_ENABLED

      Property name that is used to get the value that enables single non-database executions.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_SINGLE_EXECUTION_DB_ACCESS_ENABLED

          static final java.lang.String LICENSE_SINGLE_EXECUTION_DB_ACCESS_ENABLED

      Property name that is used to get the value that enables single database executions.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_BATCHPROCESSING_ENABLED

          static final java.lang.String LICENSE_BATCHPROCESSING_ENABLED

      Property name that is used to get the value that enables database batch processing inside a Decision Service.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_SERVER_IP

          static final java.lang.String LICENSE_SERVER_IP

      Property name that is used to get the value that sets the approved IP Address of the server where the Corticon Server can run.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_INCREMENT_IP

          static final java.lang.String LICENSE_INCREMENT_IP

      Property name that is used to get the value that sets the increment value used by IP validation.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_IP_OVERRIDE

          static final java.lang.String LICENSE_IP_OVERRIDE

      Property name that is used to get the value that enables IP validation.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_SERVER_TRANSACTIONS_TIME_PERIOD

          static final java.lang.String LICENSE_SERVER_TRANSACTIONS_TIME_PERIOD

      Property name that is used to get the value that determines the time period for transaction validation.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_SERVER_TRANSACTIONS_MAX_EXECUTIONS

          static final java.lang.String LICENSE_SERVER_TRANSACTIONS_MAX_EXECUTIONS

      Property name that is used to get the value that determines the number of executions allowed for transaction validation.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_SERVER_TRANSACTION_OVERRIDE

          static final java.lang.String LICENSE_SERVER_TRANSACTION_OVERRIDE

      Property name that is used to get the value that enables transaction validation.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_NAMED_USERS

          static final java.lang.String LICENSE_NAMED_USERS

      Property name that is used to get the value that describes the named users for the license.
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### LICENSE_EXECUTION_QUEUE_SIZE

          static final java.lang.String LICENSE_EXECUTION_QUEUE_SIZE

      Property name that is used to determine how many concurrent executions can occur in the CcServer
      See Also:
        `getCcServerLicenseValue(String)`, Constant Field Values

    - #### REST_HEADER_DECISION_SERVICE_NAME

          static final java.lang.String REST_HEADER_DECISION_SERVICE_NAME

      Constants that can be used to to pass necessary information in REST Header call.
      See Also:
        Constant Field Values

    - #### REST_HEADER_DECISION_SERVICE_MAJOR_VERSION

          static final java.lang.String REST_HEADER_DECISION_SERVICE_MAJOR_VERSION

      See Also:
        Constant Field Values

    - #### REST_HEADER_DECISION_SERVICE_MINOR_VERSION

          static final java.lang.String REST_HEADER_DECISION_SERVICE_MINOR_VERSION

      See Also:
        Constant Field Values

    - #### REST_HEADER_DECISION_SERVICE_EFFECTIVE_TIMESTAMP

          static final java.lang.String REST_HEADER_DECISION_SERVICE_EFFECTIVE_TIMESTAMP

      See Also:
        Constant Field Values

    - #### PROPERTY_IS_DEPLOYED

          static final java.lang.String PROPERTY_IS_DEPLOYED

      Property name that is used to determine if a particular Decision Service is deployed..
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_RULEASSET_URI

          static final java.lang.String PROPERTY_RULEASSET_URI

      Property name that is used to get the path of the Rule Asset (.erf file or .eds file that was deployed).
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_RULEFLOW_URI

          static final java.lang.String PROPERTY_RULEFLOW_URI

      Property name that is used to get the path of the Rule Asset (.erf file, if a .erf file was deployed).
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_RULEFLOW_URI_RELATIVE

          static final java.lang.String PROPERTY_RULEFLOW_URI_RELATIVE

      Property name that is used to get the relative path of the deployed Ruleflow in relation to the CcServerSandbox Directory.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_RULEFLOW_FILE_TIMESTAMP

          static final java.lang.String PROPERTY_RULEFLOW_FILE_TIMESTAMP

      Property name that is used to get the time of the .erf file's timestamp
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EDS_URI

          static final java.lang.String PROPERTY_EDS_URI

      Property name that is used to get the path of the Rule Asset (.erf file, if a .eds file was deployed).
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EDS_HAS_WSDL

          static final java.lang.String PROPERTY_EDS_HAS_WSDL

      Property name that is used to get whether or not the EDS file contains a WSDL document
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EDS_URI_RELATIVE

          static final java.lang.String PROPERTY_EDS_URI_RELATIVE

      Property name that is used to get the relative path of the deployed EDS in relation to the CcServerSandbox Directory.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EDS_FILE_TIMESTAMP

          static final java.lang.String PROPERTY_EDS_FILE_TIMESTAMP

      Property name that is used to get the time of the .eds file's timestamp
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DEPLOYMENT_TIMESTAMP

          static final java.lang.String PROPERTY_DEPLOYMENT_TIMESTAMP

      Property name that is used to get the time when the Decision Service was deployed.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_MIN_POOL_SIZE

          static final java.lang.String PROPERTY_MIN_POOL_SIZE

      Property name that is used to get the minimum pool size for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_MAX_POOL_SIZE

          static final java.lang.String PROPERTY_MAX_POOL_SIZE

      Property name that is used to get the maximum pool size for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_AUTO_RELOAD

          static final java.lang.String PROPERTY_AUTO_RELOAD

      Property name that is used to get the auto reload value for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_VERSION_NUMBER

          static final java.lang.String PROPERTY_VERSION_NUMBER

      Property name that is used to get the version number for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_MAJOR_VERSION_NUMBER

          static final java.lang.String PROPERTY_MAJOR_VERSION_NUMBER

      Property name that is used to get the version number for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_MINOR_VERSION_NUMBER

          static final java.lang.String PROPERTY_MINOR_VERSION_NUMBER

      Property name that is used to get the version number for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EFFECTIVE_START_DATE

          static final java.lang.String PROPERTY_EFFECTIVE_START_DATE

      Property name that is used to get the effective start date for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EFFECTIVE_END_DATE

          static final java.lang.String PROPERTY_EFFECTIVE_END_DATE

      Property name that is used to get the effective end date for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_ACTIVE_POOL

          static final java.lang.String PROPERTY_ACTIVE_POOL

      Property name that is used to get the active value for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_LOADED_FROM_CDD

          static final java.lang.String PROPERTY_LOADED_FROM_CDD

      Property name that is used to get the loaded from CDD value for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_PATH_TO_CDD

          static final java.lang.String PROPERTY_PATH_TO_CDD

      Property name that is used to get the path to CDD value for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_CURRENTLY_RUNNING_IN_BATCH_MODE

          static final java.lang.String PROPERTY_CURRENTLY_RUNNING_IN_BATCH_MODE

      Property name that is used to get the running in batch mode value for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_REACTORS_CURRENTLY_PROCESSING

          static final java.lang.String PROPERTY_REACTORS_CURRENTLY_PROCESSING

      Property name that is used to get the number of reactors that are currently processing for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_REACTORS_WAITING_IN_POOL

          static final java.lang.String PROPERTY_REACTORS_WAITING_IN_POOL

      Property name that is used to get the number of available reactors that are waiting Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_REACTORS_CURRENTLY_QUEUED

          static final java.lang.String PROPERTY_REACTORS_CURRENTLY_QUEUED

      Property name that is used to get the number of reactors that are waiting in the Execution Queie
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_REACTORS_CURRENT_STATE

          static final java.lang.String PROPERTY_REACTORS_CURRENT_STATE

      Property name that is used to get a description of the current state of all the Reactors for the Decision Service
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_NUMBER_OF_RULES_DEPLOYED

          static final java.lang.String PROPERTY_NUMBER_OF_RULES_DEPLOYED

      Property name that is used to get the number of rules deployed in the Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_MESSAGE_STRUCTURE_TYPE

          static final java.lang.String PROPERTY_MESSAGE_STRUCTURE_TYPE

      Property name that is used to get the message structure type for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DEPLOYED_EDS

          static final java.lang.String PROPERTY_DEPLOYED_EDS

      Property name that is used to determine if the deployment of the Decision Service used a .eds file instead of a .erf file.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_WSDL

          static final java.lang.String PROPERTY_WSDL

      Property name that is used to get the WSDL for the Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_XML_REPORT

          static final java.lang.String PROPERTY_XML_REPORT

      Property name that is used to get the XML Report for the Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_LAST_EXECUTION_TIMESTAMP

          static final java.lang.String PROPERTY_LAST_EXECUTION_TIMESTAMP

      Property name that is used to get the timestamp of the last execution against a specific Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_TOTAL_EXECUTION_COUNT

          static final java.lang.String PROPERTY_TOTAL_EXECUTION_COUNT

      Property name that is used to get the total execution count for specific Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_TOTAL_EXECUTION_TIME

          static final java.lang.String PROPERTY_TOTAL_EXECUTION_TIME

      Property name that is used to get the total execution time for specific Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DEPLOYED_RULEFLOW

          static final java.lang.String PROPERTY_DEPLOYED_RULEFLOW

      Property name that is used to determine if the deployment of the Decision Service used a .erf file instead of a .eds file.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_VOCABULARY_METADATA

          static final java.lang.String PROPERTY_VOCABULARY_METADATA

      Property name that is used to return the vocabulary metadata for the specified Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_RECORDING_SERVICE_ENABLED

          static final java.lang.String PROPERTY_EXECUTION_RECORDING_SERVICE_ENABLED

      Property name that is used to determine if this Decision Service will use the default Execution Recording Service
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_RECORDING_SERVICE_NAME

          static final java.lang.String PROPERTY_EXECUTION_RECORDING_SERVICE_NAME

      Property name that is used to get the Execution Recording Serivce that is associated with the specified Decision Service
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO

          static final java.lang.String PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO

      Property name that is used to get the Decision Service's restrict Info RuleMessages.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, `modifyDecisionServiceExecutionProperty(String, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, int, String, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING

          static final java.lang.String PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING

      Property name that is used to get the Decision Service's restrict Warning RuleMessages.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, `modifyDecisionServiceExecutionProperty(String, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, int, String, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION

          static final java.lang.String PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION

      Property name that is used to get the Decision Service's restrict Violation RuleMessages.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, `modifyDecisionServiceExecutionProperty(String, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, int, String, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_RESTRICT_RESPONSE_TO_RULEMESSAGES_ONLY

          static final java.lang.String PROPERTY_EXECUTION_RESTRICT_RESPONSE_TO_RULEMESSAGES_ONLY

      Property name that is used to get the Decision Service's restrict the CorticonResponse to only RuleMessages.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, `modifyDecisionServiceExecutionProperty(String, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, String, String)`, `modifyDecisionServiceExecutionProperty(String, int, int, String, String)`, Constant Field Values

    - #### PROPERTY_EXECUTION_LOCALE

          static final java.lang.String PROPERTY_EXECUTION_LOCALE

      Property name that is used to get the Decision Service's execution locale.
      See Also:
        Constant Field Values

    - #### PROPERTY_EXECUTION_TIMEZONE

          static final java.lang.String PROPERTY_EXECUTION_TIMEZONE

      See Also:
        Constant Field Values

    - #### PROPERTY_EXECUTION_EXECUTION_RECORDING_SERVICE_NAME

          static final java.lang.String PROPERTY_EXECUTION_EXECUTION_RECORDING_SERVICE_NAME

      Property name that is used to get the Decision Service's execution recording service name.
      See Also:
        Constant Field Values

    - #### PROPERTY_DATABASE_ACCESS_MODE

          static final java.lang.String PROPERTY_DATABASE_ACCESS_MODE

      Property name that is used to get the database access mode for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATABASE_ACCESS_PROPERTIES

          static final java.lang.String PROPERTY_DATABASE_ACCESS_PROPERTIES

      Property name that is used to get the string representation of the database access properties object for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATASOURCE_CONFIG_FILE_CONTENTS

          static final java.lang.String PROPERTY_DATASOURCE_CONFIG_FILE_CONTENTS

      Property name that is used to get the string representation of the datasource configuration properties object for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATASOURCE_CONFIG_FILE_PATH

          static final java.lang.String PROPERTY_DATASOURCE_CONFIG_FILE_PATH

      Property name that is used to get the string representation of the datasource xml file object for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH

          static final java.lang.String PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH

      Property name that is used to get the path to the properties file that was loaded for a Decision Service
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATABASE_ACCESS_CACHING_ENABLED

          static final java.lang.String PROPERTY_DATABASE_ACCESS_CACHING_ENABLED

      Property name that is used to get the value that tells whether this Decision Service has Caching turned on
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH_RELATIVE

          static final java.lang.String PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH_RELATIVE

      Property name that is used to get the path to the properties file that was loaded for a Decision Service The path that is returned will be relative to the location of the CcServerSandbox\DoNotDelete\DecisionServices
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DATABASE_ACCESS_RETURN_ENTITIES_MODE

          static final java.lang.String PROPERTY_DATABASE_ACCESS_RETURN_ENTITIES_MODE

      Property name that is used to get the return policy for database access executions for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DEPLOYED_AS_TEST_DECISION_SERVICE

          static final java.lang.String PROPERTY_DEPLOYED_AS_TEST_DECISION_SERVICE

      Property name that is used to get the boolean that signifies that the Decision Service was deployed in Test Mode.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_RULEASSET_ZIP_FILE_URI

          static final java.lang.String PROPERTY_RULEASSET_ZIP_FILE_URI

      Property name that is used to get the location of the unzipped Rule Asset files.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_RULEASSET_ZIP_FILE_TIMESTAMP

          static final java.lang.String PROPERTY_RULEASSET_ZIP_FILE_TIMESTAMP

      Property name that is used to get the timestamp of the unzipped Rule Asset files.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### DECISION_SERVICE_DETAILS_TYPE_XML

          static final java.lang.String DECISION_SERVICE_DETAILS_TYPE_XML

      Property name to be used to get the desired output structure when calling getDecisionServiceDetails()
      See Also:
        Constant Field Values

    - #### DECISION_SERVICE_DETAILS_TYPE_JSON

          static final java.lang.String DECISION_SERVICE_DETAILS_TYPE_JSON

      See Also:
        Constant Field Values

    - #### PROPERTY_DECISION_SERVICE_DETAILS

          static final java.lang.String PROPERTY_DECISION_SERVICE_DETAILS

      Property name that is used to get the details of the Decision Service in a String representation of a JSONObject.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DECISION_SERVICE_HAS_RULEASSETS_CHANGED

          static final java.lang.String PROPERTY_DECISION_SERVICE_HAS_RULEASSETS_CHANGED

      Property name that is used to check to see if any of the associated RuleAssets have changed based on their timestamp.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DECISION_SERVICE_QUERY_SERVICE_LAST_LOAD

          static final java.lang.String PROPERTY_DECISION_SERVICE_QUERY_SERVICE_LAST_LOAD

      Property name that is used to determine when the Query Service was last loaded for a Decision Service.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_WEB_CONSOLE_ASSET_ID

          static final java.lang.String PROPERTY_WEB_CONSOLE_ASSET_ID

      Property name that is used to set the Web Console Asset identifier.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_INCLUDED_JARS

          static final java.lang.String PROPERTY_INCLUDED_JARS

      Property name that is used to set the Included Jars identifier.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### PROPERTY_DEPENDENT_JARS

          static final java.lang.String PROPERTY_DEPENDENT_JARS

      Property name that is used to set the Dependent Jars identifier.
      See Also:
        `getDecisionServicePropertyValue(String, String)`, `getDecisionServicePropertyValue(String, int, String)`, `getDecisionServicePropertyValue(String, int, int, String)`, Constant Field Values

    - #### LOG_LEVEL

          static final java.lang.String LOG_LEVEL

      Property name that is used to get or set the log level.
      See Also:
        Constant Field Values

    - #### LOG_PATH

          static final java.lang.String LOG_PATH

      Property name that is used to get or set the log file path.
      See Also:
        Constant Field Values

    - #### LOG_ROLLOVER

          static final java.lang.String LOG_ROLLOVER

      Property name that is used to get or set log file daily rollover behavior.
      See Also:
        Constant Field Values

    - #### LOG_ROLLOVERS_TO_KEEP

          static final java.lang.String LOG_ROLLOVERS_TO_KEEP

      Property name that is used to get or set the maximum number of rollover log files.
      See Also:
        Constant Field Values

    - #### LOG_FILTERS_ACCEPT

          static final java.lang.String LOG_FILTERS_ACCEPT

      Property name that is used to get or set log marker filters. All other markers not specifed will be filtered out of the log file.
      See Also:
        Constant Field Values

    - #### LOG_PER_DS

          static final java.lang.String LOG_PER_DS

      Property name that is used to get or set decision service specific logging.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### addDecisionService

          void addDecisionService(java.lang.String astrDecisionServiceName,
                                  com.corticon.eclipse.studio.rule.rulesheet.core.IRulesheetModelAPI aIRulesheetModelAPI,
                                  java.util.Properties apropDeploymentOptions)
                           throws CcServerDecisionServiceAlreadyRegisteredException,
                                  CcServerFileOrDirNotFoundException,
                                  CcServerInvalidArgumentException,
                                  CcServerDatabaseValidationException,
                                  CcServerInvalidDecisionServiceException,
                                  CcServerLicenseViolationException

      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`

    - #### addDecisionService

          void addDecisionService(java.lang.String astrDecisionServiceName,
                                  com.corticon.eclipse.studio.rule.ruleflow.core.IRuleflowModelAPI aIRuleflowModelAPI,
                                  java.util.Properties apropDeploymentOptions)
                           throws CcServerDecisionServiceAlreadyRegisteredException,
                                  CcServerFileOrDirNotFoundException,
                                  CcServerInvalidArgumentException,
                                  CcServerDatabaseValidationException,
                                  CcServerInvalidDecisionServiceException,
                                  CcServerLicenseViolationException

      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`

    - #### addDecisionService

          void addDecisionService(java.lang.String astrDecisionServiceName,
                                  java.lang.String astrRuleAssetPath,
                                  java.util.Properties apropDeploymentOptions)
                           throws CcServerDecisionServiceAlreadyRegisteredException,
                                  CcServerFileOrDirNotFoundException,
                                  CcServerInvalidArgumentException,
                                  CcServerDatabaseValidationException,
                                  CcServerInvalidDecisionServiceException,
                                  CcServerLicenseViolationException

      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`

    - #### addDecisionService

          void addDecisionService(java.lang.String astrDecisionServiceName,
                                  java.lang.String astrRuleAssetPath,
                                  boolean abAutoReload)
                           throws CcServerDecisionServiceAlreadyRegisteredException,
                                  CcServerFileOrDirNotFoundException,
                                  CcServerInvalidArgumentException,
                                  CcServerDatabaseValidationException,
                                  CcServerInvalidDecisionServiceException,
                                  CcServerLicenseViolationException

      Invokes `addDecisionService(astrDecisionServiceName, astrRuleAssetPath, abAutoReload, false)`
      Parameters:
        `astrDecisionServiceName` - - logical name of the Decision Service (and thus corresponding Corticon Engine pool).
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
        `abAutoReload` - - set to true if this Corticon Engine pool should conduct a timestamp check to see, if rules have been modified and dynamically reload Decision Service as necessary. See `startDynamicUpdateMonitoringService` for more details.
      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `#addDecisionService(String, String, boolean, boolean)`, `startDynamicUpdateMonitoringService()`

    - #### addDecisionService

          void addDecisionService(java.lang.String astrDecisionServiceName,
                                  java.lang.String astrRuleAssetPath,
                                  boolean abAutoReload,
                                  int aiMinPoolSize,
                                  int aiMaxPoolSize,
                                  java.lang.String astrMsgStructStyle)
                           throws CcServerDecisionServiceAlreadyRegisteredException,
                                  CcServerFileOrDirNotFoundException,
                                  CcServerInvalidArgumentException,
                                  CcServerDatabaseValidationException,
                                  CcServerInvalidDecisionServiceException,
                                  CcServerLicenseViolationException

      Invokes `addDecisionService(astrDecisionServiceName, astrRuleAssetPath, abAutoReload, aiMinPoolSize, aiMaxPoolSize, astrMsgStructStyle, false)`
      Parameters:
        `astrDecisionServiceName` - - logical name of the Decision Service (and thus corresponding Corticon Engine pool).
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
        `abAutoReload` - - set to true if this Corticon Engine pool should conduct a timestamp check to see, if rules have been modified and dynamically reload Decision Service as necessary. See `startDynamicUpdateMonitoringService` for more details.
        `aiMinPoolSize` - - number of Corticon Engine instances to initialize the pool with
        `aiMaxPoolSize` - - the maximum number of Corticon Engine instances the pool can grow to
        `astrMsgStructStyle` - - type of XML Message used for the payload containing business object data. One of three values: XML_FLAT_STYLE, XML_HIER_STYLE, XML_STYLE_AUTODETECT (default)
      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `XML_FLAT_STYLE`, `XML_HIER_STYLE`, `XML_STYLE_AUTODETECT`, `#addDecisionService(String, String, boolean, int, int, String, boolean)`, `startDynamicUpdateMonitoringService()`

    - #### addDecisionService

          void addDecisionService(java.lang.String astrDecisionServiceName,
                                  java.lang.String astrRuleAssetPath,
                                  boolean abAutoReload,
                                  int aiMinPoolSize,
                                  int aiMaxPoolSize,
                                  java.lang.String astrMsgStructStyle,
                                  java.lang.String astrDatabaseAccessMode,
                                  java.lang.String astrDatabaseAccessReturnEntities,
                                  java.lang.String astrDatabaseAccessPropertiesPath)
                           throws CcServerDecisionServiceAlreadyRegisteredException,
                                  CcServerFileOrDirNotFoundException,
                                  CcServerInvalidArgumentException,
                                  CcServerDatabaseValidationException,
                                  CcServerInvalidDecisionServiceException,
                                  CcServerLicenseViolationException

      Deploys a Ruleflow as a Decision Service named `astrDecisionServiceName`. If the new Ruleflow's version number collides with an already deployed Ruleflow with the same Decision Service name then a `CcServerDecisionServiceAlreadyRegisteredException` is thrown. Each Decision Service Version is associated with a Corticon Engine pool.

      The pooling parameters indicate how the Corticon Engine pool is managed. The pool is initialized at Server startup time with `aiMinPoolSize` instances of the Engine. As the number of concurrent requests for this Decision Service Version increases to more than `aiMinPoolSize`, the Server continues to grow the pool until `aiMaxPoolSize` is reached. If the number of concurrent requests grow beyond the max size, they are then queued up to wait for an instance to be freed up. If any Engine instance remains idle for X milliseconds, where X is the configuration parameter in `CcConfig.jar|CcServer.properties|com.corticon.ccserver.inactivity`, it is removed from the pool and the associated memory is freed up. The pool continues to shrink until `aiMinPoolSize` is reached.

      `astrMsgStructStyle` parameter determines the style of XML messaging (FLAT, HIER, AUTODETECT) that may be used to invoke this Decision Service.

      Note: This method is used as an alternative to using the Corticon Deployment Descriptor file (.CDD) and method `loadFromCdd`. This allows the multi-threaded container to directly manage the state of Corticon Server rather than having to go through the Deployment Console or CDD. However, all versions of the same Decision Service must be deployed either using a CDD or `addDecisionService` methods. If there is already a Decision Service `astrDecisionServiceName` deployed using a CDD then the deployment is rejected and a `CcServerDecisionServiceLoadedFromCddException` is thrown.

      `astrDatabaseAccessMode` parameter determines database access mode of the Decision Service. `DATABASE_ACCESS_NONE` indicates no access to an external database. `DATABASE_ACCESS_READ_ONLY` indicates read only access to an external database whose connection properties are in the JDO runtime properties file pointed to by `astrDatabaseAccessPropertiesPath`. `DATABASE_ACCESS_READ_WRITE` indicates both read and write access to the external database.

      When the database access is not `DATABASE_ACCESS_NONE`: - if `astrDatabaseAccessPropertiesPath` is null or a connection to the database cannot be established then a `CcServerInvalidArgumentException` is thrown. - if the Decision Service does not have its Work Document Entity specified then a `CcServerInvalidArgumentException` is thrown. - if the Decision Service does not have a valid mapping to the database then a `CcServerInvalidArgumentException` is thrown.

      Parameters:
        `astrDecisionServiceName` - - logical name of the Decision Service (and thus corresponding Corticon Engine pool).
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
        `abAutoReload` - - set to true if this Corticon Engine pool should conduct a timestamp check to see, if rules have been modified and dynamically reload Decision Service as necessary. See `startDynamicUpdateMonitoringService` for more details.
        `aiMinPoolSize` - - number of Corticon Engine instances to initialize the pool with
        `aiMaxPoolSize` - - the maximum number of Corticon Engine instances the pool can grow to
        `astrMsgStructStyle` - - type of XML Message used for the payload containing business object data. One of three values: XML_FLAT_STYLE, XML_HIER_STYLE, XML_STYLE_AUTODETECT (default)
        `astrDatabaseAccessMode` - - this indicates what mode of database access the Decision Service is deployed with. One of three values: DATABASE_ACCESS_NONE, DATABASE_ACCESS_READ_ONLY, DATABASE_ACCESS_READ_WRITE
        `astrDatabaseAccessReturnEntities` - - this determines which entity instances are retruned as part of the response Possible values: DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES, DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES
        `astrDatabaseAccessPropertiesPath` - - path to the JDO runtime properties file containing DB connection info
      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `XML_FLAT_STYLE`, `XML_HIER_STYLE`, `XML_STYLE_AUTODETECT`, `DATABASE_ACCESS_NONE`, `DATABASE_ACCESS_READ_ONLY`, `DATABASE_ACCESS_READ_WRITE`, `DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES`, `DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES`, `startDynamicUpdateMonitoringService()`

    - #### clearAllNonCddDecisionServices

          void clearAllNonCddDecisionServices()
                                       throws CcServerInvalidArgumentException

      Clears all Decision Services and all associated Corticon Engine pools from the server. This method only operates on Decision Services loaded using `addDecisionService`.
      Throws:
        `CcServerInvalidArgumentException`

    - #### createDownloadableZipFile

          java.lang.String createDownloadableZipFile(java.lang.String astrDecisionServiceName,
                                                     int aiDecisionServiceMajorVersion,
                                                     int aiDecisionServiceMinorVersion)
                                              throws CcServerCannotWriteToFileException,
                                                     CcServerDecisionServiceNotRegisteredException,
                                                     CcServerFileOrDirNotFoundException,
                                                     CcServerInitializationInProgressException,
                                                     CcServerInvalidArgumentException,
                                                     CcServerInvalidDecisionServiceException

      Takes the most current Rule Assets related to the Decision Service and zips them up into a .zip file, and places this file inside the CcServerSandbox. The return value is the fully qualified path to that .zip file.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiTargetMajorVersionNumber` - - a specific Major Version of the Decision Service to be modified
        `aiTargetMinorVersionNumber` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - String value, which is the fully qualified path to the zip file on the Server
      Throws:
        `CcServerCannotWriteToFileException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `#createTestDecisionService(String)`

    - #### createTestDecisionService

          int createTestDecisionService(java.lang.String astrDecisionServiceName,
                                        int aiTargetMajorVersionNumber)
                                 throws CcServerDecisionServiceNotRegisteredException,
                                        CcServerDecisionServiceAlreadyRegisteredException,
                                        CcServerFileOrDirNotFoundException,
                                        CcServerLicenseViolationException,
                                        CcServerInvalidArgumentException,
                                        CcServerDatabaseValidationException,
                                        CcServerInvalidDecisionServiceException

      Invokes `createTestDecisionService(astrDecisionServiceName, aiTargetMajorVersionNumber, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiTargetMajorVersionNumber` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - int value, which is the new version number for the Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `#createTestDecisionService(String)`

    - #### createTestDecisionService

          int createTestDecisionService(java.lang.String astrDecisionServiceName,
                                        int aiTargetMajorVersionNumber,
                                        int aiTargetMinorVersionNumber)
                                 throws CcServerDecisionServiceNotRegisteredException,
                                        CcServerDecisionServiceAlreadyRegisteredException,
                                        CcServerFileOrDirNotFoundException,
                                        CcServerLicenseViolationException,
                                        CcServerInvalidArgumentException,
                                        CcServerDatabaseValidationException,
                                        CcServerInvalidDecisionServiceException

      Creates a new Test Decision Service from an existing Decision Service. This will create a new Decision Service with the next highest available major version number. Returns an `int`, which is the version number of the new Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiTargetMajorVersionNumber` - - a specific Major Version of the Decision Service to be modified
        `aiTargetMinorVersionNumber` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - int value, which is the new version number for the Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `#createTestDecisionService(String)`

    - #### createTestDecisionServiceMinorVersion

          int createTestDecisionServiceMinorVersion(java.lang.String astrDecisionServiceName,
                                                    int aiMajorVersionNumber)
                                             throws CcServerDecisionServiceNotRegisteredException,
                                                    CcServerDecisionServiceAlreadyRegisteredException,
                                                    CcServerFileOrDirNotFoundException,
                                                    CcServerLicenseViolationException,
                                                    CcServerInvalidArgumentException,
                                                    CcServerDatabaseValidationException,
                                                    CcServerInvalidDecisionServiceException

      Invokes `createTestDecisionServiceMinorVersion(astrDecisionServiceName, aiTargetMajorVersionNumber, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiTargetMajorVersionNumber` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - int value, which is the new version number for the Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `createTestDecisionServiceMinorVersion(String, int, int)`

    - #### createTestDecisionServiceMinorVersion

          int createTestDecisionServiceMinorVersion(java.lang.String astrDecisionServiceName,
                                                    int aiMajorVersionNumber,
                                                    int aiMinorVersionNumber)
                                             throws CcServerDecisionServiceNotRegisteredException,
                                                    CcServerDecisionServiceAlreadyRegisteredException,
                                                    CcServerFileOrDirNotFoundException,
                                                    CcServerLicenseViolationException,
                                                    CcServerInvalidArgumentException,
                                                    CcServerDatabaseValidationException,
                                                    CcServerInvalidDecisionServiceException

      Creates a new Test Decision Service from an existing Decision Service. This will create a new Decision Service with the next highest available minor version number for the desired Decision Service Returns an `int`, which is the version number of the new Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiTargetMajorVersionNumber` - - a specific Major Version of the Decision Service to be modified
        `aiTargetMinorVersionNumber` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - int value, which is the new version number for the Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `#createTestDecisionService(String)`

    - #### createUniqueUploadDirectory

          java.lang.String createUniqueUploadDirectory()

      Create a new temporary upload directory inside the CcServerSandbox. The CcServer will generate a unique directory, and return the fully qualified path to the user. return - String, fully qualified path to the new directory

    - #### deregisterTrackingAttribute

          void deregisterTrackingAttribute(java.lang.String astrDecisionServiceName,
                                           int aiDecisionServiceMajorVersion,
                                           int aiDecisionServiceMinorVersion,
                                           java.lang.String astrRegisteredTrackingAttribute)
                                    throws CcServerDecisionServiceNotRegisteredException,
                                           CcServerInvalidArgumentException,
                                           CcServerTimeoutException

      Deregisters a particular attribute in Corticon Data Monitoring subsystem.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### deregisterTrackingAttribute

          void deregisterTrackingAttribute(java.lang.String astrDecisionServiceName,
                                           int aiDecisionServiceMajorVersion,
                                           java.lang.String astrRegisteredTrackingAttribute)
                                    throws CcServerDecisionServiceNotRegisteredException,
                                           CcServerInvalidArgumentException,
                                           CcServerTimeoutException

      Invokes `deregisterTrackingAttribute(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### deregisterTrackingAttribute

          void deregisterTrackingAttribute(java.lang.String astrDecisionServiceName,
                                           java.lang.String astrRegisteredTrackingAttribute)
                                    throws CcServerDecisionServiceNotRegisteredException,
                                           CcServerInvalidArgumentException,
                                           CcServerTimeoutException

      Invokes `deregisterTrackingAttribute(astrDecisionServiceName, , astrRegisteredTrackingAttribute)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### downloadRuleAssetFile

          java.lang.String downloadRuleAssetFile(java.lang.String astrFullyQualifiedPath)
                                          throws CcServerCannotReadFileContentsException,
                                                 CcServerFileOrDirNotFoundException,
                                                 CcServerInvalidArgumentException

      Allow the user to download Rule Asset files up to the CcServer.
      Parameters:
        `astrFullyQualifiedPath` -
      Throws:
        `CcServerCannotReadFileContentsException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`

    - #### execute

          org.jdom.Document execute(org.jdom.Document aCorticonRequestDoc)
                             throws CcServerDecisionServiceNotRegisteredException,
                                    CcServerEndlessLoopException,
                                    CcServerExecutionException,
                                    CcServerInitializationInProgressException,
                                    CcServerInvalidArgumentException,
                                    CcServerDatabaseValidationException,
                                    CcServerLicenseViolationException,
                                    CcServerTimeoutException

      Equivalent to the method `execute(String)`, except that the `CorticonRequest` & `CorticonResponse` documents are JDOM XML. Although, the `aCorticonRequest` parameter is directly updated during the processing of the request and in effect is passed-by-reference, the updates to "`WorkDocuments`" should be obtained by examining the returning `CorticonResponse` `Document`.
      Parameters:
        `aCorticonRequestDoc` - - a JDOM representation of the `CorticonRequest`
      Returns:
        - a JDOM `CorticonResponse` Document
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String)`

    - #### execute

          org.jdom.Document execute(org.jdom.Document aCorticonRequestDoc,
                                    java.lang.String astrServerLocation)
                             throws CcServerDecisionServiceNotRegisteredException,
                                    CcServerEndlessLoopException,
                                    CcServerExecutionException,
                                    CcServerInitializationInProgressException,
                                    CcServerInvalidArgumentException,
                                    CcServerDatabaseValidationException,
                                    CcServerLicenseViolationException,
                                    CcServerTimeoutException

      Equivalent to the method `execute(String)`, except that the `CorticonRequest` & `CorticonResponse` documents are JDOM XML. Althought, the `aCorticonRequest` parameter is directly updated during the processing of the request and in effect is passed-by-reference, the updates to "`WorkDocuments`" should be obtained by examining the returning `CorticonResponse` `Document`. The asrtServerLocation is a license restriction that has been added to 5.3.2. Only use this method if instructed by Professional Services.
      Parameters:
        `aCorticonRequestDoc` - - a JDOM representation of the `CorticonRequest`
        `astrServerLocation` - - a string that represent the host caller of the method.
      Returns:
        - a JDOM `CorticonResponse` Document
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String)`

    - #### execute

          org.jdom.Document execute(org.jdom.Document aCorticonRequestDoc,
                                    java.lang.String astrServerLocation,
                                    com.corticon.services.http.ICcServerHttpInfo aCcServerHttpInfo)
                             throws CcServerDecisionServiceNotRegisteredException,
                                    CcServerEndlessLoopException,
                                    CcServerExecutionException,
                                    CcServerInitializationInProgressException,
                                    CcServerInvalidArgumentException,
                                    CcServerDatabaseValidationException,
                                    CcServerLicenseViolationException,
                                    CcServerTimeoutException

      Equivalent to the method `execute(String, ICcServerHttpInfo)`, except that the `CorticonRequest` & `CorticonResponse` documents are JDOM XML. Although, the `aCorticonRequest` parameter is directly updated during the processing of the request and in effect is passed-by-reference, the updates to "`WorkDocuments`" should be obtained by examining the returning `CorticonResponse` `Document`. The asrtServerLocation is a license restriction that has been added to 5.3.2. Only use this method if instructed by Professional Services.
      Parameters:
        `aCorticonRequestDoc` - - a JDOM representation of the `CorticonRequest`
        `astrServerLocation` - - a string that represent the host caller of the method.
        `aCcServerHttpInfo` - - ICcServerHttpInfo Object containing http headers information
      Returns:
        - a JDOM `CorticonResponse` Document
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String)`

    - #### execute

          java.lang.String execute(java.lang.String astrCorticonRequest)
                            throws CcServerDecisionServiceNotRegisteredException,
                                   CcServerEndlessLoopException,
                                   CcServerExecutionException,
                                   CcServerInitializationInProgressException,
                                   CcServerInvalidArgumentException,
                                   CcServerDatabaseValidationException,
                                   CcServerLicenseViolationException,
                                   CcServerTimeoutException

      Invoke a specific Decision Service by passing in a `CorticonRequest` XML message in String form.
      A `CorticonRequest` root element is comprised of:
      . . . `decisionServiceName` attribute - refers to the logical decision "Service" name that should process the request.
      . . . `decisionServiceTargetVersion` attribute - the Decision Service version that should process this request.
      . . . `decisionServiceEffectiveTimestamp` attribute - the effective timestamp the Server should use to process this request.
      . . . `WorkDocuments` element - contains a payload of possibly interrelated business entity instances.
      . . . . . . The primary business entity class operated on is called the "Work Document" entity. This section
      . . . . . . must contain at least one instance of the "Work Document" entity. All other business entity instances
      . . . . . . in this section must be related to the "Work Document" entity(s). These business entity instances may
      . . . . . . be updated by the decision service and returned as part of the returning `CorticonResponse`.
      This method returns a `CorticonResponse` XML document.
      A `CorticonResponse` root element is comprised of:
      . . . `WorkDocuments` element - the incoming "`WorkDocuments`" possibly updated by the decision services
      . . . `Messages` element - an audit trace of rule firings associated to specific entity instances within `WorkDocuments`.
      `WorkDocuments` payload contains instances of entities defined in the vocabulary that the decision service is based on. The structure of `WorkDocuments` is described by the XML Schemas as generated by the Corticon Deployment Console for the target decision service.

      This method should also be used for SOAP messaging. The container must have a means of processing document-style (message-style) incoming SOAP calls, extract and forward the payload to this method. The structure of the SOAP request is defined by the WSDL documents generated by the Corticon Deployment Console for the target decision service. The WSDL defines a service under soapAction="urn:Corticon" with a single method "processRequest" that takes as input an XML document containing a `CorticonRequest` (the SOAP call payload) and returning an XML document containing a `CorticonResponse`.

      The `decisionServiceTargetVersion` and `decisionServiceEffectiveTimestamp` attributes are mutually exclusive and optional. If they both contain a null value then the server selects the latest effective version of the Decision Service to process the request. If no effective Decision Service is found then a `CcServerDecisionServiceNotRegisteredException` is thrown. If they both contain a non-null value then a `CcServerInvalidArgumentException` is thrown. The `decisionServiceTargetVersion` attribute determines a specific version of the Decision Service that should be used to process this request. If the requested version is not currently loaded in the Server then a `CcServerDecisionServiceNotRegisteredException` is thrown. The `adDecisionServiceEffectiveTimestamp` attriubtes tells the server to assume the request had arrived at a different point in time. This timestamp is used to determine which version of the Decision Service must process the request. If no effective Decision Service is found for the given timestamp then a `CcServerDecisionServiceNotRegisteredException` is thrown.

      Parameters:
        `astrCorticonRequest` - - a `CorticonRequest` XML Document compliant with the XSD contract of the decision service.
      Returns:
        String - a `CorticonResponse` XML Document compliant with the XSD contract of the decision service.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`

    - #### execute

          java.lang.String execute(java.lang.String astrCorticonRequest,
                                   com.corticon.services.http.ICcServerHttpInfo aCcServerHttpInfo)
                            throws CcServerDecisionServiceNotRegisteredException,
                                   CcServerEndlessLoopException,
                                   CcServerExecutionException,
                                   CcServerInitializationInProgressException,
                                   CcServerInvalidArgumentException,
                                   CcServerDatabaseValidationException,
                                   CcServerLicenseViolationException,
                                   CcServerTimeoutException

      Equivalent to the method `execute(String)`, except for this method accepts `ICcServerHttpInfo`
      Parameters:
        `astrCorticonRequest` - - a `CorticonResponse` XML Document compliant with the XSD contract of the decision service.
        `aCcServerHttpInfo` - - ICcServerHttpInfo Object containing http headers information
      Returns:
        String - a `CorticonResponse` XML Document compliant with the XSD contract of the decision service.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Collection acolWorkObjs)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Invoke a specific Decision Service by passing in a `Collection` of Java business objects representing `WorkDocuments`. The server selects the latest effective version of the Decision Service to process the request. If no effective Decision Service is found then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      The `acolWorkObjs` is effectively passed-by-reference. Any possible updates the business objects by the Decision Service are reflected in `acolWorkObjs` after the call. An `ICcRuleMessages` is also returned containing `ICcRuleMessage` instances represneting the business rule statements posted by Decision Service. The `ICcRuleMessages` is the audit trace of rules that fired and each `ICcRuleMessage` points to specific instances of Java "WorkDocument" objects in the `acolWorkObjs`.
      Note: These objects must conform to the JavaBean standard and be accurately mapped to a Vocabulary file (.cvj / .ecore). Typically, a UML class diagram is exported from Rose to an XMI file, which is in turn imported into the Corticon Studio to create the vocabulary. The same UML class diagram is used to also generate the Java business objects. Therefore, the UML model becomes the glue that ensures integrity of the system. Note, it is possible for the Java business object class and property names to be different than those used in the vocabulary file. Each node of the vocabulary has "external" properties for name-mapping purposes.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `acolWorkObjs` - - a `Collection` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Collection acolWorkObjs,
                                  java.util.Date adDecisionServiceEffectiveTimestamp)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Similar to `execute(String, Collection)` except that the user can specify what effective timestamp should be using using the parameter `adDecisionServiceEffectiveTimestamp`. This parameter tells the server to assume the request had arrived at a different point in time. This timestamp is used to determine which version of the Decision Service must process the request. If no effective Decision Service is found for the given timestamp then a `CcServerDecisionServiceNotRegisteredException` is thrown. Since no major version number is specified, the CcServer will start at the highest major/minor version Decision Service version and then work backwards to find the first matching Deciison Service version.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `acolWorkObjs` - - a `Collection` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `adDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Collection acolWorkObjs,
                                  java.util.Date adDecisionServiceEffectiveTimestamp,
                                  int aiDecisionServiceTargetMajorVersion)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Similar to `execute(String, Collection, Date)` except that the user can specify what major version number should be using for the parameter `aiDecisionServiceTargetMajorVersion`. This parameter limits the matching of the Decision Service to also have its Major Version Number equal to `aiDecisionServiceTargetMajorVersion`. If no Decision Service is found that satisfies the `adDecisionServiceEffectiveTimestamp` and `aiDecisionServiceTargetMajorVersion` criteria, then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `acolWorkObjs` - - a `Collection` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `adDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to process this request
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Collection acolWorkObjs,
                                  int aiDecisionServiceTargetMajorVersion)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Similar to `execute(String, Collection)` except that the user can specify which Major Version of the Decision Service should process the request using parameter `aiDecisionServiceTargetVersion`. If the requested version is not currently loaded in the Server then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `acolWorkObjs` - - a `Collection` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major Version that should process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Collection acolWorkObjs,
                                  int aiDecisionServiceTargetMajorVersion,
                                  int aiDecisionServiceTargetMinorVersion)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Similar to `execute(String, Collection, int)` except that the user can specify which Minor Version of the Decision Service should process the request using parameter `aiDecisionServiceTargetVersion`. If the requested version is not currently loaded in the Server then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `acolWorkObjs` - - a `Collection` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
        `aiDecisionServiceTargetMinorVersion` - - the Decision Service Minor version that should process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Map amapWorkObjs)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Equivalent to the method `execute(String, Collection)`, except that a `Map` is passed in instead of a `Collection`. The `Map` contain name-value pairs of business objects. The names will stay intact during processing of the Decision Service. Only the business objects may be updated.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `amapWorkObjs` - - a `Map` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Map amapWorkObjs,
                                  java.util.Date adDecisionServiceEffectiveTimestamp)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Equivalent to the method `execute(String, Collection, Date)`, except that a `Map` is passed in instead of a `Collection`. The `Map` contain name-value pairs of business objects. The names will stay intact during processing of the Decision Service. Only the business objects may be updated.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `amapWorkObjs` - - a `Map` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `adDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection, Date)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Map amapWorkObjs,
                                  java.util.Date adDecisionServiceEffectiveTimestamp,
                                  int aiDecisionServiceTargetMajorVersion)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Equivalent to the method `execute(String, Collection, Date, int)`, except that a `Map` is passed in instead of a `Collection`. The `Map` contain name-value pairs of business objects. The names will stay intact during processing of the Decision Service. Only the business objects may be updated.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `amapWorkObjs` - - a `Map` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `adDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to process this request
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection, Date)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Map acolWorkObjs,
                                  int aiDecisionServiceTargetMajorVersion)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Equivalent to the method `execute(String, Collection, int)`, except that a `Map` is passed in instead of a `Collection`. The `Map` contain name-value pairs of business objects. The names will stay intact during processing of the Decision Service. Only the business objects may be updated.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `amapWorkObjs` - - a `Map` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection, int)`, `execute(String)`

    - #### execute

          ICcRuleMessages execute(java.lang.String astrDecisionServiceName,
                                  java.util.Map acolWorkObjs,
                                  int aiDecisionServiceTargetMajorVersion,
                                  int aiDecisionServiceTargetMinorVersion)
                           throws CcServerDecisionServiceNotRegisteredException,
                                  CcServerEndlessLoopException,
                                  CcServerExecutionException,
                                  CcServerInitializationInProgressException,
                                  CcServerInvalidArgumentException,
                                  CcServerLicenseViolationException,
                                  CcServerTimeoutException

      Equivalent to the method `execute(String, Collection, int, int)`, except that a `Map` is passed in instead of a `Collection`. The `Map` contain name-value pairs of business objects. The names will stay intact during processing of the Decision Service. Only the business objects may be updated.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `amapWorkObjs` - - a `Map` of business objects (e.g. Order#1, LineItem#11, LineItem#12, ...).
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
        `aiDecisionServiceTargetMinorVersion` - - the Decision Service Minor version that should process this request
      Returns:
        ICcRuleMessages - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, Collection, int)`, `execute(String)`

    - #### execute

          org.json.JSONObject execute(org.json.JSONObject ajsonObjectPayload)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Invoke a specific Decision Service by passing in a `JSONObject`.
      A `JSONObject` root contains the following key/value pairs:
      . . . `name` key - refers to the logical decision "Service" name that should process the request.
      . . . `majorVersion` key - the major version of the Decision Service that should process this request. (optional)
      . . . `minorVersion` key - the minor version of the Decision Service that should process this request. (optional)
      . . . `effectiveTarget` key - the effective timestamp the Server should use to process this request. (optional)
      . . . `Objects` key - contains a JSONArray, with each JSONObject in the JSONArray representing an Entity in the payload.
      This method returns a `JSONObject`.
      A `JSONObject` contains the following key/value pairs:
      . . . The same key/value that were contained in the incoming payload (listed above)
      . . . `Messages` key - contains a JSONObject containing the following key/value pairs:
      . . . . . .`Message` key - contains a JSONArray, with each JSONObject in the JSONArray representing a RuleMessages possted against the payload
      . . . . . .`version` key - the version of the Decision Service that was executed against.
      `WorkDocuments` payload contains instances of entities defined in the vocabulary that the decision service is based on. The structure of `WorkDocuments` is described by the XML Schemas as generated by the Corticon Deployment Console for the target decision service.

      Parameters:
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the decision service
      Returns:
        JSONObject - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`

    - #### execute

          org.json.JSONObject execute(org.json.JSONObject ajsonObjectPayload,
                                      com.corticon.services.http.ICcServerHttpInfo aCcServerHttpInfo)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Equivalent to `execute(JSONObject)`, except for this method accepts `ICcServerHttpInfo`
      Parameters:
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the decision service
        `aCcServerHttpInfo` - - ICcServerHttpInfo Object containing http headers information
      Returns:
        JSONObject - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`

    - #### execute

          org.json.JSONObject execute(java.lang.String astrDecisionServiceName,
                                      org.json.JSONObject ajsonObjectPayload)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Deprecated.
      Invoke a specific Decision Service by passing in a `JSONObject`. The server selects the latest effective version of the Decision Service to process the request. If no effective Decision Service is found then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      The `ajsonObjectPayload` is effectively passed-by-reference. Any possible updates by the Decision Service are reflected in `ajsonObjectPayload` after the call. The posted Rule Messages will be added to the JSONObject at the root level.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the decision service
      Returns:
        JSONObject - the Message objects posted during Decision Service processing
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`

    - #### execute

          org.json.JSONObject execute(java.lang.String astrDecisionServiceName,
                                      org.json.JSONObject ajsonObjectPayload,
                                      java.util.Date adDecisionServiceEffectiveTimestamp)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Deprecated.
      Similar to `execute(String, JSONObject)` except that the user can specify what effective timestamp should be using using the parameter `adDecisionServiceEffectiveTimestamp`. This parameter tells the server to assume the request had arrived at a different point in time. This timestamp is used to determine which version of the Decision Service must process the request. If no effective Decision Service is found for the given timestamp then a `CcServerDecisionServiceNotRegisteredException` is thrown. Since no major version number is specified, the CcServer will start at the highest major/minor version Decision Service version and then work backwards to find the first matching Decision Service version.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the Decision Service
        `adDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to process this request
      Returns:
        JSONObject - the updated JSONObject containing all the changes from the execution.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, JSONObject)`

    - #### execute

          org.json.JSONObject execute(java.lang.String astrDecisionServiceName,
                                      org.json.JSONObject ajsonObjectPayload,
                                      java.util.Date adDecisionServiceEffectiveTimestamp,
                                      int aiDecisionServiceTargetMajorVersion)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Deprecated.
      Similar to `execute(String, JSONObject, Date)` except that the user can specify what major version number should be using for the parameter `aiDecisionServiceTargetMajorVersion`. This parameter limits the matching of the Decision Service to also have its Major Version Number equal to `aiDecisionServiceTargetMajorVersion`. If no Decision Service is found that satisfies the `adDecisionServiceEffectiveTimestamp` and `aiDecisionServiceTargetMajorVersion` criteria, then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the Decision Service
        `adDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to process this request
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
      Returns:
        JSONObject - the updated JSONObject containing all the changes from the execution.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, JSONObject)`, `execute(String, JSONObject, Date)`

    - #### execute

          org.json.JSONObject execute(java.lang.String astrDecisionServiceName,
                                      org.json.JSONObject ajsonObjectPayload,
                                      int aiDecisionServiceTargetMajorVersion)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Deprecated.
      Similar to `execute(String, JSONObject)` except that the user can specify which Major Version of the Decision Service should process the request using parameter `aiDecisionServiceTargetVersion`. If the requested version is not currently loaded in the Server then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the Decision Service
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
      Returns:
        JSONObject - the updated JSONObject containing all the changes from the execution.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, JSONObject)`

    - #### execute

          org.json.JSONObject execute(java.lang.String astrDecisionServiceName,
                                      org.json.JSONObject ajsonObjectPayload,
                                      int aiDecisionServiceTargetMajorVersion,
                                      int aiDecisionServiceTargetMinorVersion)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerEndlessLoopException,
                                      CcServerExecutionException,
                                      CcServerInitializationInProgressException,
                                      CcServerInvalidArgumentException,
                                      CcServerLicenseViolationException,
                                      CcServerTimeoutException

      Deprecated.
      Similar to `execute(String, JSONObject, int)` except that the user can specify which Minor Version of the Decision Service should process the request using parameter `aiDecisionServiceTargetVersion`. If the requested version is not currently loaded in the Server then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `ajsonObjectPayload` - - a `JSONObject` containing the data to be processed by the Decision Service
        `aiDecisionServiceTargetMajorVersion` - - the Decision Service Major version that should process this request
        `aiDecisionServiceTargetMinorVersion` - - the Decision Service Minor version that should process this request
      Returns:
        JSONObject - the updated JSONObject containing all the changes from the execution.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerEndlessLoopException`
        `CcServerExecutionException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
        `CcServerTimeoutException`
      See Also:
        `execute(String, JSONObject)`, `execute(String, JSONObject, int)`

    - #### getCcPropertyOverrideSet

          java.util.Set getCcPropertyOverrideSet()

      This will return the property names that are in the CcDebug.properties file inside the CcConfig.jar
      Returns:
        - Set of Property names that are in the CcDebug.properties file

    - #### getCcPropertyValue

          java.lang.String getCcPropertyValue(java.lang.String astrPropertyName)

      Returns a `String` value of any Corticon Property that is inside the CcConfig.jar.
      Returns:
        - String property value

    - #### setCcPropertyValue

          void setCcPropertyValue(java.lang.String astrPropertyName,
                                  java.lang.String astrPropertyValue)
                           throws CcServerInvalidArgumentException

      Sets the property values of limited number of properties that can be changed at runtime. The following properties can be set using this method: `loglevel` `logpath` `logDailyRollover` `logRolloverMaxHistory` `logFiltersAccept` `com.corticon.server.execution.logPerDS`
      Throws:
        `CcServerInvalidArgumentException` - exception thrown when property name or value is not supported or invalid
      See Also:
        `LOG_LEVEL`, `LOG_PATH`, `LOG_ROLLOVER`, `LOG_ROLLOVERS_TO_KEEP`, `LOG_FILTERS_ACCEPT`, `LOG_PER_DS`

    - #### getCcServerInfo

          java.lang.String getCcServerInfo()

      Returns a `String` in XML format that describes the current state of the CcServer. The returned XML String will contain licensing, deployed Decision Services, and transactional information.
      Returns:
        - String in XML format that describes the current state of the CcServer

    - #### getCcServerLicenseValue

          java.lang.String getCcServerLicenseValue(java.lang.String astrPropertyName)
                                            throws CcServerInvalidArgumentException,
                                                   CcServerLicenseViolationException

      Returns a requested Corticon Server License value.
      Parameters:
        `astrPropertyName` - - the license property to be returned:
        LICENSE_OEM_NAME: Registered name of customer associated with the license
        LICENSE_DATE_GRANTED: Date the license was granted
        LICENSE_MAX_POOLS: The max number of Decision Services that can be deployed
        LICENSE_MAX_REACTORS: The max number of Reactor instances inside of each Decision Service Pool
        LICENSE_MAX_NUMBER_OF_RULES: The max number of rules that can be deployed
        LICENSE_DEACTIVATE_DATE: Date that the Server License expires
        LICENSE_DEACTIVATE_DATE_OVERRIDE: Deactivate the license validation determining whether license has expired
        LICENSE_SINGLE_EXECUTION_ENABLED: Allow single non-database execution against a Decision Service
        LICENSE_SINGLE_EXECUTION_DB_ACCESS_ENABLED: Allow single database execution against a Decision Service
        LICENSE_BATCHPROCESSING_ENABLED: Allow database batch processing
        LICENSE_USAGE_ENFORCED: Activate usage validation on each execution
        LICENSE_USAGE_NAME: Name of the Usage associated with the license
        LICENSE_SERVER_IP: Starting approved server IP
        LICENSE_INCREMENT_IP: Increment of the approved server IP
        LICENSE_IP_OVERRIDE: Deactivate server IP validation
        LICENSE_SERVER_TRANSACTIONS_TIME_PERIOD: The time period that limits the number of transactions
        LICENSE_SERVER_TRANSACTIONS_MAX_EXECUTIONS: The number of transactions within a given time period
        LICENSE_SERVER_TRANSACTION_OVERRIDE: Deactivate transaction validation
        LICENSE_NAMED_USERS: List of approved named users for this license
      Returns:
        - String value of the requested property.
      Throws:
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`
      See Also:
        `LICENSE_OEM_NAME`, `LICENSE_DATE_GRANTED`, `LICENSE_MAX_POOLS`, `LICENSE_MAX_REACTORS`, `LICENSE_MAX_NUMBER_OF_RULES`, `LICENSE_DEACTIVATE_DATE`, `LICENSE_DEACTIVATE_DATE_OVERRIDE`, `LICENSE_SINGLE_EXECUTION_ENABLED`, `LICENSE_SINGLE_EXECUTION_DB_ACCESS_ENABLED`, `LICENSE_BATCHPROCESSING_ENABLED`, `#LICENSE_USAGE_ENFORCED`, `#LICENSE_USAGE_NAME`, `LICENSE_SERVER_IP`, `LICENSE_INCREMENT_IP`, `LICENSE_IP_OVERRIDE`, `LICENSE_SERVER_TRANSACTIONS_TIME_PERIOD`, `LICENSE_SERVER_TRANSACTIONS_MAX_EXECUTIONS`, `LICENSE_SERVER_TRANSACTION_OVERRIDE`, `LICENSE_NAMED_USERS`

    - #### getDecisionServiceMajorVersionNumbers

          java.util.List getDecisionServiceMajorVersionNumbers(java.lang.String astrDecisionServiceName)
                                                        throws CcServerDecisionServiceNotRegisteredException

      Returns a `List` of Decision Service Major Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - List of Decision Service Version Integers
      Throws:
        `CcServerDecisionServiceNotRegisteredException`

    - #### getDecisionServiceMajorVersionNumbersFormatted

          java.lang.String getDecisionServiceMajorVersionNumbersFormatted(java.lang.String astrDecisionServiceName)
                                                                   throws CcServerDecisionServiceNotRegisteredException

      Returns a formatted `String` of Decision Service Major Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - Formatted String of Decision Service Version Integers
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
      See Also:
        `getDecisionServiceVersionNumbers(String)`

    - #### getDecisionServiceMinorVersionNumbers

          java.util.List getDecisionServiceMinorVersionNumbers(java.lang.String astrDecisionServiceName,
                                                               int aiDecisionServiceMajorVersion)
                                                        throws CcServerDecisionServiceNotRegisteredException

      Returns a `List` of Decision Service Minor Version Integers that are currently loaded into the Corticon Server for a particular Decision Service with a Major version number `aiDecisionServiceMajorVersion`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
      Returns:
        - List of Decision Service Minor Version Integers
      Throws:
        `CcServerDecisionServiceNotRegisteredException`

    - #### getDecisionServiceMinorVersionNumbersFormatted

          java.lang.String getDecisionServiceMinorVersionNumbersFormatted(java.lang.String astrDecisionServiceName,
                                                                          int aiDecisionServiceMajorVersion)
                                                                   throws CcServerDecisionServiceNotRegisteredException

      Returns a formatted `String` of Decision Service Minor Version Integers that are currently loaded into the Corticon Server for a particular Decision Service with a Major version number `aiDecisionServiceMajorVersion`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
      Returns:
        - Formatted String of Decision Service Version Integers
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
      See Also:
        `getDecisionServiceVersionNumbers(String)`

    - #### getDecisionServiceNames

          java.util.Collection getDecisionServiceNames()

      Returns a `Collection` of Decision Service name Strings that are currently loaded into the Corticon Server.
      Returns:
        - Collection of Decision Service names

    - #### getDecisionServicePropertyValue

          java.lang.String getDecisionServicePropertyValue(java.lang.String astrDecisionServiceName,
                                                           java.lang.String astrPropertyName)
                                                    throws CcServerDecisionServiceNotRegisteredException,
                                                           CcServerInvalidArgumentException

      Invokes `getDecisionServicePropertyValue(astrDecisionServiceName, , astrPropertyName)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrPropertyName` - - the Decision Server property to be returned:
      Returns:
        - String value of the requested property.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServicePropertyValue(String, int, String)`

    - #### getDecisionServicePropertyValue

          java.lang.String getDecisionServicePropertyValue(java.lang.String astrDecisionServiceName,
                                                           int aiDecisionServiceMajorVersion,
                                                           java.lang.String astrPropertyName)
                                                    throws CcServerDecisionServiceNotRegisteredException,
                                                           CcServerInvalidArgumentException

      Invokes `getDecisionServicePropertyValue(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrPropertyName` - - the Decision Server property to be returned:
      Returns:
        - String value of the requested property.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServicePropertyValue(String, int, int, String)`

    - #### getDecisionServicePropertyValue

          java.lang.String getDecisionServicePropertyValue(java.lang.String astrDecisionServiceName,
                                                           int aiDecisionServiceMajorVersion,
                                                           int aiDecisionServiceMinorVersion,
                                                           java.lang.String astrPropertyName)
                                                    throws CcServerDecisionServiceNotRegisteredException,
                                                           CcServerInvalidArgumentException

      Get a particular property value related to a specific Decision Service based on name and major and minor version number.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrPropertyName` - - the Decision Server property to be returned:
      Returns:
        - String value of the requested property.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `PROPERTY_RULEFLOW_URI`, `PROPERTY_RULEFLOW_FILE_TIMESTAMP`, `PROPERTY_EDS_URI`, `PROPERTY_EDS_FILE_TIMESTAMP`, `PROPERTY_DEPLOYMENT_TIMESTAMP`, `PROPERTY_MIN_POOL_SIZE`, `PROPERTY_MAX_POOL_SIZE`, `PROPERTY_AUTO_RELOAD`, `PROPERTY_VERSION_NUMBER`, `PROPERTY_EFFECTIVE_START_DATE`, `PROPERTY_EFFECTIVE_END_DATE`, `PROPERTY_ACTIVE_POOL`, `PROPERTY_LOADED_FROM_CDD`, `PROPERTY_CURRENTLY_RUNNING_IN_BATCH_MODE`, `PROPERTY_REACTORS_CURRENTLY_PROCESSING`, `PROPERTY_REACTORS_WAITING_IN_POOL`, `PROPERTY_NUMBER_OF_RULES_DEPLOYED`, `PROPERTY_MESSAGE_STRUCTURE_TYPE`, `PROPERTY_DATABASE_ACCESS_MODE`, `PROPERTY_DATABASE_ACCESS_PROPERTIES`, `PROPERTY_DATABASE_ACCESS_RETURN_ENTITIES_MODE`, `PROPERTY_DEPLOYED_AS_TEST_DECISION_SERVICE`, `getDecisionServicePropertyValue(String, String)`, `#PROPERTY_EXECUTION_LOG_PATH`, `#PROPERTY_EXECUTION_LOG_LEVEL`, `#PROPERTY_EXECUTION_LOG_PER_THREAD`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION`, `PROPERTY_IS_DEPLOYED`, `PROPERTY_DEPLOYED_RULEFLOW`, `PROPERTY_DEPLOYED_EDS`, `PROPERTY_WSDL`, `PROPERTY_XML_REPORT`, `PROPERTY_LAST_EXECUTION_TIMESTAMP`, `PROPERTY_TOTAL_EXECUTION_COUNT`, `PROPERTY_TOTAL_EXECUTION_TIME`

    - #### setDecisionServicePropertyValue

          void setDecisionServicePropertyValue(java.lang.String astrDecisionServiceName,
                                               java.lang.String astrPropertyName,
                                               java.lang.String astrPropertyValue)
                                        throws CcServerDecisionServiceLoadedFromCddException,
                                               CcServerDecisionServiceNotRegisteredException,
                                               CcServerFileOrDirNotFoundException,
                                               CcServerLicenseViolationException,
                                               CcServerInvalidArgumentException,
                                               CcServerDatabaseValidationException,
                                               CcServerInvalidDecisionServiceException

      Invokes `setDecisionServicePropertyValue(astrDecisionServiceName, , astrPropertyName, astrProperyValue)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrPropertyName` - - the Decision Server property to be changed
        `astrPropertyValue` - - the new Decision Server property value
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `setDecisionServicePropertyValue(String, int, String, String)`

    - #### setDecisionServicePropertyValue

          void setDecisionServicePropertyValue(java.lang.String astrDecisionServiceName,
                                               int aiMajorVersionNumber,
                                               java.lang.String astrPropertyName,
                                               java.lang.String astrPropertyValue)
                                        throws CcServerDecisionServiceLoadedFromCddException,
                                               CcServerDecisionServiceNotRegisteredException,
                                               CcServerFileOrDirNotFoundException,
                                               CcServerLicenseViolationException,
                                               CcServerInvalidArgumentException,
                                               CcServerDatabaseValidationException,
                                               CcServerInvalidDecisionServiceException

      Invokes `setDecisionServicePropertyValue(astrDecisionServiceName, aiMajorVersionNumber, , astrPropertyName, astrProperyValue)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrPropertyName` - - the Decision Server property to be changed
        `astrPropertyValue` - - the new Decision Server property value
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `setDecisionServicePropertyValue(String, int, int, String, String)`

    - #### setDecisionServicePropertyValue

          void setDecisionServicePropertyValue(java.lang.String astrDecisionServiceName,
                                               int aiMajorVersionNumber,
                                               int aiMinorVersionNumber,
                                               java.lang.String astrPropertyName,
                                               java.lang.String astrPropertyValue)
                                        throws CcServerDecisionServiceLoadedFromCddException,
                                               CcServerDecisionServiceNotRegisteredException,
                                               CcServerFileOrDirNotFoundException,
                                               CcServerLicenseViolationException,
                                               CcServerInvalidArgumentException,
                                               CcServerDatabaseValidationException,
                                               CcServerInvalidDecisionServiceException

      Set a new property value related to a specific Decision Service based on name and major and minor version number. The user is only able to dynmically change certain values related to the Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrPropertyName` - - the Decision Server property to be changed
        `astrPropertyValue` - - the new Decision Server property value
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `PROPERTY_RULEASSET_URI`, `PROPERTY_MAX_POOL_SIZE`, `PROPERTY_AUTO_RELOAD`, `PROPERTY_MESSAGE_STRUCTURE_TYPE`, `PROPERTY_DATABASE_ACCESS_MODE`, `PROPERTY_DATABASE_ACCESS_PROPERTIES_PATH`, `PROPERTY_DATABASE_ACCESS_RETURN_ENTITIES_MODE`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION`

    - #### getDecisionServiceStepNumberAndRulesheetActivityNodeNames

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetActivityNodeNames(java.lang.String astrDecisionServiceName)
                                                                                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                                                                                          CcServerInvalidArgumentException

      Invokes `getDecisionServiceStepNumberAndRulesheetActivityNames(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - HashMap containing the step number with the corresponding relative path to the Rulesheet in relation to the Ruleflow file.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(String, int)`

    - #### getDecisionServiceStepNumberAndRulesheetActivityNodeNames

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetActivityNodeNames(java.lang.String astrDecisionServiceName,
                                                                                                                          int aiDecisionServiceMajorVersion)
                                                                                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                                                                                          CcServerInvalidArgumentException

      Invokes `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(String)`

    - #### getDecisionServiceStepNumberAndRulesheetActivityNodeNames

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetActivityNodeNames(java.lang.String astrDecisionServiceName,
                                                                                                                          int aiDecisionServiceMajorVersion,
                                                                                                                          int aiDecisionServiceMinorVersion)
                                                                                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                                                                                          CcServerInvalidArgumentException

      Returns a `HashMap` containing the step number along with the corresponding Rulesheet Activity name for the given Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetActivityNodeNames(String)`

    - #### getDecisionServiceStepNumberAndRulesheetPaths

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetPaths(java.lang.String astrDecisionServiceName)
                                                                                                       throws CcServerDecisionServiceNotRegisteredException,
                                                                                                              CcServerInvalidArgumentException

      Invokes `getDecisionServiceStepNumberAndRulesheetPaths(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetPaths(String, int)`

    - #### getDecisionServiceStepNumberAndRulesheetPaths

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetPaths(java.lang.String astrDecisionServiceName,
                                                                                                              int aiDecisionServiceMajorVersion)
                                                                                                       throws CcServerDecisionServiceNotRegisteredException,
                                                                                                              CcServerInvalidArgumentException

      Invokes `getDecisionServiceStepNumberAndRulesheetPaths(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetPaths(String)`

    - #### getDecisionServiceStepNumberAndRulesheetPaths

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetPaths(java.lang.String astrDecisionServiceName,
                                                                                                              int aiDecisionServiceMajorVersion,
                                                                                                              int aiDecisionServiceMinorVersion)
                                                                                                       throws CcServerDecisionServiceNotRegisteredException,
                                                                                                              CcServerInvalidArgumentException

      Returns a `HashMap` containing the step number along with the corresponding Rulesheet path for the given Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetPaths(String)`

    - #### getDecisionServiceStepNumberAndRulesheetRelativePaths

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetRelativePaths(java.lang.String astrDecisionServiceName)
                                                                                                               throws CcServerDecisionServiceNotRegisteredException,
                                                                                                                      CcServerInvalidArgumentException

      Invokes `getDecisionServiceStepNumberAndRulesheetRelativePaths(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - HashMap containing the step number with the corresponding relative path to the Rulesheet in relation to the Ruleflow file.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetRelativePaths(String, int)`

    - #### getDecisionServiceStepNumberAndRulesheetRelativePaths

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetRelativePaths(java.lang.String astrDecisionServiceName,
                                                                                                                      int aiDecisionServiceMajorVersion)
                                                                                                               throws CcServerDecisionServiceNotRegisteredException,
                                                                                                                      CcServerInvalidArgumentException

      Invokes `getDecisionServiceStepNumberAndRulesheetRelativePaths(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetRelativePaths(String)`

    - #### getDecisionServiceStepNumberAndRulesheetRelativePaths

          java.util.HashMap<java.lang.Integer,java.lang.String> getDecisionServiceStepNumberAndRulesheetRelativePaths(java.lang.String astrDecisionServiceName,
                                                                                                                      int aiDecisionServiceMajorVersion,
                                                                                                                      int aiDecisionServiceMinorVersion)
                                                                                                               throws CcServerDecisionServiceNotRegisteredException,
                                                                                                                      CcServerInvalidArgumentException

      Returns a `HashMap` containing the step number along with the corresponding relative Rulesheet path to the Ruleflow file for the given Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - HashMap containing the step number with the corresponding path to the Rulesheet
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `getDecisionServiceStepNumberAndRulesheetRelativePaths(String)`

    - #### getDecisionServiceVersionNumbers

          java.util.List getDecisionServiceVersionNumbers(java.lang.String astrDecisionServiceName)
                                                   throws CcServerDecisionServiceNotRegisteredException

      Returns a `List` of Decision Service Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - List of Decision Service Version Integers
      Throws:
        `CcServerDecisionServiceNotRegisteredException`

    - #### getDecisionServiceVersionNumbersFormatted

          java.lang.String getDecisionServiceVersionNumbersFormatted(java.lang.String astrDecisionServiceName)
                                                              throws CcServerDecisionServiceNotRegisteredException

      Deprecated. use getDecisionServiceMajorVersionNumbersFormatted(astrDecisionServiceName)
      Returns a formatted `String` of Decision Service Version Integers that are currently loaded into the Corticon Server for a particular Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - Formatted String of Decision Service Version Integers
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
      See Also:
        `getDecisionServiceVersionNumbers(String)`

    - #### getDeploymentDescriptorDirectoryPath

          java.lang.String getDeploymentDescriptorDirectoryPath()

      Returns the current directory that the Maintenance Service looks for new CDD files to be auto-deployed.
      Returns:
        - String path to the directory

    - #### getDeploymentUploadDirectoryPath

          java.lang.String getDeploymentUploadDirectoryPath()

      Returns the current directory that the Server Console will upload pre-compiled .eds or Database property files to the Server.
      Returns:
        - String path to the directory

    - #### getFullyQualifiedPathsForRuleAssets

          java.util.List getFullyQualifiedPathsForRuleAssets(java.lang.String astrDecisionServiceName,
                                                             int aiDecisionServiceMajorVersion,
                                                             int aiDecisionServiceMinorVersion)
                                                      throws CcServerDecisionServiceNotRegisteredException,
                                                             CcServerFileOrDirNotFoundException,
                                                             CcServerInitializationInProgressException,
                                                             CcServerInvalidArgumentException,
                                                             CcServerInvalidDecisionServiceException

      Get a list of fully qualified paths of the Rule Assets related to the Decision Service. If the Decision Service was deployed as an EDS, this method will first unzip the Rule Assets into the CcServerSandbox, and then return the paths.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service
      Returns:
        List - a list of fully qualified paths
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### getFullyQualifiedPathsForRuleAssetsFormatted

          java.lang.String getFullyQualifiedPathsForRuleAssetsFormatted(java.lang.String astrDecisionServiceName,
                                                                        int aiDecisionServiceMajorVersion,
                                                                        int aiDecisionServiceMinorVersion)
                                                                 throws CcServerDecisionServiceNotRegisteredException,
                                                                        CcServerFileOrDirNotFoundException,
                                                                        CcServerInitializationInProgressException,
                                                                        CcServerInvalidArgumentException,
                                                                        CcServerInvalidDecisionServiceException

      Get a list of fully qualified paths of the Rule Assets related to the Decision Service. If the Decision Service was deployed as an EDS, this method will first unzip the Rule Assets into the CcServerSandbox, and then return the paths.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service
      Returns:
        String - a string that contains all the fully qualified paths separated with a ;
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### getJavaHome

          java.lang.String getJavaHome()

      Get the java home for launching java executable when compiling the rules out-of-process.
      Returns:
        Java home, e.g. C:\app\j2sdk1.4.2_01\jre

    - #### getLicensePath

          java.lang.String getLicensePath()

      Get the location of the CcLicense.jar that the CcServer is using.
      Returns:
        String Fully Qualified path to the CcLicense.jar. A null value will be returned if the path has not been specified and the CcLicense.jar is being retrieved from from the Classpath.

    - #### getRegisteredTrackingAttributeBucketDefinition

          java.lang.String getRegisteredTrackingAttributeBucketDefinition(java.lang.String astrDecisionServiceName,
                                                                          int aiDecisionServiceMajorVersion,
                                                                          int aiDecisionServiceMinorVersion,
                                                                          java.lang.String astrRegisteredTrackingAttribute)
                                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                                          CcServerTimeoutException

      Returns a `String` of the Bucket definition. Stored data will be tracked if the Server Results Distribution Monitoring Service has started.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - String value of the Bucket definition
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeBucketDefinition

          java.lang.String getRegisteredTrackingAttributeBucketDefinition(java.lang.String astrDecisionServiceName,
                                                                          int aiDecisionServiceMajorVersion,
                                                                          java.lang.String astrRegisteredTrackingAttribute)
                                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                                          CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeBucketDefinition(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - String value of the Bucket definition
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeBucketDefinition

          java.lang.String getRegisteredTrackingAttributeBucketDefinition(java.lang.String astrDecisionServiceName,
                                                                          java.lang.String astrRegisteredTrackingAttribute)
                                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                                          CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeBucketDefinition(astrDecisionServiceName, , astrRegisteredTrackingAttribute)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - String value of the Bucket defintion
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeCounts

          java.util.List getRegisteredTrackingAttributeCounts(java.lang.String astrDecisionServiceName,
                                                              int aiDecisionServiceMajorVersion,
                                                              int aiDecisionServiceMinorVersion,
                                                              java.lang.String astrRegisteredTrackingAttribute)
                                                       throws CcServerDecisionServiceNotRegisteredException,
                                                              CcServerDecisionServiceTrackingAttributeNotRegisteredException,
                                                              CcServerTimeoutException

      Returns a `List` of `String` values. Each value is a combination of the 'bucket category' and the count associated with that bucket. Stored execution times and data will be tracked if the Server Results Distribution Monitoring Service has started.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - List of String values that contains each 'bucket category' and that associated count with that bucket.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeCounts

          java.util.List getRegisteredTrackingAttributeCounts(java.lang.String astrDecisionServiceName,
                                                              int aiDecisionServiceMajorVersion,
                                                              java.lang.String astrRegisteredTrackingAttribute)
                                                       throws CcServerDecisionServiceNotRegisteredException,
                                                              CcServerDecisionServiceTrackingAttributeNotRegisteredException,
                                                              CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - List of String values that contains each 'bucket category' and that associated count with that bucket.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeCounts

          java.util.List getRegisteredTrackingAttributeCounts(java.lang.String astrDecisionServiceName,
                                                              java.lang.String astrRegisteredTrackingAttribute)
                                                       throws CcServerDecisionServiceNotRegisteredException,
                                                              CcServerDecisionServiceTrackingAttributeNotRegisteredException,
                                                              CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, , astrRegisteredTrackingAttribute)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - List of String values that contains each 'bucket category' and that associated count with that bucket.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeCountsFormatted

          java.lang.String getRegisteredTrackingAttributeCountsFormatted(java.lang.String astrDecisionServiceName,
                                                                         int aiDecisionServiceMajorVersion,
                                                                         int aiDecisionServiceMinorVersion,
                                                                         java.lang.String astrRegisteredTrackingAttribute)
                                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                                         CcServerDecisionServiceTrackingAttributeNotRegisteredException,
                                                                         CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, aiDecisionServiceMajorVersion, aiDecisionServiceMinorVersion, astrRegisteredTrackingAttribute)` and formats the result into a String..
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - Formatted String of String values that contains each 'bucket category' and that associated count with that bucket.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeCountsFormatted

          java.lang.String getRegisteredTrackingAttributeCountsFormatted(java.lang.String astrDecisionServiceName,
                                                                         int aiDecisionServiceMajorVersion,
                                                                         java.lang.String astrRegisteredTrackingAttribute)
                                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                                         CcServerDecisionServiceTrackingAttributeNotRegisteredException,
                                                                         CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, aiDecisionServiceMajorVersion, astrRegisteredTrackingAttribute)` and formats the result into a String..
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - Formatted String of String values that contains each 'bucket category' and that associated count with that bucket.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributeCountsFormatted

          java.lang.String getRegisteredTrackingAttributeCountsFormatted(java.lang.String astrDecisionServiceName,
                                                                         java.lang.String astrRegisteredTrackingAttribute)
                                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                                         CcServerDecisionServiceTrackingAttributeNotRegisteredException,
                                                                         CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributeCounts(astrDecisionServiceName, astrRegisteredTrackingAttribute)` and formats the result into a String..
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
      Returns:
        - Formatted String of String values that contains each 'bucket category' and that associated count with that bucket.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributes

          java.util.List getRegisteredTrackingAttributes(java.lang.String astrDecisionServiceName)
                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                         CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - List of fully qualified Vocabulary attributes.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributes

          java.util.List getRegisteredTrackingAttributes(java.lang.String astrDecisionServiceName,
                                                         int aiDecisionServiceMajorVersion)
                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                         CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Version of the Decision Service to be modified
      Returns:
        - List of fully qualified Vocabulary attributes.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributes

          java.util.List getRegisteredTrackingAttributes(java.lang.String astrDecisionServiceName,
                                                         int aiDecisionServiceMajorVersion,
                                                         int aiDecisionServiceMinorVersion)
                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                         CcServerTimeoutException

      Returns a `List` of `String` values. Each value is a fully qualified Vocabulary attribute. Stored data will be tracked if the Server Results Distribution Monitoring Service has started.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - List of fully qualified Vocabulary attributes.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributesFormatted

          java.lang.String getRegisteredTrackingAttributesFormatted(java.lang.String astrDecisionServiceName)
                                                             throws CcServerDecisionServiceNotRegisteredException,
                                                                    CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName)` and formats the result into a String.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - Formatted String of fully qualified Vocabulary attributes.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributesFormatted

          java.lang.String getRegisteredTrackingAttributesFormatted(java.lang.String astrDecisionServiceName,
                                                                    int aiDecisionServiceMajorVersion)
                                                             throws CcServerDecisionServiceNotRegisteredException,
                                                                    CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, aiDecisionServiceMajorVersion)` and formats the result into a String.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - Formatted String of fully qualified Vocabulary attributes.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRegisteredTrackingAttributesFormatted

          java.lang.String getRegisteredTrackingAttributesFormatted(java.lang.String astrDecisionServiceName,
                                                                    int aiDecisionServiceMajorVersion,
                                                                    int aiDecisionServiceMinorVersion)
                                                             throws CcServerDecisionServiceNotRegisteredException,
                                                                    CcServerTimeoutException

      Invokes `getRegisteredTrackingAttributes(astrDecisionServiceName, aiDecisionServiceMajorVersion, aiDecisionServiceMinorVersion)` and formats the result into a String.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Version of the Decision Service to be modified
      Returns:
        - Formatted String of fully qualified Vocabulary attributes.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`, `stopServerResultsDistributionMonitoringService()`

    - #### getRulesetHtmlReport

          org.jdom.Document getRulesetHtmlReport(java.lang.String astrDecisionServiceName,
                                                 int aiDecisionServiceMajorVersion,
                                                 int aiDecisionServiceMinorVersion,
                                                 java.lang.String astrXsltPath)
                                          throws CcServerDecisionServiceNotRegisteredException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerReportingInvalidDataException

      Returns a `Document` of the Html transformed Report. The raw Xml Report and the Xslt (supplied by astrXsltPath) will be transformed into a return Html Document.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrXsltPath` - - a fully qualified path to an xslt that be used to transform the raw Xml report.
      Returns:
        - Document (Html) of the transformed Xml Report
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `getRulesetHtmlReport(String, String)`

    - #### getRulesetHtmlReport

          org.jdom.Document getRulesetHtmlReport(java.lang.String astrDecisionServiceName,
                                                 int aiDecisionServiceMajorVersion,
                                                 java.lang.String astrXsltPath)
                                          throws CcServerDecisionServiceNotRegisteredException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerReportingInvalidDataException

      Invokes `getRulesetHtmlReport(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrXsltPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrXsltPath` - - a fully qualified path to an xslt that be used to transform the raw Xml report.
      Returns:
        - Document (Html) of the transformed Xml Report
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `getRulesetHtmlReport(String, String)`

    - #### getRulesetHtmlReport

          org.jdom.Document getRulesetHtmlReport(java.lang.String astrDecisionServiceName,
                                                 java.lang.String astrXsltPath)
                                          throws CcServerDecisionServiceNotRegisteredException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerReportingInvalidDataException

      Invokes `getRulesetHtmlReport(astrDecisionServiceName, , astrXsltPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrXsltPath` - - a fully qualified path to an xslt that be used to transform the raw Xml report.
      Returns:
        - Document (Html) of the transformed Xml Report
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `getRulesetHtmlReport(String, int, String)`

    - #### getRulesetMajorVersionNumber

          int getRulesetMajorVersionNumber(java.lang.String astrRulesetAssetPath)
                                    throws CcServerFileOrDirNotFoundException,
                                           CcServerInvalidArgumentException

      Returns the Major Version number that has been associated within the RuleAsset, based on the path to the RuleAsset.
      Parameters:
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Returns:
        - int
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`

    - #### getRulesetMinorVersionNumber

          int getRulesetMinorVersionNumber(java.lang.String astrRulesetAssetPath)
                                    throws CcServerFileOrDirNotFoundException,
                                           CcServerInvalidArgumentException

      Returns the Minor Version number that has been associated within the RuleAsset, based on the path to the RuleAsset.
      Parameters:
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Returns:
        - int
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`

    - #### getRulesetVersionNumber

          int getRulesetVersionNumber(java.lang.String astrRulesetAssetPath)
                               throws CcServerFileOrDirNotFoundException,
                                      CcServerInvalidArgumentException

      Returns the Major Version number that has been associated within the RuleAsset, based on the path to the RuleAsset.
      Parameters:
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Returns:
        - int deprecated - use getRulesetMajorVersionNumber(String)
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`

    - #### getRulesetWSDL

          org.jdom.Document getRulesetWSDL(java.lang.String astrDecisionServiceName)
                                    throws CcServerDecisionServiceNotRegisteredException,
                                           CcServerInvalidArgumentException,
                                           CcServerReportingInvalidDataException

      Deprecated. use getDecisionServicePropertyValue(String, String)
      Invokes `getRulesetWSDL(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - Document of the raw Xml WSDL
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `getRulesetWSDL(String, int)`

    - #### getRulesetWSDL

          org.jdom.Document getRulesetWSDL(java.lang.String astrDecisionServiceName,
                                           int aiDecisionServiceMajorVersion)
                                    throws CcServerDecisionServiceNotRegisteredException,
                                           CcServerInvalidArgumentException,
                                           CcServerReportingInvalidDataException

      Deprecated. use getDecisionServicePropertyValue(String, int, String)
      Invokes `getRulesetWSDL(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - Document of the raw Xml WSDL
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `#getRulesetXmlReport(String, String)`

    - #### getRulesetWSDL

          org.jdom.Document getRulesetWSDL(java.lang.String astrDecisionServiceName,
                                           int aiDecisionServiceMajorVersion,
                                           int aiDecisionServiceMinorVersion)
                                    throws CcServerDecisionServiceNotRegisteredException,
                                           CcServerInvalidArgumentException,
                                           CcServerReportingInvalidDataException

      Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
      Returns a `Document` of the raw Xml WSDL for a particular Decision Service Version.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - Document of the raw Xml WSDL
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `#getRulesetXmlReport(String, String)`

    - #### getRulesetXmlReport

          org.jdom.Document getRulesetXmlReport(java.lang.String astrDecisionServiceName)
                                         throws CcServerDecisionServiceNotRegisteredException,
                                                CcServerInvalidArgumentException,
                                                CcServerReportingInvalidDataException

      Deprecated. use getDecisionServicePropertyValue(String, String)
      Invokes `getRulesetXmlReport(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - Document of the raw Xml Report
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `getRulesetXmlReport(String, int)`

    - #### getRulesetXmlReport

          org.jdom.Document getRulesetXmlReport(java.lang.String astrDecisionServiceName,
                                                int aiDecisionServiceMajorVersion)
                                         throws CcServerDecisionServiceNotRegisteredException,
                                                CcServerInvalidArgumentException,
                                                CcServerReportingInvalidDataException

      Deprecated. use getDecisionServicePropertyValue(String, int, String)
      Invokes `getRulesetXmlReport(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - Document of the raw Xml Report
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `#getRulesetXmlReport(String, String)`

    - #### getRulesetXmlReport

          org.jdom.Document getRulesetXmlReport(java.lang.String astrDecisionServiceName,
                                                int aiDecisionServiceMajorVersion,
                                                int aiDecisionServiceMinorVersion)
                                         throws CcServerDecisionServiceNotRegisteredException,
                                                CcServerInvalidArgumentException,
                                                CcServerReportingInvalidDataException

      Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
      Returns a `Document` of the raw Xml Report for a particular Decision Service Version.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - Document of the raw Xml Report
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerReportingInvalidDataException`
      See Also:
        `#getRulesetXmlReport(String, String)`

    - #### getSandboxDirectoryPath

          java.lang.String getSandboxDirectoryPath()

      Returns the current directory that the Server Sandbox is located. Changes must be made to the CcConfig.jar -> CcServer.properties file before the CcServer has been initialized.
      Returns:
        - String path to the directory

    - #### getCompilationDirectoryPath

          java.lang.String getCompilationDirectoryPath()

      Return the current directory that the Server uses to compile assets. This path is dependent on the SandboxDirectoryPath.
      Returns:
        Sring

    - #### getExecutionRecordingDirectoryPath

          java.lang.String getExecutionRecordingDirectoryPath()

      Return the current directory that the Server uses to store the Execution Recording Service files. This path is dependent on the SandboxDirectoryPath.
      Returns:
        Sring

    - #### getDecisionServiceDirectoryPath

          java.lang.String getDecisionServiceDirectoryPath()

      Return the current directory that the Server uses to store the compiled Decision Services. This path is dependent on the SandboxDirectoryPath.
      Returns:
        Sring

    - #### getDecisionServiceDetails

          java.lang.Object getDecisionServiceDetails(java.lang.String astrDecisionServiceName,
                                                     java.lang.String astrStructureType)
                                              throws CcServerDecisionServiceNotRegisteredException,
                                                     CcServerInvalidArgumentException

      Invokes `getDecisionServiceDetails(astrDecisionServiceName, , astrStructureType)`
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrStructureType` - - output structure, which could be an XML or JSON String
      Returns:
        - String representation of XML or JSON structure of the details of the Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentExceptio`
        `CcServerInvalidArgumentException`

    - #### getDecisionServiceDetails

          java.lang.Object getDecisionServiceDetails(java.lang.String astrDecisionServiceName,
                                                     int aiDecisionServiceMajorVersion,
                                                     java.lang.String astrStructureType)
                                              throws CcServerDecisionServiceNotRegisteredException,
                                                     CcServerInvalidArgumentException

      Invokes `getDecisionServiceDetails(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrStructureType)`
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrStructureType` - - output structure, which could be an XML or JSON String
      Returns:
        - String representation of XML or JSON structure of the details of the Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`

    - #### getDecisionServiceDetails

          java.lang.Object getDecisionServiceDetails(java.lang.String astrDecisionServiceName,
                                                     int aiDecisionServiceMajorVersion,
                                                     int aiDecisionServiceMinorVersion,
                                                     java.lang.String astrStructureType)
                                              throws CcServerDecisionServiceNotRegisteredException,
                                                     CcServerInvalidArgumentException

      Returns the String object representation for the specified decision service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrStructureType` - - output structure, which could be an XML or JSON String
      Returns:
        - String representation of XML or JSON structure of the details of the Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`

    - #### getDecisionServiceDetailsAll

          java.util.ArrayList getDecisionServiceDetailsAll(java.lang.String astrStructureType)
                                                    throws CcServerDecisionServiceNotRegisteredException,
                                                           CcServerInvalidArgumentException

      Invokes `getDecisionServiceDetailsAll(, astrStructureType)`
      Parameters:
        `astrStructureType` - - output structure, which could be an XML or JSON String
      Returns:
        - ArrayList containing a String representation of XML or JSON structure of the details of each Decision Service for this particular name and minor version
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentExceptio`
        `CcServerInvalidArgumentException`

    - #### getDecisionServiceDetailsAll

          java.util.ArrayList getDecisionServiceDetailsAll(java.lang.String astrDecisionServiceName,
                                                           java.lang.String astrStructureType)
                                                    throws CcServerDecisionServiceNotRegisteredException,
                                                           CcServerInvalidArgumentException

      Invokes `getDecisionServiceDetailsAll(astrDecisionServiceName, , astrStructureType)`
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrStructureType` - - output structure, which could be an XML or JSON String
      Returns:
        - ArrayList containing a String representation of XML or JSON structure of the details of each Decision Service for this particular name and minor version
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentExceptio`
        `CcServerInvalidArgumentException`

    - #### getDecisionServiceDetailsAll

          java.util.ArrayList getDecisionServiceDetailsAll(java.lang.String astrDecisionServiceName,
                                                           int aiDecisionServiceMajorVersion,
                                                           java.lang.String astrStructureType)
                                                    throws CcServerDecisionServiceNotRegisteredException,
                                                           CcServerInvalidArgumentException

      Returns the String object representation for the specified decision service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrStructureType` - - output structure, which could be an XML or JSON String
      Returns:
        - ArrayList containing a String representation of XML or JSON structure of the details of each Decision Service for this particular name and minor version
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`

    - #### getLastExecutionTimestamp

          java.lang.Long getLastExecutionTimestamp(java.lang.String astrDecisionServiceName)
                                            throws CcServerDecisionServiceNotRegisteredException,
                                                   CcServerInvalidArgumentException,
                                                   CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, String)
      Invokes `getLastExecutionTimestamp(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - Long The GMT miliseconds of the last execution for this particular Decision Service. Null means that Decision Service has not been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getLastExecutionTimestamp(String, int)`, `getLastExecutionTimestamp(String, int, int)`

    - #### getLastExecutionTimestamp

          java.lang.Long getLastExecutionTimestamp(java.lang.String astrDecisionServiceName,
                                                   int aiDecisionServiceMajorVersion)
                                            throws CcServerDecisionServiceNotRegisteredException,
                                                   CcServerInvalidArgumentException,
                                                   CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, int, String)
      Invokes `getLastExecutionTimestamp(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - Long The GMT miliseconds of the last execution for this particular Decision Service. Null means that Decision Service has not been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getLastExecutionTimestamp(String)`, `getLastExecutionTimestamp(String, int, int)`

    - #### getLastExecutionTimestamp

          java.lang.Long getLastExecutionTimestamp(java.lang.String astrDecisionServiceName,
                                                   int aiDecisionServiceMajorVersion,
                                                   int aiDecisionServiceMinorVersion)
                                            throws CcServerDecisionServiceNotRegisteredException,
                                                   CcServerInvalidArgumentException,
                                                   CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
      Returns a `long` values. The long value will be the Server's timestamp in GMT miliseconds. This allows any potential caller to disaply the value anyway that they want.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - Long The GMT miliseconds of the last execution for this particular Decision Service. Null means that Decision Service has not been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getLastExecutionTimestamp(String)`, `getLastExecutionTimestamp(String, int)`

    - #### getTotalExecutionCount

          long getTotalExecutionCount()
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerInvalidArgumentException,
                                      CcServerTimeoutException

      Returns the total execution count across all Decision Service Versions.
      Returns:
        - long of total times this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String, int)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionCount

          long getTotalExecutionCount(java.lang.String astrDecisionServiceName)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerInvalidArgumentException,
                                      CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, String)
      Invokes `getTotalExecutionCount(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - long of total executions this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String, int)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionCount

          long getTotalExecutionCount(java.lang.String astrDecisionServiceName,
                                      int aiDecisionServiceMajorVersion)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerInvalidArgumentException,
                                      CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, int, String)
      Invokes `getTotalExecutionCount(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - long of total executions this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionCount

          long getTotalExecutionCount(java.lang.String astrDecisionServiceName,
                                      int aiDecisionServiceMajorVersion,
                                      int aiDecisionServiceMinorVersion)
                               throws CcServerDecisionServiceNotRegisteredException,
                                      CcServerInvalidArgumentException,
                                      CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
      Returns a `long` value that is the total number of executions that went against the particular Decision Service version. Stored execution times and data will be tracked if the Server Performance Monitoring Service has started.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - long of total executions this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionTime

          long getTotalExecutionTime()
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerInvalidArgumentException,
                                     CcServerTimeoutException

      Returns the total execution time across all Decision Service Versions.
      Returns:
        - long of total times this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String, int)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionTime

          long getTotalExecutionTime(java.lang.String astrDecisionServiceName)
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerInvalidArgumentException,
                                     CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, String)
      Invokes `getTotalExecutionTime(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - long of total milliseconds this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String, int)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionTime

          long getTotalExecutionTime(java.lang.String astrDecisionServiceName,
                                     int aiDecisionServiceMajorVersion)
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerInvalidArgumentException,
                                     CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, int, String)
      Invokes `getTotalExecutionTime(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - long of total milliseconds this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### getTotalExecutionTime

          long getTotalExecutionTime(java.lang.String astrDecisionServiceName,
                                     int aiDecisionServiceMajorVersion,
                                     int aiDecisionServiceMinorVersion)
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerInvalidArgumentException,
                                     CcServerTimeoutException

      Deprecated. use getDecisionServicePropertyValue(String, int, int, String)
      Returns a `long` value that is the total number of miliseconds that went against the particular Decision Service version. Stored execution times and data will be tracked if the Time and Data Recorder has started.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - long of total milliseconds this Decision Service has been executed against.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `getTotalExecutionCount(String)`, `#getStoredExecutionTimes(String)`, `#getStoredExecutionTimes(String, int)`, `#clearAllCcServerExecutionCounts()`, `#clearAllCcServerStoredExecutionTimes()`, `#clearExecutionCounts(String)`, `#clearExecutionCounts(String, int)`, `#clearStoredExecutionTimes(String)`, `#clearStoredExecutionTimes(String, int)`, `#startServerPerformanceMonitoringService()`, `#stopServerPerformanceMonitoringService()`

    - #### initialize

          void initialize()
                   throws CcServerLicenseViolationException

      Deprecated. Current version of CcServer will automatically initialize itself inside the constructor.
      Initializes the Corticon Server by first reloading the previous state of the Corticon Server.
      Throws:
        `CcServerLicenseViolationException`

    - #### isCDDFileDeployed

          boolean isCDDFileDeployed(java.lang.String astrPathToCddFile)
                             throws CcServerInvalidArgumentException

      Returns a `boolean` based on whether the CDD has been deployed in the CcServer.
      Parameters:
        `astrPathToCddFile` - - path to the .cdd in question
      Returns:
        - boolean , true if .cdd has bee deployed and false if not
      Throws:
        `CcServerInvalidArgumentException`

    - #### isDecisionServiceDeployed

          boolean isDecisionServiceDeployed(java.lang.String astrDecisionServiceName)
                                     throws CcServerInvalidArgumentException

      Invokes `isDecisionServiceDeployed(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
      Returns:
        boolean
      Throws:
        `CcServerInvalidArgumentException`

    - #### isDecisionServiceDeployed

          boolean isDecisionServiceDeployed(java.lang.String astrDecisionServiceName,
                                            java.util.Date adtDecisionServiceEffectiveTimestamp)
                                     throws CcServerInvalidArgumentException

      Query the CcServer to determine is a Decision Service has already been deployed under a specific name
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `adtDecisionServiceEffectiveTimestamp` - - the effective timestamp the Server should use to lookup the Decision Service
      Returns:
        boolean
      Throws:
        `CcServerInvalidArgumentException`

    - #### isDecisionServiceDeployed

          boolean isDecisionServiceDeployed(java.lang.String astrDecisionServiceName,
                                            int aiDecisionServiceMajorVersion)
                                     throws CcServerInvalidArgumentException

      Invokes `isDecisionServiceDeployed(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service
      Returns:
        boolean
      Throws:
        `CcServerInvalidArgumentException`

    - #### isDecisionServiceDeployed

          boolean isDecisionServiceDeployed(java.lang.String astrDecisionServiceName,
                                            int aiDecisionServiceMajorVersion,
                                            int aiDecisionServiceMinorVersion)
                                     throws CcServerInvalidArgumentException

      Query the CcServer to determine is a Decision Service has already been deployed under a specific name and Major Version number and Minor Version number
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service
      Returns:
        boolean
      Throws:
        `CcServerInvalidArgumentException`

    - #### isDecisionServiceDeployedAsTest

          boolean isDecisionServiceDeployedAsTest(java.lang.String astrDecisionServiceName)
                                           throws CcServerDecisionServiceNotRegisteredException,
                                                  CcServerFileOrDirNotFoundException,
                                                  CcServerInitializationInProgressException,
                                                  CcServerInvalidArgumentException

      Inform the caller whether a particular Decision Service is deployed as a Test Decision Service.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
      Returns:
        boolean - true if deployed as Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerFileOrDirNotFoundException`

    - #### isDecisionServiceDeployedAsTest

          boolean isDecisionServiceDeployedAsTest(java.lang.String astrDecisionServiceName,
                                                  int aiDecisionServiceMajorVersion)
                                           throws CcServerDecisionServiceNotRegisteredException,
                                                  CcServerFileOrDirNotFoundException,
                                                  CcServerInitializationInProgressException,
                                                  CcServerInvalidArgumentException

      Inform the caller whether a particular Decision Service is deployed as a Test Decision Service.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service
      Returns:
        boolean - true if deployed as Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerFileOrDirNotFoundException`

    - #### isDecisionServiceDeployedAsTest

          boolean isDecisionServiceDeployedAsTest(java.lang.String astrDecisionServiceName,
                                                  int aiDecisionServiceMajorVersion,
                                                  int aiDecisionServiceMinorVersion)
                                           throws CcServerDecisionServiceNotRegisteredException,
                                                  CcServerFileOrDirNotFoundException,
                                                  CcServerInitializationInProgressException,
                                                  CcServerInvalidArgumentException

      Inform the caller whether a particular Decision Service is deployed as a Test Decision Service.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service that you want to inquire about
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service
      Returns:
        boolean - true if deployed as Test Decision Service
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerFileOrDirNotFoundException`

    - #### isDecisionServiceEdsDeployed

          boolean isDecisionServiceEdsDeployed(java.lang.String astrDecisionServiceName)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerInvalidArgumentException

      Invokes `isDecisionServiceEdsDeployed(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceVersion` - - a specific Version of the Decision Service to be modified
      Returns:
        - boolean , true if Decision Service was deployed as EDS and false if deployed as ERF.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `isDecisionServiceEdsDeployed(String, int)`

    - #### isDecisionServiceEdsDeployed

          boolean isDecisionServiceEdsDeployed(java.lang.String astrDecisionServiceName,
                                               int aiDecisionServiceMajorVersion)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerInvalidArgumentException

      Invokes `isDecisionServiceEdsDeployed(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - boolean , true if Decision Service was deployed as EDS and false if deployed as ERF.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `isDecisionServiceEdsDeployed(String)`

    - #### isDecisionServiceEdsDeployed

          boolean isDecisionServiceEdsDeployed(java.lang.String astrDecisionServiceName,
                                               int aiDecisionServiceMajorVersion,
                                               int aiDecisionServiceMinorVersion)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerInvalidArgumentException

      Returns a `boolean` based on whether the Decision Service version was originally deployed as an EDS file.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - boolean , true if Decision Service was deployed as EDS and false if deployed as ERF.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `isDecisionServiceEdsDeployed(String)`

    - #### isDecisionServiceRuleflowDeployed

          boolean isDecisionServiceRuleflowDeployed(java.lang.String astrDecisionServiceName)
                                             throws CcServerDecisionServiceNotRegisteredException,
                                                    CcServerInvalidArgumentException

      Invokes `isDecisionServiceRuleflowDeployed(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceVersion` - - a specific Version of the Decision Service to be modified
      Returns:
        - boolean , true if Decision Service was deployed as ERF and false if deployed as EDS.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `isDecisionServiceRuleflowDeployed(String, int)`

    - #### isDecisionServiceRuleflowDeployed

          boolean isDecisionServiceRuleflowDeployed(java.lang.String astrDecisionServiceName,
                                                    int aiDecisionServiceMajorVersion)
                                             throws CcServerDecisionServiceNotRegisteredException,
                                                    CcServerInvalidArgumentException

      Invokes `isDecisionServiceRuleflowDeployed(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - boolean , true if Decision Service was deployed as ERF and false if deployed as EDS.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `isDecisionServiceRuleflowDeployed(String)`

    - #### isDecisionServiceRuleflowDeployed

          boolean isDecisionServiceRuleflowDeployed(java.lang.String astrDecisionServiceName,
                                                    int aiDecisionServiceMajorVersion,
                                                    int aiDecisionServiceMinorVersion)
                                             throws CcServerDecisionServiceNotRegisteredException,
                                                    CcServerInvalidArgumentException

      Returns a `boolean` based on whether the Decision Service version was originally deployed as an ERF file.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - boolean , true if Decision Service was deployed as ERF and false if deployed as EDS.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
      See Also:
        `isDecisionServiceRuleflowDeployed(String)`

    - #### isDynamicUpdateMonitoringServiceRunning

          boolean isDynamicUpdateMonitoringServiceRunning()

      See `startDynamicUpdateMonitorService`. See `stopDynamicUpdateMonitorService`.
      Returns:
        - boolean true=service is running and false=service is not
      See Also:
        `startDynamicUpdateMonitoringService()`, `loadFromCdd(String)`, `addDecisionService(String, String, boolean, int, int, String)`

    - #### isServerExecutionTimesIntervalServiceRunning

          boolean isServerExecutionTimesIntervalServiceRunning()

      See `startServerExecutionTimesIntervalService`. See `stopServerExecutionTimesIntervalService`.
      Returns:
        - boolean true=service is running and false=service is not
      See Also:
        `startServerExecutionTimesIntervalService()`

    - #### isServerResultsDistributionMonitoringServiceRunning

          boolean isServerResultsDistributionMonitoringServiceRunning()

      See `startServerResultsDistributionMonitoringService`. See `stopServerResultsDistributionMonitoringService`.
      Returns:
        - boolean true=service is running and false=service is not
      See Also:
        `startServerResultsDistributionMonitoringService()`

    - #### isServerDiagnosticServiceRunning

          boolean isServerDiagnosticServiceRunning()

      See `startServerDiagnosticService`. See `stopServerDiagnosticService`.
      Returns:
        - boolean true=service is running and false=service is not
      See Also:
        `startServerDiagnosticService()`, `stopServerDiagnosticService()`, `isServerDiagnosticServiceRunning()`, `setDiagnosticsEnabled(boolean)`, `setServerDiagnosticsWaitTime(long)`

    - #### loadFromCdd

          void loadFromCdd(java.lang.String astrCddPath)
                    throws CcServerDecisionServiceAlreadyRegisteredException,
                           CcServerFileOrDirNotFoundException,
                           CcServerInvalidArgumentException,
                           CcServerDatabaseValidationException,
                           CcServerInvalidCddException,
                           CcServerInvalidDecisionServiceException,
                           CcServerLicenseViolationException

      Deploys the specified Corticon Deployment Descriptor (CDD). This causes the Corticon Server to initialize a Decision Service pool for each entry in the CDD using the initialization parameters specified (see `addDecisionService` for more details). The CDD is updated as an ATOMic unit. If any of the Decision Services within the CDD fails to initialize, the entire CDD update is rolled back and the pre-update state of the Server is restored. The loaded CDD will continue to be monitored for changes by a Maintenance thread (see `startDynamicUpdateMonitoringService` for more details). `loadFromCdd` can be called to load multiple specific CDDs. To load all CDDs in a directory, use `loadFromCddDir` instead.
      Parameters:
        `astrCddPath` - - the path to the CDD file to be deployed
      Throws:
        `CcServerDecisionServiceAlreadyRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidCddException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `loadFromCddDir(String)`, `addDecisionService(String, String, boolean, int, int, String)`

    - #### loadFromCddDir

          void loadFromCddDir(java.lang.String astrCddDirPath)
                       throws CcServerInvalidArgumentException,
                              CcServerInvalidCddException

      Deploys all decision services in all Corticon Deployment Descriptor (CDD) files in a specified directory. This causes the Corticon Server to initialize, for each decision service, the set of Corticon Engine pools specified in the CDD. The CDD directory will continue to be monitored by a Maintenance thread (see `startDynamicUpdateMonitoringService` method for more details).
      Parameters:
        `astrCddDirPath` - - Path to a directory where .cdd files are located
      Throws:
        `CcServerInvalidArgumentException`
        `CcServerInvalidCddException`
      See Also:
        `loadFromCdd(String)`, `addDecisionService(String, String, boolean, int, int, String)`, `startDynamicUpdateMonitoringService()`

    - #### modifyDecisionServiceAutoReload

          void modifyDecisionServiceAutoReload(java.lang.String astrDecisionServiceName,
                                               boolean abNewAutoReload)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerDecisionServiceLoadedFromCddException,
                                               CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, String, String)
      Invokes `modifyDecisionServiceAutoReload(astrDecisionServiceName, , abNewAutoReload)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `abNewAutoReload` - - set to true if this Corticon Engine pool should conduct a timestamp check to see, if rules have been modified and dynamically reload Decision Service as necessary. See `startDynamicUpdateMonitoringService` for more details.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`

    - #### modifyDecisionServiceAutoReload

          void modifyDecisionServiceAutoReload(java.lang.String astrDecisionServiceName,
                                               int aiDecisionServiceMajorVersion,
                                               boolean abNewAutoReload)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerDecisionServiceLoadedFromCddException,
                                               CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServiceAutoReload(astrDecisionServiceName, aiDecisionServiceMajorVersion, , abNewAutoReload)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `abNewAutoReload` - - set to true if this Corticon Engine pool should conduct a timestamp check to see, if rules have been modified and dynamically reload Decision Service as necessary. See `startDynamicUpdateMonitoringService` for more details.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`

    - #### modifyDecisionServiceAutoReload

          void modifyDecisionServiceAutoReload(java.lang.String astrDecisionServiceName,
                                               int aiDecisionServiceMajorVersion,
                                               int aiDecisionServiceMinorVersion,
                                               boolean abNewAutoReload)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerDecisionServiceLoadedFromCddException,
                                               CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
      Modify the dynamic auto-reload flag for a specific deployed Version of a Decision Service. This method only operates on Decision Services loaded using `addDecisionService`. If a `astrDecisionServiceName` Decision Service is not deployed or the specific `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` is not deployed then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Servie to be modified
        `abNewAutoReload` - - set to true if this Corticon Engine pool should conduct a timestamp check to see, if rules have been modified and dynamically reload Decision Service as necessary. See `startDynamicUpdateMonitoringService` for more details.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`

    - #### modifyDecisionServiceDatabaseAccessProperties

          void modifyDecisionServiceDatabaseAccessProperties(java.lang.String astrDecisionServiceName,
                                                             int aiDecisionServiceMajorVersion,
                                                             int aiDecisionServiceMinorVersion,
                                                             java.lang.String astrNewDatabaseAccessMode,
                                                             java.lang.String astrNewDatabaseAccessReturnEntities,
                                                             java.lang.String astrNewDatabaseAccessPropertiesPath)
                                                      throws CcServerDecisionServiceNotRegisteredException,
                                                             CcServerDecisionServiceLoadedFromCddException,
                                                             CcServerFileOrDirNotFoundException,
                                                             CcServerInvalidArgumentException,
                                                             CcServerDatabaseValidationException,
                                                             CcServerLicenseViolationException

      Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
      Modify the Database Access mode, Returned Entities, and path to Database Access properties file for a specific deployed Version of a Decision Service . This method only operates on Decision Services loaded using `addDecisionService`.

      When the database access is not `DATABASE_ACCESS_NONE`: - if `astrDatabaseAccessPropertiesPath` is null or a connection to the database cannot be established then a `CcServerInvalidArgumentException` is thrown. - if the Decision Service does not have its Work Document Entity specified then a `CcServerInvalidArgumentException` is thrown. - if the Decision Service does not have a valid mapping to the database then a `CcServerInvalidArgumentException` is thrown.

      If a `astrDecisionServiceName` Decision Service is not deployed or the specific `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` is not deployed then a `CcServerDecisionServiceNotRegisteredException` is thrown.

      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Servie to be modified
        `astrNewDatabaseAccessMode` - - this determines the new Database Access mode
        `astrNewDatabaseAccessReturnEntities` - - this determines which entity instances are retruned as part of the response Possible values: DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES, DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES
        `astrNewDynamicDBPropFilePath` - - path to the new JDO runtime properties file containing DB connection info
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
      See Also:
        `DATABASE_ACCESS_NONE`, `DATABASE_ACCESS_READ_ONLY`, `DATABASE_ACCESS_READ_WRITE`, `DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES`, `DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES`

    - #### modifyDecisionServiceDatabaseAccessProperties

          void modifyDecisionServiceDatabaseAccessProperties(java.lang.String astrDecisionServiceName,
                                                             int aiDecisionServiceMajorVersion,
                                                             java.lang.String astrNewDatabaseAccessMode,
                                                             java.lang.String astrNewDatabaseAccessReturnEntities,
                                                             java.lang.String astrNewDatabaseAccessPropertiesPath)
                                                      throws CcServerDecisionServiceNotRegisteredException,
                                                             CcServerDecisionServiceLoadedFromCddException,
                                                             CcServerFileOrDirNotFoundException,
                                                             CcServerInvalidArgumentException,
                                                             CcServerDatabaseValidationException,
                                                             CcServerLicenseViolationException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServiceDatabaseAccessProperties(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrNewDatabaseAccessMode, astrNewDatabaseAccessReturnEntities, astrNewDatabaseAccessPropertiesPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `astrNewDatabaseAccessMode` - - this determines the new Database Access mode
        `astrNewDatabaseAccessReturnEntities` - - this determines which entity instances are retruned as part of the response Possible values: DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES, DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES
        `astrNewDynamicDBPropFilePath` - - path to the new JDO runtime properties file containing DB connection info
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
      See Also:
        `DATABASE_ACCESS_NONE`, `DATABASE_ACCESS_READ_ONLY`, `DATABASE_ACCESS_READ_WRITE`, `DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES`, `DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES`

    - #### modifyDecisionServiceDatabaseAccessProperties

          void modifyDecisionServiceDatabaseAccessProperties(java.lang.String astrDecisionServiceName,
                                                             java.lang.String astrNewDatabaseAccessMode,
                                                             java.lang.String astrNewDatabaseAccessReturnEntities,
                                                             java.lang.String astrNewDatabaseAccessPropertiesPath)
                                                      throws CcServerDecisionServiceNotRegisteredException,
                                                             CcServerDecisionServiceLoadedFromCddException,
                                                             CcServerFileOrDirNotFoundException,
                                                             CcServerInvalidArgumentException,
                                                             CcServerDatabaseValidationException,
                                                             CcServerLicenseViolationException

      Deprecated. use setDecisionServicePropertyValue(String, String, String)
      Invokes `modifyDecisionServiceDatabaseAccessProperties(astrDecisionServiceName, , astrNewDatabaseAccessMode, astrNewDatabaseAccessReturnEntities, astrNewDatabaseAccessPropertiesPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrNewDatabaseAccessMode` - - this determines the new Database Access mode
        `astrNewDatabaseAccessReturnEntities` - - this determines which entity instances are retruned as part of the response Possible values: DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES, DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES
        `astrNewDynamicDBPropFilePath` - - path to the new JDO runtime properties file containing DB connection info
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerLicenseViolationException`
      See Also:
        `DATABASE_ACCESS_NONE`, `DATABASE_ACCESS_READ_ONLY`, `DATABASE_ACCESS_READ_WRITE`, `DATABASE_ACCESS_RETURN_ALL_ENTITY_INSTANCES`, `DATABASE_ACCESS_RETURN_INCOMING_NEW_ENTITY_INSTANCES`

    - #### modifyDecisionServiceMessageStructType

          void modifyDecisionServiceMessageStructType(java.lang.String astrDecisionServiceName,
                                                      int aiDecisionServiceMajorVersion,
                                                      int aiDecisionServiceMinorVersion,
                                                      java.lang.String astrNewMsgStructStyle)
                                               throws CcServerDecisionServiceNotRegisteredException,
                                                      CcServerDecisionServiceLoadedFromCddException,
                                                      CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
      Modify the XML message style for a specific deployed Version of a Decision Service. This method only operates on Decision Services loaded using `addDecisionService`.

      If a `astrDecisionServiceName` Decision Service is not deployed or the specific `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` is not deployed then a `CcServerDecisionServiceNotRegisteredException` is thrown.

      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Version of the Decision Servie to be modified
        `astrNewMsgStructStyle` - - type of XML Message used for the payload containing business object data. One of three values: XML_FLAT_STYLE, XML_HIER_STYLE, XML_STYLE_AUTODETECT (default)
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `XML_FLAT_STYLE`, `XML_HIER_STYLE`, `XML_STYLE_AUTODETECT`

    - #### modifyDecisionServiceMessageStructType

          void modifyDecisionServiceMessageStructType(java.lang.String astrDecisionServiceName,
                                                      int aiDecisionServiceMajorVersion,
                                                      java.lang.String astrNewMsgStructStyle)
                                               throws CcServerDecisionServiceNotRegisteredException,
                                                      CcServerDecisionServiceLoadedFromCddException,
                                                      CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServiceMessageStructType(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrNewMsgStructStyle)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific MajorVersion of the Decision Servie to be modified
        `astrNewMsgStructStyle` - - type of XML Message used for the payload containing business object data. One of three values: XML_FLAT_STYLE, XML_HIER_STYLE, XML_STYLE_AUTODETECT (default)
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `XML_FLAT_STYLE`, `XML_HIER_STYLE`, `XML_STYLE_AUTODETECT`

    - #### modifyDecisionServiceMessageStructType

          void modifyDecisionServiceMessageStructType(java.lang.String astrDecisionServiceName,
                                                      java.lang.String astrNewMsgStructStyle)
                                               throws CcServerDecisionServiceNotRegisteredException,
                                                      CcServerDecisionServiceLoadedFromCddException,
                                                      CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, String, String)
      Invokes `modifyDecisionServiceMessageStructType(astrDecisionServiceName, , astrNewMsgStructStyle)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrNewMsgStructStyle` - - type of XML Message used for the payload containing business object data. One of three values: XML_FLAT_STYLE, XML_HIER_STYLE, XML_STYLE_AUTODETECT (default)
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `XML_FLAT_STYLE`, `XML_HIER_STYLE`, `XML_STYLE_AUTODETECT`

    - #### modifyDecisionServicePoolSizes

          void modifyDecisionServicePoolSizes(java.lang.String astrDecisionServiceName,
                                              int aiNewMinPoolSize,
                                              int aiNewMaxPoolSize)
                                       throws CcServerDecisionServiceNotRegisteredException,
                                              CcServerDecisionServiceLoadedFromCddException,
                                              CcServerLicenseViolationException,
                                              CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServicePoolSizes(astrDecisionServiceName, , aiNewMinPoolSize, aiNewMaxPoolSize)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiNewMinPoolSize` - - number of Corticon Engine instances to initialize the pool with
        `aiNewMaxPoolSize` - - the maximum number of Corticon Engine instances the pool can grow to
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`

    - #### modifyDecisionServicePoolSizes

          void modifyDecisionServicePoolSizes(java.lang.String astrDecisionServiceName,
                                              int aiDecisionServiceMajorVersion,
                                              int aiNewMinPoolSize,
                                              int aiNewMaxPoolSize)
                                       throws CcServerDecisionServiceNotRegisteredException,
                                              CcServerDecisionServiceLoadedFromCddException,
                                              CcServerLicenseViolationException,
                                              CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServicePoolSizes(astrDecisionServiceName, aiDecisionServiceMajorVersion, , aiNewMinPoolSize, aiNewMaxPoolSize)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Version of the Decision Servie to be modified
        `aiNewMinPoolSize` - - number of Corticon Engine instances to initialize the pool with
        `aiNewMaxPoolSize` - - the maximum number of Corticon Engine instances the pool can grow to
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`

    - #### modifyDecisionServicePoolSizes

          void modifyDecisionServicePoolSizes(java.lang.String astrDecisionServiceName,
                                              int aiDecisionServiceMajorVersion,
                                              int aiDecisionServiceMinorVersion,
                                              int aiNewMinPoolSize,
                                              int aiNewMaxPoolSize)
                                       throws CcServerDecisionServiceNotRegisteredException,
                                              CcServerDecisionServiceLoadedFromCddException,
                                              CcServerLicenseViolationException,
                                              CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
      Modify the min and max pool sizes for a specific deployed Version of a Decision Service. This method only operates on Decision Services loaded using `addDecisionService`.

      If a `astrDecisionServiceName` Decision Service is not deployed or the specific `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` is not deployed then a `CcServerDecisionServiceNotRegisteredException` is thrown.

      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Servie to be modified
        `aiNewMinPoolSize` - - number of Corticon Engine instances to initialize the pool with
        `aiNewMaxPoolSize` - - the maximum number of Corticon Engine instances the pool can grow to
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`

    - #### modifyDecisionServiceRuleAssetPath

          void modifyDecisionServiceRuleAssetPath(java.lang.String astrDecisionServiceName,
                                                  int aiDecisionServiceMajorVersion,
                                                  int aiDecisionServiceMinorVersion,
                                                  java.lang.String astrNewRuleAssetPath)
                                           throws CcServerDecisionServiceLoadedFromCddException,
                                                  CcServerDecisionServiceNotRegisteredException,
                                                  CcServerFileOrDirNotFoundException,
                                                  CcServerLicenseViolationException,
                                                  CcServerInvalidArgumentException,
                                                  CcServerDatabaseValidationException,
                                                  CcServerInvalidDecisionServiceException

      Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
      Modify the path to the source Ruleflow .erf or .pre-compiled eds file for a specific deployed Version of a Decision Service. This method only operates on Decision Services loaded using `addDecisionService`.

      If a `astrDecisionServiceName` Decision Service is not deployed or the specific `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` is not deployed then a `CcServerDecisionServiceNotRegisteredException` is thrown. If the .erf or .eds file pointed to by `astrNewRuleAssetPath` has a version number that is different than `aiDecisionServiceVersion` then the update is rejected and a `CcServerInvalidDecisionServiceException` is thrown.

      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrNewRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`

    - #### modifyDecisionServiceRuleAssetPath

          void modifyDecisionServiceRuleAssetPath(java.lang.String astrDecisionServiceName,
                                                  int aiDecisionServiceMajorVersion,
                                                  java.lang.String astrNewRuleAssetPath)
                                           throws CcServerDecisionServiceLoadedFromCddException,
                                                  CcServerDecisionServiceNotRegisteredException,
                                                  CcServerFileOrDirNotFoundException,
                                                  CcServerLicenseViolationException,
                                                  CcServerInvalidArgumentException,
                                                  CcServerDatabaseValidationException,
                                                  CcServerInvalidDecisionServiceException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrNewRuleAssetPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrNewRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`

    - #### modifyDecisionServiceRuleAssetPath

          void modifyDecisionServiceRuleAssetPath(java.lang.String astrDecisionServiceName,
                                                  java.lang.String astrNewRuleAssetPath)
                                           throws CcServerDecisionServiceLoadedFromCddException,
                                                  CcServerDecisionServiceNotRegisteredException,
                                                  CcServerFileOrDirNotFoundException,
                                                  CcServerLicenseViolationException,
                                                  CcServerInvalidArgumentException,
                                                  CcServerDatabaseValidationException,
                                                  CcServerInvalidDecisionServiceException

      Deprecated. use setDecisionServicePropertyValue(String, String, String)
      Invokes `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, , astrNewRuleAssetPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrNewRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`

    - #### modifyDecisionServiceExecutionProperty

          void modifyDecisionServiceExecutionProperty(java.lang.String astrDecisionServiceName,
                                                      java.lang.String astrPropertyName,
                                                      java.lang.String astrPropertyValue)
                                               throws CcServerDecisionServiceNotRegisteredException,
                                                      CcServerDecisionServiceLoadedFromCddException,
                                                      CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, String, String)
      Invokes `modifyDecisionServiceExecutionProperty(astrDecisionServiceName, , astrNewLogPath, astrNewLogLevel, astrNewLogSeverity, abLogPerThreadName)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrPropertyName` - - the desired property to be changed.
        `astrPropertyValue` - - the desired value to be changed.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION`

    - #### modifyDecisionServiceExecutionProperty

          void modifyDecisionServiceExecutionProperty(java.lang.String astrDecisionServiceName,
                                                      int aiDecisionServiceMajorVersion,
                                                      java.lang.String astrPropertyName,
                                                      java.lang.String astrPropertyValue)
                                               throws CcServerDecisionServiceNotRegisteredException,
                                                      CcServerDecisionServiceLoadedFromCddException,
                                                      CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, String, String)
      Invokes `modifyDecisionServiceExecutionLoggingParameters(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrNewLogPath, astrNewLogLevel, astrNewLogSeverity, abLogPerThreadName)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `astrPropertyName` - - the desired property to be changed.
        `astrPropertyValue` - - the desired value to be changed.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION`

    - #### modifyDecisionServiceExecutionProperty

          void modifyDecisionServiceExecutionProperty(java.lang.String astrDecisionServiceName,
                                                      int aiDecisionServiceMajorVersion,
                                                      int aiDecisionServiceMinorVersion,
                                                      java.lang.String astrPropertyName,
                                                      java.lang.String astrPropertyValue)
                                               throws CcServerDecisionServiceNotRegisteredException,
                                                      CcServerDecisionServiceLoadedFromCddException,
                                                      CcServerInvalidArgumentException

      Deprecated. use setDecisionServicePropertyValue(String, int, int, String, String)
      Modify a Decision Service's execution property for a specific deployed Version of a Decision Service. This method only operates on Decision Services loaded using `addDecisionService`. If a `astrDecisionServiceName` Decision Service is not deployed or the specific `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` is not deployed then a `CcServerDecisionServiceNotRegisteredException` is thrown.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Servie to be modified
        `astrPropertyName` - - the desired property to be changed.
        `astrPropertyValue` - - the desired value to be changed.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_INFO`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_WARNING`, `PROPERTY_EXECUTION_RESTRICT_RULEMESSAGES_VIOLATION`

    - #### modifyDecisionServiceRuleflowPath

          void modifyDecisionServiceRuleflowPath(java.lang.String astrDecisionServiceName,
                                                 int aiDecisionServiceVersion,
                                                 java.lang.String astrRuleAssetPath)
                                          throws CcServerDecisionServiceLoadedFromCddException,
                                                 CcServerDecisionServiceNotRegisteredException,
                                                 CcServerFileOrDirNotFoundException,
                                                 CcServerLicenseViolationException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerDatabaseValidationException,
                                                 CcServerInvalidDecisionServiceException

      Deprecated. Please use `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, aiDecisionServiceVersion>, astrRuleAssetPath)` instead.
      Invokes `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, aiDecisionServiceVersion, astrRuleAssetPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceVersion` - - a specific Version of the Decision Service to be modified
        `astrRuleAssetPath` - - path to the Ruleflow .erf or pre-compiled .eds file containing the Decision Service rules.
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `#addDecisionService(String, String, boolean, int, int, String, String)`

    - #### modifyDecisionServiceRuleflowPath

          void modifyDecisionServiceRuleflowPath(java.lang.String astrDecisionServiceName,
                                                 java.lang.String astrNewRuleAssetPath)
                                          throws CcServerDecisionServiceLoadedFromCddException,
                                                 CcServerDecisionServiceNotRegisteredException,
                                                 CcServerFileOrDirNotFoundException,
                                                 CcServerLicenseViolationException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerDatabaseValidationException,
                                                 CcServerInvalidDecisionServiceException

      Deprecated. Please use `modifyDecisionServiceRuleAssetPath(astrDecisionServiceName, astrNewRuleAssetPath)` instead.
      Invokes `modifyDecisionServiceRuleflowPath(astrDecisionServiceName, , astrNewRuleAssetPath)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrNewRuleAssetPath` - - path to the Ruleflow .erf or .eds file containing the Decision Service rules.
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `#addDecisionService(String, String, boolean, int, int, String, String)`

    - #### precompileDecisionService

          java.lang.String precompileDecisionService(java.lang.String astrRuleflowPath,
                                                     java.lang.String astrDecisionServiceName,
                                                     java.lang.String astrOutputPath,
                                                     boolean abOverwriteFile)
                                              throws CcServerFileOrDirNotFoundException,
                                                     CcServerInvalidArgumentException,
                                                     CcServerInvalidDecisionServiceException

      Pre-compiles the give Ruleflow into a deployment unit (EDS) which is written to the output directory.
      Parameters:
        `astrRuleflowPath` - - path to the Ruleflow .erf file.
        `astrDecisionServiceName` - – logical name of the Decision Service
        `astrOutputPath` - - path to directory where the EDS file is written to
        `abOverwriteFile` - – if true, overwrites existing EDS file should a name conflict occur - if false, throws CcDeployFileOrDirNotFoundException should a name conflict occur
      Returns:
        fully qualified path to the newly generated EDS file
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### precompileDecisionService

          java.lang.String precompileDecisionService(java.lang.String astrRuleflowPath,
                                                     java.lang.String astrDecisionServiceName,
                                                     java.lang.String astrOutputPath,
                                                     java.lang.String astrDatabaseAccessMode,
                                                     boolean abOverwriteFile)
                                              throws CcServerFileOrDirNotFoundException,
                                                     CcServerInvalidArgumentException,
                                                     CcServerInvalidDecisionServiceException

      Pre-compiles the give Ruleflow into a deployment unit (EDS) which is written to the output directory.
      Parameters:
        `astrRuleflowPath` - - path to the Ruleflow .erf file.
        `astrDecisionServiceName` - – logical name of the Decision Service
        `astrOutputPath` - - path to directory where the EDS file is written to
        `astrDatabaseAccessMode` - – String which will be the Database Access Mode to be used during compile
        `abOverwriteFile` - – if true, overwrites existing EDS file should a name conflict occur - if false, throws CcDeployFileOrDirNotFoundException should a name conflict occur
      Returns:
        fully qualified path to the newly generated EDS file
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### precompileDecisionService

          java.lang.String precompileDecisionService(java.lang.String astrRuleflowPath,
                                                     java.lang.String astrDecisionServiceName,
                                                     java.lang.String astrOutputPath,
                                                     java.lang.String astrDatabaseAccessMode,
                                                     boolean abOverwriteFile,
                                                     java.util.Set<java.lang.String> asetDependentJars,
                                                     java.util.Set<java.lang.String> asetIncludedJars)
                                              throws CcServerFileOrDirNotFoundException,
                                                     CcServerInvalidArgumentException,
                                                     CcServerInvalidDecisionServiceException

      Pre-compiles the give Ruleflow into a deployment unit (EDS) which is written to the output directory.
      Parameters:
        `astrRuleflowPath` - - path to the Ruleflow .erf file.
        `astrDecisionServiceName` - – logical name of the Decision Service
        `astrOutputPath` - - path to directory where the EDS file is written to
        `astrDatabaseAccessMode` - – String which will be the Database Access Mode to be used during compile
        `abOverwriteFile` - – if true, overwrites existing EDS file should a name conflict occur - if false, throws CcDeployFileOrDirNotFoundException should a name conflict occur
        `asetDependentJars` - - the set of jar file paths that the compilation needs to successfully compile. - examples would include Business Object jars or 3rd party jars that a Service Callout needs
        `asetIncludedJars` - - the set of jar files that will be added to the compiled .eds file - examples would include Business Object jars or 3rd party jars that a Service Callout needs
      Returns:
        fully qualified path to the newly generated EDS file
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### promoteTestDecisionService

          void promoteTestDecisionService(java.lang.String astrDecisionServiceName)
                                   throws CcServerDecisionServiceNotRegisteredException,
                                          CcServerInvalidArgumentException,
                                          CcServerInvalidDecisionServiceException

      Invokes `promoteTestDecisionService(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceVersion` - - a specific Version of the Decision Service to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `promoteTestDecisionService(String, int)`

    - #### promoteTestDecisionService

          void promoteTestDecisionService(java.lang.String astrDecisionServiceName,
                                          int aiDecisionServiceMajorVersion)
                                   throws CcServerDecisionServiceNotRegisteredException,
                                          CcServerInvalidArgumentException,
                                          CcServerInvalidDecisionServiceException

      Invokes `promoteTestDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `promoteTestDecisionService(String)`

    - #### promoteTestDecisionService

          void promoteTestDecisionService(java.lang.String astrDecisionServiceName,
                                          int aiDecisionServiceMajorVersion,
                                          int aiDecisionServiceMinorVersion)
                                   throws CcServerDecisionServiceNotRegisteredException,
                                          CcServerInvalidArgumentException,
                                          CcServerInvalidDecisionServiceException

      Promotes a Test Decision Service to be a live.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `promoteTestDecisionService(String)`

    - #### redeployDecisionServiceUsingExistingModel

          void redeployDecisionServiceUsingExistingModel(java.lang.String astrDecisionServiceName)
                                                  throws CcServerDecisionServiceNotRegisteredException,
                                                         CcServerLicenseViolationException,
                                                         CcServerInvalidArgumentException,
                                                         CcServerDatabaseValidationException,
                                                         CcServerInvalidDecisionServiceException

      This will redeploy the Decision Service using the existing model assigned to the Decision Service Name. This can only be used by the TestsheetTreeSetModelAPI to redeploy an existing Decision Service. If called outside of the TestsheetTreeSetModelAPI, an CcServerInvalidDecisionServiceException will be thrown.
      Parameters:
        `astrDecisionServiceName` - - Logical name of the Decision Service (and thus corresponding Corticon Engine pool).
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`

    - #### registerTrackingAttribute

          void registerTrackingAttribute(java.lang.String astrDecisionServiceName,
                                         int aiDecisionServiceMajorVersion,
                                         int aiDecisionServiceMinorVersion,
                                         java.lang.String astrRegisteredTrackingAttribute,
                                         java.lang.String astrBucketString)
                                  throws CcServerDecisionServiceNotRegisteredException,
                                         CcServerDecisionServiceTrackingAttributeAlreadyRegisteredException,
                                         CcServerInvalidArgumentException,
                                         CcServerTimeoutException

      Registers a particular attribute in Corticon Data Monitoring subsystem. This subsystem can keep counts or result values for each of the 'buckets' defined in the astrBucketString.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
        `astrBucketString` - - bucket definitions.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeAlreadyRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `stopServerResultsDistributionMonitoringService()`, `startServerResultsDistributionMonitoringService()`

    - #### registerTrackingAttribute

          void registerTrackingAttribute(java.lang.String astrDecisionServiceName,
                                         int aiDecisionServiceMajorVersion,
                                         java.lang.String astrRegisteredTrackingAttribute,
                                         java.lang.String astrBucketString)
                                  throws CcServerDecisionServiceNotRegisteredException,
                                         CcServerDecisionServiceTrackingAttributeAlreadyRegisteredException,
                                         CcServerInvalidArgumentException,
                                         CcServerTimeoutException

      Invokes `registerTrackingAttribute(astrDecisionServiceName, aiDecisionServiceMajorVersion, , astrRegisteredTrackingAttribute, astrBucketString)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
        `astrBucketString` - - bucket definitions.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeAlreadyRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `stopServerResultsDistributionMonitoringService()`, `startServerResultsDistributionMonitoringService()`

    - #### registerTrackingAttribute

          void registerTrackingAttribute(java.lang.String astrDecisionServiceName,
                                         java.lang.String astrRegisteredTrackingAttribute,
                                         java.lang.String astrBucketString)
                                  throws CcServerDecisionServiceNotRegisteredException,
                                         CcServerDecisionServiceTrackingAttributeAlreadyRegisteredException,
                                         CcServerInvalidArgumentException,
                                         CcServerTimeoutException

      Invokes `registerTrackingAttribute(astrDecisionServiceName, , astrRegisteredTrackingAttribute, String astrRegisteredAttributeType, String astrBucketString)`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `astrRegisteredTrackingAttribute` - - fully qualified vocabulary attribute name.
        `astrBucketString` - - bucket definitions.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceTrackingAttributeAlreadyRegisteredException`
        `CcServerInvalidArgumentException`
        `CcServerTimeoutException`
      See Also:
        `registerTrackingAttribute(String, int , String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `stopServerResultsDistributionMonitoringService()`, `startServerResultsDistributionMonitoringService()`

    - #### reloadDecisionService

          void reloadDecisionService(java.lang.String astrDecisionServiceName)
                              throws CcServerDecisionServiceLoadedFromCddException,
                                     CcServerDecisionServiceNotRegisteredException,
                                     CcServerFileOrDirNotFoundException,
                                     CcServerInvalidArgumentException,
                                     CcServerDatabaseValidationException,
                                     CcServerInvalidDecisionServiceException,
                                     CcServerLicenseViolationException

      Invokes `reloadDecisionService(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `stopDynamicUpdateMonitoringService()`

    - #### reloadDecisionService

          void reloadDecisionService(java.lang.String astrDecisionServiceName,
                                     int aiDecisionServiceVersion)
                              throws CcServerDecisionServiceLoadedFromCddException,
                                     CcServerDecisionServiceNotRegisteredException,
                                     CcServerFileOrDirNotFoundException,
                                     CcServerInvalidArgumentException,
                                     CcServerDatabaseValidationException,
                                     CcServerInvalidDecisionServiceException,
                                     CcServerLicenseViolationException

      Invokes `reloadDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `aiDecisionServiceVersion` - - a specific Version of the Decision Servie to be modified
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `stopDynamicUpdateMonitoringService()`

    - #### reloadDecisionService

          void reloadDecisionService(java.lang.String astrDecisionServiceName,
                                     int aiDecisionServiceMajorVersion,
                                     int aiDecisionServiceMinorVersion)
                              throws CcServerDecisionServiceLoadedFromCddException,
                                     CcServerDecisionServiceNotRegisteredException,
                                     CcServerFileOrDirNotFoundException,
                                     CcServerInvalidArgumentException,
                                     CcServerDatabaseValidationException,
                                     CcServerInvalidDecisionServiceException,
                                     CcServerLicenseViolationException

      Reload a specific deployed Major Version and Minor Version of a Decision Service. This method is used to control dynamic updates of the Decision Service. The client may consider turning off the dynamic update monitoring service when using this method.
      Parameters:
        `astrDecisionServiceName` - - name of the Decision Service and thus corresponding Corticon Engine pool to use.
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Servie to be modified
      Throws:
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`
        `CcServerDatabaseValidationException`
        `CcServerInvalidDecisionServiceException`
        `CcServerLicenseViolationException`
      See Also:
        `stopDynamicUpdateMonitoringService()`

    - #### removeDecisionService

          void removeDecisionService(java.lang.String astrDecisionServiceName)
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerDecisionServiceLoadedFromCddException,
                                     CcServerInvalidArgumentException

      Invokes `removeDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - Name of the Decision Service to be removed from the server.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `addDecisionService(String, String, boolean, int, int, String)`

    - #### removeDecisionService

          void removeDecisionService(java.lang.String astrDecisionServiceName,
                                     int aiDecisionServiceMajorVersion)
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerDecisionServiceLoadedFromCddException,
                                     CcServerInvalidArgumentException

      Invokes `removeDecisionService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - Name of the Decision Service to be removed from the server.
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `addDecisionService(String, String, boolean, int, int, String)`

    - #### removeDecisionService

          void removeDecisionService(java.lang.String astrDecisionServiceName,
                                     int aiDecisionServiceMajorVersion,
                                     int aiDecisionServiceMinorVersion)
                              throws CcServerDecisionServiceNotRegisteredException,
                                     CcServerDecisionServiceLoadedFromCddException,
                                     CcServerInvalidArgumentException

      Removes version `aiDecisionServiceMajorVersion` and `aiDecisionServiceMinorVersion` of Decision Service `astrDecisionServiceName` and all associated Corticon Engines in its pool (if any). This method only operates on Decision Services loaded using `addDecisionService`.
      Parameters:
        `astrDecisionServiceName` - - Name of the Decision Service to be removed from the server.
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Servie to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Servie to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`
      See Also:
        `addDecisionService(String, String, boolean, int, int, String)`

    - #### setDeploymentDescriptorDirectoryPath

          void setDeploymentDescriptorDirectoryPath(java.lang.String astrDeploymentDirectoryPath)
                                             throws CcServerFileOrDirNotFoundException,
                                                    CcServerInvalidArgumentException

      Sets the current directory that the Maintenance Service looks for new CDD files to be auto-deployed.
      Parameters:
        `astrDeploymentDirectoryPath` - - Path to a directory
      Throws:
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`

    - #### setJavaHome

          void setJavaHome(java.lang.String astrJavaHome)

      Set the java home that will be used to locate java executable for compiling the rules out-of-process. By default, system java home is used, that is, the java home used by the JVM where this code is executing.
      Parameters:
        `astrJavaHome` - Java home, e.g. C:\app\j2sdk1.4.2_01\jre

    - #### setLicensePath

          void setLicensePath(java.lang.String astrLicensePath)
                       throws CcServerLicenseViolationException

      Set the location of the CcLicense.jar that the CcServer should use.
      Parameters:
        `astrLicensePath` - Fully Qualified path to the CcLicense.jar
      Throws:
        `CcServerLicenseViolationException`

    - #### setLogLevel

          void setLogLevel(java.lang.String astrLogPath)
                    throws CcServerInvalidArgumentException

      Sets the Log level for the server.
      Parameters:
        `astrLogLevel` - - the log level:
        LOG_LEVEL_DEBUG: All messages are logged, including debugging info
        LOG_LEVEL_INFO: All messages except debugging messages are logged
        LOG_LEVEL_DIAGNOSTIC: Only Diagnostic messages and Exceptions are logged
        LOG_LEVEL_VIOLATION: Only Exceptions are logged
      Throws:
        `CcServerInvalidArgumentException`
      See Also:
        `#LOG_LEVEL_DEBUG`, `#LOG_LEVEL_INFO`, `#LOG_LEVEL_DIANOSTIC`, `#LOG_LEVEL_VIOLATION`

    - #### setLogPath

          void setLogPath(java.lang.String astrLogPath)
                   throws CcServerInvalidArgumentException

      Sets the path for the Corticon Server log files. The Corticon Server log is a trace of Corticon Server activity and is distinct from Messages that result from rule actions. Note: the default path is in %corticon_base%\log
      Parameters:
        `astrLogPath` - - path to the directory where log files are written
      Throws:
        `CcServerInvalidArgumentException`

    - #### setServerExecutionTimesIntervalTime

          void setServerExecutionTimesIntervalTime(long alInterval)

      Change the interval time that the Server Execution Times Interval Service uses to determine when to record interval values.
      Parameters:
        `alInterval` - - time in milliseconds that the Server Execution Times Interval Service will wake up and record the interval values.

    - #### setServerDiagnosticsWaitTime

          void setServerDiagnosticsWaitTime(long alWaitTime)

      Change the wait time for the Diagnostic service. Diagnostics will log every alWaitTime ms.
      Parameters:
        `alWaitTime` - - time in milliseconds between diagnostic log entries
      See Also:
        `startServerDiagnosticService()`, `stopServerDiagnosticService()`, `isServerDiagnosticServiceRunning()`, `setDiagnosticsEnabled(boolean)`, `setServerDiagnosticsWaitTime(long)`

    - #### setIntervalProcessingEnabled

          void setIntervalProcessingEnabled(boolean abValue)

      Enable/Disable the Interval Time processing

    - #### setDiagnosticsEnabled

          void setDiagnosticsEnabled(boolean abValue)

      Enable/Disable server diagnostic data collection. Note this setting is independent of the Diagnostic service
      See Also:
        `startServerDiagnosticService()`, `stopServerDiagnosticService()`, `isServerDiagnosticServiceRunning()`, `setDiagnosticsEnabled(boolean)`, `setServerDiagnosticsWaitTime(long)`

    - #### startDynamicUpdateMonitoringService

          void startDynamicUpdateMonitoringService()

      Each Decision Service and each CDD loaded into the Server is monitored by a Maintenance thread at intervals of X where X is the number of milliseconds in the `CcConfig.jar|CcServer.properties| com.corticon.ccserver.dynamicUpdateMonitoringService.serviceIntervals`. If X=0, the Maintenance service is shutdown at server initialization time. The Maintenance thread can be started up and/or shutdown using `startDynamicUpdateMonitoringService/stopDynamicUpdateMonitoringService`. If any new CDD's are added or any existing CDDs are removed or updated, the Maintenance service detects the changes and dynamically refreshes the server to reflect the changes. If any of the CDDs fails to load, a message is printed to the console and the details of the failure are logged in the Corticon log file. Each CDD is updated as an atomic unit. If the update to any of the Decision Services within the CDD fail, the entire CDD update is rolled back and the pre-update state of the Server is restored.

      The Maintenance thread also monitors the .eds, erf, and ers files for the Decision Services already to detect possible updates. For Decision Services loaded with the Automatic Reload flag set to true, an update to the .eds, erf, and ers files results in a dynamic refresh of the Decision Service. If an error occurs during this process, the pre-refresh state of the Decision Service is restored.

      See Also:
        `stopDynamicUpdateMonitoringService()`, `loadFromCdd(String)`, `addDecisionService(String, String, boolean, int, int, String)`

    - #### startServerExecutionTimesIntervalService

          void startServerExecutionTimesIntervalService()

      Each Decision Service loaded into the Server is monitored by an Server Execution Times Interval Service thread at intervals of X that will keep track of total execution times, total execution count, and the average execution times for all executions that occurred during each interval. Also, the each Decision Service will maintain up to X intervals which is configurable with a property in CcServer.properties.
      See Also:
        `#getIntervalExecutionCounts(String)`, `#getIntervalExecutionCounts(String, int)`, `#getIntervalExecutionTimes(String)`, `#getIntervalExecutionTimes(String, int)`, `#getIntervalExecutionAverageTimes(String)`, `#getIntervalExecutionAverageTimes(String, int)`, `setServerExecutionTimesIntervalTime(long)`, `#clearAllCcServerIntervalValues()`, `#clearIntervalValues(String)`, `#clearIntervalValues(String, int)`, `stopServerExecutionTimesIntervalService()`

    - #### startServerResultsDistributionMonitoringService

          void startServerResultsDistributionMonitoringService()

      This will inform the Corticon Server to perform three separate tasks on the Decision Service Version for each execution.
      1. Analyze and record results
      The Corticon Server will analyze the results of each execution locating all instances of all Registered Attributes and record their values. The values are also categorized based on the buckets defined for the Registered Attributed based on the `astrBucketString` when defining a Registered Attribute.
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int , String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `stopServerResultsDistributionMonitoringService()`

    - #### startServerDiagnosticService

          void startServerDiagnosticService()

      This will start the Diagnostic Service. This service will log any diagnostic data collected (data collection if diagnostic data collection enabled) A message will be logged after configured wait time at log level DIAGNOSTIC If Log Level < DIAGNOSTIC the message will not be posted.
      See Also:
        `startServerDiagnosticService()`, `stopServerDiagnosticService()`, `isServerDiagnosticServiceRunning()`, `setDiagnosticsEnabled(boolean)`, `setServerDiagnosticsWaitTime(long)`

    - #### stopDynamicUpdateMonitoringService

          void stopDynamicUpdateMonitoringService()

      See `startDynamicUpdateMonitorService`.
      See Also:
        `startDynamicUpdateMonitoringService()`, `loadFromCdd(String)`, `addDecisionService(String, String, boolean, int, int, String)`

    - #### stopServerExecutionTimesIntervalService

          void stopServerExecutionTimesIntervalService()

      See `stopServerExecutionTimesIntervalService`.
      See Also:
        `#getIntervalExecutionCounts(String)`, `#getIntervalExecutionCounts(String, int)`, `#getIntervalExecutionTimes(String)`, `#getIntervalExecutionTimes(String, int)`, `#getIntervalExecutionAverageTimes(String)`, `#getIntervalExecutionAverageTimes(String, int)`, `setServerExecutionTimesIntervalTime(long)`, `#clearAllCcServerIntervalValues()`, `#clearIntervalValues(String)`, `#clearIntervalValues(String, int)`, `startServerExecutionTimesIntervalService()`

    - #### stopServerResultsDistributionMonitoringService

          void stopServerResultsDistributionMonitoringService()

      See `startServerResultsDistributionMonitoringService`.
      See Also:
        `registerTrackingAttribute(String, String, String)`, `registerTrackingAttribute(String, int , String, String)`, `deregisterTrackingAttribute(String, String)`, `deregisterTrackingAttribute(String, int, String)`, `getRegisteredTrackingAttributes(String)`, `getRegisteredTrackingAttributes(String, int)`, `getRegisteredTrackingAttributeCounts(String, String)`, `getRegisteredTrackingAttributeCounts(String, int, String)`, `startServerResultsDistributionMonitoringService()`

    - #### stopServerDiagnosticService

          void stopServerDiagnosticService()

      Start Diagnostic Logging Service
      See Also:
        `startServerDiagnosticService()`, `stopServerDiagnosticService()`, `isServerDiagnosticServiceRunning()`, `setDiagnosticsEnabled(boolean)`, `setServerDiagnosticsWaitTime(long)`

    - #### unzipDecisionServiceRuleAssets

          java.lang.String unzipDecisionServiceRuleAssets(java.lang.String astrDecisionServiceName)
                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                          CcServerFileOrDirNotFoundException,
                                                          CcServerLicenseViolationException,
                                                          CcServerInvalidArgumentException,
                                                          CcServerInvalidDecisionServiceException

      Invokes `unzipDecisionServiceRuleAssets(astrDecisionServiceName, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Returns:
        - String value, which is the path of the ERF file that was unzipped.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `unzipDecisionServiceRuleAssets(String, int)`

    - #### unzipDecisionServiceRuleAssets

          java.lang.String unzipDecisionServiceRuleAssets(java.lang.String astrDecisionServiceName,
                                                          int aiDecisionServiceMajorVersion)
                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                          CcServerFileOrDirNotFoundException,
                                                          CcServerLicenseViolationException,
                                                          CcServerInvalidArgumentException,
                                                          CcServerInvalidDecisionServiceException

      Invokes `unzipDecisionServiceRuleAssets(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Returns:
        - String value, which is the path of the ERF file that was unzipped.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `unzipDecisionServiceRuleAssets(String)`

    - #### unzipDecisionServiceRuleAssets

          java.lang.String unzipDecisionServiceRuleAssets(java.lang.String astrDecisionServiceName,
                                                          int aiDecisionServiceMajorVersion,
                                                          int aiDecisionServiceMinorVersion)
                                                   throws CcServerDecisionServiceNotRegisteredException,
                                                          CcServerFileOrDirNotFoundException,
                                                          CcServerLicenseViolationException,
                                                          CcServerInvalidArgumentException,
                                                          CcServerInvalidDecisionServiceException

      If the Decision Services was deployed as an EDS file, this method will unzip the Rule Assets inside the EDS file and put them under a unique directory under the ServerSandbox directory. This will allow the Server Console to read the information and display in the Rulesheet Editor. Returns an `String`, which is the path of the ERF file that was unzipped.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Returns:
        - String value, which is the path of the ERF file that was unzipped.
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerFileOrDirNotFoundException`
        `CcServerLicenseViolationException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`
      See Also:
        `unzipDecisionServiceRuleAssets(String)`

    - #### uploadRuleAssetFile

          void uploadRuleAssetFile(java.lang.String astrFullyQualifiedPath,
                                   java.lang.String astrFileContents)
                            throws CcServerCannotWriteToFileException,
                                   CcServerFileOrDirNotFoundException,
                                   CcServerInvalidArgumentException

      Allow the user to upload Rule Asset files up to the CcServer.
      Parameters:
        `astrFullyQualifiedPath` -
        `astrFileContents` -
      Throws:
        `CcServerCannotWriteToFileException`
        `CcServerFileOrDirNotFoundException`
        `CcServerInvalidArgumentException`

    - #### isCcServerRunning

          boolean isCcServerRunning()

      Allows a client application to ask the CcServer it is up and running.
      Returns:
        - boolean (true/false)

    - #### startBatchExecution

          java.lang.String startBatchExecution(org.json.JSONObject ajsonObjectBatchProcessingProperties)
                                        throws CcServerDecisionServiceNotRegisteredException,
                                               CcServerDecisionServiceQueryServiceLoadFailedException,
                                               CcServerInitializationInProgressException,
                                               CcServerInvalidArgumentException,
                                               CcServerLicenseViolationException

      This method will start a Batch Execution against a particular Decision Service based on the Batch Processing Properties outlined in the passed in JSONObject.
      Parameters:
        `ajsonObjectBatchProcessingProperties` - - JSONObject containing all necessary processing properties to run the desired Batch Execution.
      Returns:
        - String, which will be unique Id for the newly started Batch Execution
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceQueryServiceLoadFailedException`
        `CcServerInitializationInProgressException`
        `CcServerInvalidArgumentException`
        `CcServerLicenseViolationException`

    - #### stopBatchExecution

          void stopBatchExecution(java.lang.String astrBatchExecutionId)
                           throws CcServerDecisionServiceBatchNotCurrentlyRunningException,
                                  CcServerDecisionServiceNotRegisteredException,
                                  CcServerDecisionServiceLoadedFromCddException,
                                  CcServerInvalidArgumentException

      This method will stop a Batch Execution based on the passed in Id.
      Parameters:
        `astrBatchExecutionId` - - The Id of the desired Batch Execution to be stopped
      Throws:
        `CcServerDecisionServiceBatchNotCurrentlyRunningException`
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceLoadedFromCddException`
        `CcServerInvalidArgumentException`

    - #### getBatchExecutionIds

          java.util.List<java.lang.String> getBatchExecutionIds()

      This method will start a Batch Execution against a particular Decision Service based on the Batch Processing Properties outlined in the passed in JSONObject.
      Parameters:
        `ajsonObjectBatchProcessingProperties` - - JSONObject containing all necessary processing properties to run the desired Batch Execution.
      Returns:
        - List, which will contain all the Ids of the Batch Executions that are currently running or that have completed during the CcServer has been up and running.

    - #### getBatchExecutionDetails

          org.json.JSONObject getBatchExecutionDetails(java.lang.String astrBatchExecutionId)
                                                throws CcServerInvalidArgumentException

      This method will return a JSONObject that contains all the details the Batch Execution for the passed in Id.
      Parameters:
        `astrBatchExecutionId` - - The Id of the desired Batch Execution to be stopped
      Returns:
        - JSONObject, which contains all details related to the desired Batch Execution.
      Throws:
        `CcServerInvalidArgumentException`

    - #### reloadDecisionServiceQueryService

          void reloadDecisionServiceQueryService(java.lang.String astrDecisionServiceName)
                                          throws CcServerDecisionServiceNotRegisteredException,
                                                 CcServerDecisionServiceQueryServiceLoadFailedException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerInvalidDecisionServiceException

      Invokes `reloadDecisionServiceQueryService(astrDecisionServiceName, )`
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceQueryServiceLoadFailedException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### reloadDecisionServiceQueryService

          void reloadDecisionServiceQueryService(java.lang.String astrDecisionServiceName,
                                                 int aiDecisionServiceMajorVersion)
                                          throws CcServerDecisionServiceNotRegisteredException,
                                                 CcServerDecisionServiceQueryServiceLoadFailedException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerInvalidDecisionServiceException

      Invokes `reloadDecisionServiceQueryService(astrDecisionServiceName, aiDecisionServiceMajorVersion, )`
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceQueryServiceLoadFailedException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### reloadDecisionServiceQueryService

          void reloadDecisionServiceQueryService(java.lang.String astrDecisionServiceName,
                                                 int aiDecisionServiceMajorVersion,
                                                 int aiDecisionServiceMinorVersion)
                                          throws CcServerDecisionServiceNotRegisteredException,
                                                 CcServerDecisionServiceQueryServiceLoadFailedException,
                                                 CcServerInvalidArgumentException,
                                                 CcServerInvalidDecisionServiceException

      This method will reload the Query Service data from the Database for the desired Decision Service.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceQueryServiceLoadFailedException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

    - #### reloadAllDecisionServicesQueryService

          void reloadAllDecisionServicesQueryService()
                                              throws CcServerDecisionServiceNotRegisteredException,
                                                     CcServerDecisionServiceQueryServiceLoadFailedException,
                                                     CcServerInvalidArgumentException,
                                                     CcServerInvalidDecisionServiceException

      This method will go to each Decision Service and reload the Query Service data from the Database.
      Parameters:
        `astrDecisionServiceName` - - logical name of an existing Decision Service (and thus corresponding Corticon Engine pool).
        `aiDecisionServiceMajorVersion` - - a specific Major Version of the Decision Service to be modified
        `aiDecisionServiceMinorVersion` - - a specific Minor Version of the Decision Service to be modified
      Throws:
        `CcServerDecisionServiceNotRegisteredException`
        `CcServerDecisionServiceQueryServiceLoadFailedException`
        `CcServerInvalidArgumentException`
        `CcServerInvalidDecisionServiceException`

Copyright © 2005-2018 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.